2023-07-30  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-07-29  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-07-28  Jan Beulich  <jbeulich@suse.com>

	gas: amend X_unsigned uses
	PR gas/30688

	X_unsigned being clear does not indicate a negative number; it merely
	indicates a signed one (whose sign may still be clear). Amend two uses
	by an actual value check.

2023-07-28  Tsukasa OI  <research_trasio@irq.a4lg.com>

	RISC-V: Add actual 'Zvkt' extension support
	The 'Zvkt' extension is listed on the added extensions in the GNU Binutils
	version 2.41 (see binutils/NEWS).  However, the support of this extension
	was actually missing.

	This commit adds actual support of this extension and adds implications
	from 'Zvkn' and 'Zvks' superset extensions.

	bfd/ChangeLog:

		* elfxx-riscv.c (riscv_implicit_subsets) Add implications from
		'Zvkn' and 'Zvks'.  (riscv_supported_std_z_ext): Add 'Zvkt' to
		the supported extension list.

2023-07-28  YunQiang Su  <yunqiang.su@cipunited.com>

	MIPS: Support `-gnuabi64' target triplet suffix for 64-bit Linux targets
	Make the n64 ABI the default for 64-bit Linux targets specified with
	`-gnuabi64' suffix included in the target triplet, for configurations
	such as the Debian mips64el and mips64r6el ports.  Adjust testsuite
	configuration accordingly.

	There are the following regressions with the new target triplet:

	mips64-linux-gnuabi64  +FAIL: readelf -S bintest
	mips64-linux-gnuabi64  +FAIL: MIPS reloc estimation 1
	mips64el-linux-gnuabi64  +FAIL: readelf -S bintest
	mips64el-linux-gnuabi64  +FAIL: MIPS reloc estimation 1

	The `readelf' issue comes from a difference in section headers produced
	that the `binutils/testsuite/binutils-all/readelf.s-64' pattern template
	does not match.  While there has been a precedent it does not appear to
	me that there is a clear advantage from adding more and more variations
	to the template rather than forking the existing template into multiple
	ones for a more exact match.  So this is best deferred to a separate
	discussion.

	The MIPS reloc estimation issue is an actual bug in `objdump', which
	discards a number of trailing entries from output here for n64 composed
	relocations:

	DYNAMIC RELOCATION RECORDS
	OFFSET           TYPE              VALUE
	0000000000000000 R_MIPS_NONE       *ABS*
	0000000000000000 R_MIPS_NONE       *ABS*

	and consequently `ld/testsuite/ld-mips-elf/reloc-estimate-1.d' does not
	match even though ELF output produced is correct according to `readelf':

	Relocation section '.rel.dyn' at offset 0x10400 contains 2 entries:
	  Offset          Info           Type           Sym. Value    Sym. Name
	000000000000  000000000000 R_MIPS_NONE
	                    Type2: R_MIPS_NONE
	                    Type3: R_MIPS_NONE
	000000010000  000300001203 R_MIPS_REL32      0000000000010010 foo@@V2
	                    Type2: R_MIPS_64
	                    Type3: R_MIPS_NONE

	As a genuine bug this has to be handled separately.

	Co-Authored by: Maciej W. Rozycki <macro@orcam.me.uk>

		bfd/
		* config.bfd: Add `mips64*el-*-linux*-gnuabi64' and
		`mips64*-*-linux*-gnuabi64' targets.

		binutils/
		* testsuite/binutils-all/mips/mips.exp: Handle `*-*-*-gnuabi64'
		targets.
		* testsuite/binutils-all/objcopy.exp: Handle
		`mips64*-*-*-gnuabi64' targets.
		* testsuite/binutils-all/remove-relocs-01.d: Likewise.
		* testsuite/binutils-all/remove-relocs-04.d: Likewise.
		* testsuite/binutils-all/remove-relocs-05.d: Likewise.
		* testsuite/binutils-all/remove-relocs-06.d: Likewise.

		gas/
		* configure.ac: Handle `mips64*-linux-gnuabi64' targets.
		* configure: Regenerate.
		* testsuite/gas/mips/compact-eh-eb-7.d: Handle
		`mips64*-*-*-gnuabi64' targets.
		* testsuite/gas/mips/compact-eh-el-7.d: Likewise.

		ld/
		* configure.tgt: Add `mips64*el-*-linux-gnuabi64' and
		`mips64*-*-linux-gnuabi64' targets.
		* testsuite/ld-undefined/undefined.exp: Handle
		`mips64*-*-*-gnuabi64' targets.
		* testsuite/ld-mips-elf/attr-gnu-4-10.d: Likewise.
		* testsuite/ld-mips-elf/compact-eh6.d: Likewise.
		* testsuite/ld-mips-elf/mips-elf.exp: Handle `*-*-*-gnuabi64'
		targets.

	(cherry picked from commit 29c108c9610640439daa5244a573348b7c47d994)

2023-07-28  YunQiang Su  <yunqiang.su@cipunited.com>

	MIPS/GAS/testsuite: Fix n64 compact EH failures
	Expect a `.MIPS.options' section alternatively to `.reginfo' and ignore
	contents of either as irrelevant for all the affected compact EH tests,
	removing these regressions:

	mips64-openbsd  -FAIL: Compact EH EB #1 with personality ID and FDE data
	mips64-openbsd  -FAIL: Compact EH EB #2 with personality routine and FDE data
	mips64-openbsd  -FAIL: Compact EH EB #3 with personality id and large FDE data
	mips64-openbsd  -FAIL: Compact EH EB #4 with personality id, FDE data and LSDA
	mips64-openbsd  -FAIL: Compact EH EB #5 with personality routine, FDE data and LSDA
	mips64-openbsd  -FAIL: Compact EH EB #6 with personality id, LSDA and large FDE data
	mips64-openbsd  -FAIL: Compact EH EL #1 with personality ID and FDE data
	mips64-openbsd  -FAIL: Compact EH EL #2 with personality routine and FDE data
	mips64-openbsd  -FAIL: Compact EH EL #3 with personality id and large FDE data
	mips64-openbsd  -FAIL: Compact EH EL #4 with personality id, FDE data and LSDA
	mips64-openbsd  -FAIL: Compact EH EL #5 with personality routine, FDE data and LSDA
	mips64-openbsd  -FAIL: Compact EH EL #6 with personality id, LSDA and large FDE data
	mips64el-openbsd  -FAIL: Compact EH EB #1 with personality ID and FDE data
	mips64el-openbsd  -FAIL: Compact EH EB #2 with personality routine and FDE data
	mips64el-openbsd  -FAIL: Compact EH EB #3 with personality id and large FDE data
	mips64el-openbsd  -FAIL: Compact EH EB #4 with personality id, FDE data and LSDA
	mips64el-openbsd  -FAIL: Compact EH EB #5 with personality routine, FDE data and LSDA
	mips64el-openbsd  -FAIL: Compact EH EB #6 with personality id, LSDA and large FDE data
	mips64el-openbsd  -FAIL: Compact EH EL #1 with personality ID and FDE data
	mips64el-openbsd  -FAIL: Compact EH EL #2 with personality routine and FDE data
	mips64el-openbsd  -FAIL: Compact EH EL #3 with personality id and large FDE data
	mips64el-openbsd  -FAIL: Compact EH EL #4 with personality id, FDE data and LSDA
	mips64el-openbsd  -FAIL: Compact EH EL #5 with personality routine, FDE data and LSDA
	mips64el-openbsd  -FAIL: Compact EH EL #6 with personality id, LSDA and large FDE data

	Co-Authored-By: Maciej W. Rozycki <macro@orcam.me.uk>

		gas/
		* testsuite/gas/mips/compact-eh-eb-1.d: Accept `.MIPS.options'
		section as an alternative to `.reginfo' and ignore contents of
		either.
		* testsuite/gas/mips/compact-eh-eb-2.d: Likewise.
		* testsuite/gas/mips/compact-eh-eb-3.d: Likewise.
		* testsuite/gas/mips/compact-eh-eb-4.d: Likewise.
		* testsuite/gas/mips/compact-eh-eb-5.d: Likewise.
		* testsuite/gas/mips/compact-eh-eb-6.d: Likewise.
		* testsuite/gas/mips/compact-eh-el-1.d: Likewise.
		* testsuite/gas/mips/compact-eh-el-2.d: Likewise.
		* testsuite/gas/mips/compact-eh-el-3.d: Likewise.
		* testsuite/gas/mips/compact-eh-el-4.d: Likewise.
		* testsuite/gas/mips/compact-eh-el-5.d: Likewise.
		* testsuite/gas/mips/compact-eh-el-6.d: Likewise.

	(cherry picked from commit 316be2b229f5bd07ebef48fd1d7b8cb103e4d815)

2023-07-28  YunQiang Su  <yunqiang.su@cipunited.com>

	testsuite: Handle composed R_MIPS_NONE relocations
	MIPS n64 ABI has a peculiarity where all relocations are composed of
	three, with subsequent relocation types set to R_MIPS_NONE if further
	calculation is not required.  Example output produced by `readelf' and
	`objdump' for such relocations is:

	  Offset          Info           Type           Sym. Value    Sym. Name + Addend
	000000000000  000800000002 R_MIPS_32         0000000000000000 foo + 0
	                    Type2: R_MIPS_NONE
	                    Type3: R_MIPS_NONE

	and:

	OFFSET           TYPE              VALUE
	0000000000000000 R_MIPS_32         foo
	0000000000000000 R_MIPS_NONE       *ABS*
	0000000000000000 R_MIPS_NONE       *ABS*

	respectively.  The presence of these extra R_MIPS_NONE entries is not
	relevant for generic or even some MIPS tests, so optionally match them
	with the respective dump patterns, also discarding `xfail' annotation
	for MIPS/OpenBSD targets from gas/elf/missing-build-notes.d, removing
	these regressions:

	mips64-openbsd  -FAIL: readelf -r bintest
	mips64-openbsd  -FAIL: forward expression
	mips64-openbsd  -FAIL: assignment tests
	mips64-openbsd  -FAIL: gas/all/none
	mips64-openbsd  -XFAIL: gas/elf/missing-build-notes
	mips64-openbsd  -FAIL: macro test 2
	mips64-openbsd  -FAIL: macro irp
	mips64-openbsd  -FAIL: macro rept
	mips64-openbsd  -FAIL: nested irp/irpc/rept
	mips64-openbsd  -FAIL: macro vararg
	mips64-openbsd  -FAIL: mips jalx
	mips64-openbsd  -FAIL: ST Microelectronics Loongson-2F workarounds of Jump Instruction issue
	mips64el-openbsd  -FAIL: readelf -r bintest
	mips64el-openbsd  -FAIL: forward expression
	mips64el-openbsd  -FAIL: assignment tests
	mips64el-openbsd  -FAIL: gas/all/none
	mips64el-openbsd  -XFAIL: gas/elf/missing-build-notes
	mips64el-openbsd  -FAIL: macro test 2
	mips64el-openbsd  -FAIL: macro irp
	mips64el-openbsd  -FAIL: macro rept
	mips64el-openbsd  -FAIL: nested irp/irpc/rept
	mips64el-openbsd  -FAIL: macro vararg
	mips64el-openbsd  -FAIL: mips jalx
	mips64el-openbsd  -FAIL: ST Microelectronics Loongson-2F workarounds of Jump Instruction issue

	Co-Authored-By: Maciej W. Rozycki <macro@orcam.me.uk>

		binutils/
		* testsuite/binutils-all/readelf.r-64: Optionally match extra
		R_MIPS_NONE pairs.

		gas/
		* testsuite/gas/all/assign.d: Optionally match extra
		R_MIPS_NONE pairs.
		* testsuite/gas/all/fwdexp.d: Likewise.
		* testsuite/gas/all/none.d: Likewise.
		* testsuite/gas/macros/irp.d: Likewise.
		* testsuite/gas/macros/repeat.d: Likewise.
		* testsuite/gas/macros/rept.d: Likewise.
		* testsuite/gas/macros/test2.d: Likewise.
		* testsuite/gas/macros/vararg.d: Likewise.
		* testsuite/gas/mips/compact-eh-eb-1.d: Likewise.
		* testsuite/gas/mips/compact-eh-eb-2.d: Likewise.
		* testsuite/gas/mips/compact-eh-eb-3.d: Likewise.
		* testsuite/gas/mips/compact-eh-eb-4.d: Likewise.
		* testsuite/gas/mips/compact-eh-eb-5.d: Likewise.
		* testsuite/gas/mips/compact-eh-eb-6.d: Likewise.
		* testsuite/gas/mips/compact-eh-el-1.d: Likewise.
		* testsuite/gas/mips/compact-eh-el-2.d: Likewise.
		* testsuite/gas/mips/compact-eh-el-3.d: Likewise.
		* testsuite/gas/mips/compact-eh-el-4.d: Likewise.
		* testsuite/gas/mips/compact-eh-el-5.d: Likewise.
		* testsuite/gas/mips/compact-eh-el-6.d: Likewise.
		* testsuite/gas/mips/loongson-2f-3.d: Likewise.
		* testsuite/gas/mips/mips-jalx.d: Likewise.
		* testsuite/gas/elf/missing-build-notes.d: Likewise.  Remove
		the `xfail' tag.

		ld/
		* testsuite/ld-mips-elf/reloc-estimate-1.d: Optionally match
		extra R_MIPS_NONE pairs.

	(cherry picked from commit ed4dca900c0dbc1317917cb289255d2f8d03f732)

2023-07-28  YunQiang Su  <yunqiang.su@cipunited.com>

	MIPS/testsuite: Handle 64-bit addresses
	Several MIPS test cases are suitable for the n64 ABI if not for the
	extra leading zeros or spaces in addresses not handled by dump patterns.
	Match the characters then, removing these regressions:

	mips64-openbsd  -FAIL: .set arch=FOO
	mips64-openbsd  -FAIL: ST Microelectronics Loongson-2F workarounds of nop issue
	mips64-openbsd  -FAIL: MIPS DSP ASE for MIPS64
	mips64-openbsd  -FAIL: gas/mips/align2
	mips64-openbsd  -FAIL: gas/mips/align2-el
	mips64-openbsd  -FAIL: Locally-resolvable PC-relative code references
	mips64-openbsd  -FAIL: MIPS jalx-1
	mips64-openbsd  -FAIL: JAL overflow 2
	mips64el-openbsd  -FAIL: .set arch=FOO
	mips64el-openbsd  -FAIL: ST Microelectronics Loongson-2F workarounds of nop issue
	mips64el-openbsd  -FAIL: MIPS DSP ASE for MIPS64
	mips64el-openbsd  -FAIL: gas/mips/align2
	mips64el-openbsd  -FAIL: gas/mips/align2-el
	mips64el-openbsd  -FAIL: Locally-resolvable PC-relative code references
	mips64el-openbsd  -FAIL: MIPS jalx-1
	mips64el-openbsd  -FAIL: JAL overflow 2

	Co-Authored-By: Maciej W. Rozycki <macro@orcam.me.uk>

		gas/
		* testsuite/gas/mips/align2-el.d: Match extra leading zeros
		with addresses.
		* testsuite/gas/mips/align2.d: Likewise.
		* testsuite/gas/mips/compact-eh-eb-1.d: Likewise.
		* testsuite/gas/mips/compact-eh-eb-2.d: Likewise.
		* testsuite/gas/mips/compact-eh-eb-3.d: Likewise.
		* testsuite/gas/mips/compact-eh-eb-4.d: Likewise.
		* testsuite/gas/mips/compact-eh-eb-5.d: Likewise.
		* testsuite/gas/mips/compact-eh-eb-6.d: Likewise.
		* testsuite/gas/mips/compact-eh-el-1.d: Likewise.
		* testsuite/gas/mips/compact-eh-el-2.d: Likewise.
		* testsuite/gas/mips/compact-eh-el-3.d: Likewise.
		* testsuite/gas/mips/compact-eh-el-4.d: Likewise.
		* testsuite/gas/mips/compact-eh-el-5.d: Likewise.
		* testsuite/gas/mips/compact-eh-el-6.d: Likewise.
		* testsuite/gas/mips/loongson-2f-2.d: Likewise.
		* testsuite/gas/mips/loongson-2f-3.d: Likewise.
		* testsuite/gas/mips/mips-jalx.d: Likewise.
		* testsuite/gas/mips/mips64-dsp.d: Likewise.
		* testsuite/gas/mips/pcrel-1.d: Likewise.
		* testsuite/gas/mips/set-arch.d: Likewise.

		ld/
		* testsuite/ld-mips-elf/jaloverflow-2.d: Match extra leading
		zeros and spaces with addresses as appropriate.
		* testsuite/ld-mips-elf/jalx-1.d: Likewise.
		* testsuite/ld-mips-elf/reloc-estimate-1.d: Likewise.

	(cherry picked from commit ec76a6172f7b6d61f7d76c2bcf766122132116b8)

2023-07-28  YunQiang Su  <yunqiang.su@cipunited.com>

	testsuite: Also discard the `.MIPS.options' section
	Also discard the `.MIPS.options' section, used with n64 MIPS binaries,
	along with similar other MIPS sections (`.reginfo', `.MIPS.abiflags')
	not relevant for the test cases concerned, fixing these regressions:

	mips64-openbsd  -FAIL: ld-elf/group3a
	mips64-openbsd  -FAIL: ld-elf/group3b
	mips64-openbsd  -FAIL: Place orphan sections (map file check)
	mips64-openbsd  -FAIL: ld-elf/orphan-region
	mips64-openbsd  -FAIL: ld-elf/orphan
	mips64-openbsd  -FAIL: overlay size (map file check)
	mips64-openbsd  -FAIL: overlay size
	mips64el-openbsd  -FAIL: ld-elf/group3a
	mips64el-openbsd  -FAIL: ld-elf/group3b
	mips64el-openbsd  -FAIL: Place orphan sections (map file check)
	mips64el-openbsd  -FAIL: ld-elf/orphan-region
	mips64el-openbsd  -FAIL: ld-elf/orphan
	mips64el-openbsd  -FAIL: overlay size (map file check)
	mips64el-openbsd  -FAIL: overlay size

	Co-Authored-By: Maciej W. Rozycki <macro@orcam.me.uk>

		binutils/
		* testsuite/binutils-all/strip-3.d: Add `-R .MIPS.options' to
		the `strip' tag.

		ld/
		* testsuite/ld-elf/group.ld: Also discard `.MIPS.options'.
		* testsuite/ld-elf/orphan-region.ld: Likewise.
		* testsuite/ld-elf/orphan.ld: Likewise.
		* testsuite/ld-mips-elf/got-page-1.ld: Likewise.
		* testsuite/ld-scripts/overlay-size.t: Likewise.

	(cherry picked from commit 60ec8306db150e687fc05870949056bae6c8d635)

2023-07-28  Maciej W. Rozycki  <macro@orcam.me.uk>

	MIPS/LD/testsuite: Fix MIPS16 interlinking test IRIX 6 regressions
	IRIX 6 does not have MIPS16 stub section support in its n32 linker
	scripts, causing such input sections to be propagated to the respective
	output sections rather than `.text', causing dump pattern mismatches.

	Expect IRIX 6 to fail with n32 testing then, removing this regression:

	mips-sgi-irix6  -FAIL: MIPS16 interlinking for local functions 1 (n32)

	We may choose to update IRIX 6 n32 linker scripts sometime, as it seems
	a harmless change.

		ld/
		* testsuite/ld-mips-elf/mips-elf.exp: Expect IRIX 6 to fail with
		n32 `mips16-local-stubs-1' testing.

	(cherry picked from commit ec3205bbc6f2018c9907bfd6e6c6ae51a2e01432)

2023-07-28  YunQiang Su  <yunqiang.su@cipunited.com>

	MIPS/LD/testsuite: Fix MIPS16 interlinking test n64 regressions
	The MIPS16 interlinking test for local functions expects to be assembled
	with 32-bit addressing, otherwise causing assembly warnings:

	.../ld/testsuite/ld-mips-elf/mips16-local-stubs-1.s: Assembler messages:
	.../ld/testsuite/ld-mips-elf/mips16-local-stubs-1.s:16: Warning: la used to load 64-bit address; recommend using dla instead

	Use the per-ABI framework then to run the test explicitly for o32 and
	n32 ABIs only, replacing the `-mips4' option from the `as' tag with
	`.module mips4' pseudo-op within the source itself so as to avoid
	assembly errors:

	Assembler messages:
	Error: -mips4 conflicts with the other architecture options, which imply -mips3

	with n32 testing for some targets, and ultimately removing these
	regressions:

	mips64-openbsd  -FAIL: MIPS16 interlinking for local functions 1
	mips64el-openbsd  -FAIL: MIPS16 interlinking for local functions 1

	Co-Authored-By: Maciej W. Rozycki <macro@orcam.me.uk>

		ld/
		* testsuite/ld-mips-elf/mips16-local-stubs-1.d: Remove `-mips4'
		from the `as' tag.
		* testsuite/ld-mips-elf/mips16-local-stubs-1.s: Add `.module
		mips4'.
		* testsuite/ld-mips-elf/mips-elf.exp: Run `mips16-local-stubs-1'
		for o32 and n32 ABIs only.

	(cherry picked from commit 3c8ed624caf3317b2155a8c00a7af6a8bb6a3c10)

2023-07-28  YunQiang Su  <yunqiang.su@cipunited.com>

	MIPS/GAS/testsuite: Force o32 for tests expecting 32-bit addressing
	A few GAS tests expect to be assembled with 32-bit addressing, otherwise
	causing an assembly warning:

	.../gas/testsuite/gas/mips/fix-rm7000-2.s:11: Warning: la used to load 64-bit address; recommend using dla instead

	or pattern dump mismatches against 32-bit address calculations, however
	these tests do not enforce their expectation in any.  For none of them
	the specific ABI used is of any relevance however, so select the o32 ABI
	unconditionally, removing these failures with OpenBSD targets:

	mips64-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (micromips)
	mips64-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (mips3)
	mips64-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (mips4)
	mips64-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (mips5)
	mips64-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (mips64)
	mips64-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (mips64r2)
	mips64-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (mips64r3)
	mips64-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (mips64r5)
	mips64-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (octeon)
	mips64-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (octeon2)
	mips64-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (octeon3)
	mips64-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (octeonp)
	mips64-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (r4000)
	mips64-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (sb1)
	mips64-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (vr5400)
	mips64-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (xlr)
	mips64-openbsd  -FAIL: MIPS-OCTEON octeon_saa_saad (octeon2)
	mips64-openbsd  -FAIL: MIPS-OCTEON octeon_saa_saad (octeon3)
	mips64-openbsd  -FAIL: MIPS-OCTEON octeon_saa_saad (octeonp)
	mips64-openbsd  -FAIL: Full MIPS R5900
	mips64-openbsd  -FAIL: MIPS R5900 VU0
	mips64-openbsd  -FAIL: Paired LL/SC for mips64r6 (mips64r6)
	mips64el-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (micromips)
	mips64el-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (mips3)
	mips64el-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (mips4)
	mips64el-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (mips5)
	mips64el-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (mips64)
	mips64el-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (mips64r2)
	mips64el-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (mips64r3)
	mips64el-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (mips64r5)
	mips64el-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (octeon)
	mips64el-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (octeon2)
	mips64el-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (octeon3)
	mips64el-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (octeonp)
	mips64el-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (r4000)
	mips64el-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (sb1)
	mips64el-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (vr5400)
	mips64el-openbsd  -FAIL: MIPS RM7000 workarounds test 2 (xlr)
	mips64el-openbsd  -FAIL: MIPS-OCTEON octeon_saa_saad (octeon2)
	mips64el-openbsd  -FAIL: MIPS-OCTEON octeon_saa_saad (octeon3)
	mips64el-openbsd  -FAIL: MIPS-OCTEON octeon_saa_saad (octeonp)
	mips64el-openbsd  -FAIL: Full MIPS R5900
	mips64el-openbsd  -FAIL: MIPS R5900 VU0
	mips64el-openbsd  -FAIL: Paired LL/SC for mips64r6 (mips64r6)

	Co-Authored-By: Maciej W. Rozycki <macro@orcam.me.uk>

		gas/
		* testsuite/gas/mips/fix-rm7000-2.d: Add `-32' to the `as' tag.
		* testsuite/gas/mips/micromips@fix-rm7000-2.d: Likewise.
		* testsuite/gas/mips/r5900-full.d: Likewise.
		* testsuite/gas/mips/r5900-vu0.d: Likewise.
		* testsuite/gas/mips/llpscp-64.d: Add `as' tag with `-32'.
		* testsuite/gas/mips/octeon-saa-saad.d: Likewise.

	(cherry picked from commit ce0077a2e724146285c282037a41c68de6c0608d)

2023-07-28  Maciej W. Rozycki  <macro@orcam.me.uk>

	MIPS/LD/testsuite: Run `got-dump-1' for o32/n32 ABIs
	The `got-dump-1' test case uses 32-bit addressing, so it makes no sense
	to run it with the n64 ABI.  And there is a corresponding `got-dump-2'
	test already for the n64 ABI.

	Use the per-ABI framework then to run the `got-dump-1' test explicitly
	for o32 and n32 ABIs only.

		ld/
		* testsuite/ld-mips-elf/mips-elf.exp: Run `got-dump-1' for o32
		and n32 ABIs only.

	(cherry picked from commit 70116eb5e6c74f9b526b1fec4e39f11238cb6a34)

2023-07-28  Maciej W. Rozycki  <macro@orcam.me.uk>

	MIPS/LD/testsuite: Fix `attr-gnu-4-10' failures with OpenBSD targets
	OpenBSD targets produce ELF64 files while the pattern dump expects ELF32
	output and specific header sizes.  Disable it for `mips64*-*-openbsd*'
	for these targets then, removing these failures:

	mips64-openbsd  -FAIL: ld-mips-elf/attr-gnu-4-10
	mips64el-openbsd  -FAIL: ld-mips-elf/attr-gnu-4-10

		ld/
		* testsuite/ld-mips-elf/attr-gnu-4-10.d: Add `notarget' tag with
		`mips64*-*-openbsd*'.

	(cherry picked from commit b50c220d179d239eacd7d7e120f7466e2ea47170)

2023-07-28  Maciej W. Rozycki  <macro@orcam.me.uk>

	MIPS/LD/testsuite: Fix `attr-gnu-4-10' failures with IRIX targets
	IRIX targets do not enable the production of a `.pdr' section in GAS by
	default, which causes a failure with the `attr-gnu-4-10' test case due
	to a difference resulting in the number and indices of sections produced
	in linker output.

	As the presence or absence of this section is not relevant to this test
	case, just enable it unconditionally, fixing these regressions:

	mips-sgi-irix5  -FAIL: ld-mips-elf/attr-gnu-4-10
	mips-sgi-irix6  -FAIL: ld-mips-elf/attr-gnu-4-10

		ld/
		* testsuite/ld-mips-elf/attr-gnu-4-10.d: Add `as' tag with
		`-mpdr'.

	(cherry picked from commit d4e5281f03764a985b1229e9417a4fd1bebcea17)

2023-07-28  Maciej W. Rozycki  <macro@orcam.me.uk>

	MIPS/LD/testsuite: Fix JALR relaxation test failure with IRIX 6
	The `mips-sgi-irix6' target only supports IRIX linker emulations, but
	most JALR relaxation tests request the relevant traditional emulation
	instead, causing a link failure:

	./ld-new: unrecognised emulation mode: elf32btsmipn32
	Supported emulations: elf32bmipn32 elf32bsmip elf64bmip

	This is clearly an omission from the conversion to use the per-ABI
	framework made with commit 78da84f99405 ("MIPS/LD/testsuite: Correct
	mips-elf.exp test ABI/emul/endian arrangement").  These tests are also
	endianness agnostic, which was missed in the conversion as well.

	Remove the unnecessary explicit ABI and endianness options then and rely
	on the per-ABI framework to get things right, removing this regression:

	mips-sgi-irix6  -FAIL: MIPS relax-jalr-shared n32

		ld/
		* testsuite/ld-mips-elf/relax-jalr-n32-shared.d: Remove flags
		related to ABI and endianness selection from the `as' and `ld'
		tags.
		* testsuite/ld-mips-elf/relax-jalr-n64.d: Likewise.
		* testsuite/ld-mips-elf/relax-jalr-n64-shared.d: Likewise.
		* testsuite/ld-mips-elf/mips-elf.exp: Remove `as' and `ld' tag
		additions from the invocation of JALR relaxation tests.

	(cherry picked from commit 94052ee4ccf0ac64b5f55da59878f13d567ef3cf)

2023-07-28  Maciej W. Rozycki  <macro@orcam.me.uk>

	MIPS/LD/testsuite: Fix unaligned JALX failures with OpenBSD targets
	There are only n64 linker emulations included with `mips64*-*-openbsd*'
	targets, however the unaligned JALX tests insist on running across all
	targets and force the n32 ABI, causing link errors with the targets
	concerned, e.g.:

	./ld-new: tmpdir/unaligned-jalx-0.o: ABI is incompatible with that of the selected emulation
	./ld-new: failed to merge target specific data of file tmpdir/unaligned-jalx-0.o
	./ld-new: tmpdir/unaligned-insn.o: ABI is incompatible with that of the selected emulation
	./ld-new: failed to merge target specific data of file tmpdir/unaligned-insn.o

	Convert the tests then to use the per-ABI framework and run them for the
	o32 and n32 ABIs, removing these regressions:

	mips64-openbsd  -FAIL: MIPS JALX to unaligned symbol 0
	mips64-openbsd  -FAIL: MIPS JALX to unaligned symbol 1
	mips64-openbsd  -FAIL: MIPS JALX to unaligned symbol 2
	mips64-openbsd  -FAIL: MIPS JALX to unaligned symbol 3
	mips64-openbsd  -FAIL: MIPS16 JALX to unaligned symbol 0
	mips64-openbsd  -FAIL: MIPS16 JALX to unaligned symbol 1
	mips64-openbsd  -FAIL: microMIPS JALX to unaligned symbol 0
	mips64-openbsd  -FAIL: microMIPS JALX to unaligned symbol 1
	mips64el-openbsd  -FAIL: MIPS JALX to unaligned symbol 0
	mips64el-openbsd  -FAIL: MIPS JALX to unaligned symbol 1
	mips64el-openbsd  -FAIL: MIPS JALX to unaligned symbol 2
	mips64el-openbsd  -FAIL: MIPS JALX to unaligned symbol 3
	mips64el-openbsd  -FAIL: MIPS16 JALX to unaligned symbol 0
	mips64el-openbsd  -FAIL: MIPS16 JALX to unaligned symbol 1
	mips64el-openbsd  -FAIL: microMIPS JALX to unaligned symbol 0
	mips64el-openbsd  -FAIL: microMIPS JALX to unaligned symbol 1

	Similar tests for the n64 ABI can be added separately, using suitable
	dump patterns.

		ld/
		* testsuite/ld-mips-elf/unaligned-jalx-0.d: Remove `-32' from
		the `as' tag.
		* testsuite/ld-mips-elf/unaligned-jalx-1.d: Likewise.
		* testsuite/ld-mips-elf/unaligned-jalx-2.d: Likewise.
		* testsuite/ld-mips-elf/unaligned-jalx-3.d: Likewise.
		* testsuite/ld-mips-elf/unaligned-jalx-mips16-0.d: Likewise.
		* testsuite/ld-mips-elf/unaligned-jalx-mips16-1.d: Likewise.
		* testsuite/ld-mips-elf/unaligned-jalx-micromips-0.d: Likewise.
		* testsuite/ld-mips-elf/unaligned-jalx-micromips-1.d: Likewise.
		* testsuite/ld-mips-elf/mips-elf.exp: Run unaligned JALX tests
		with `run_dump_test_o32' and `run_dump_test_n32' rather than
		`run_dump_test'.

	(cherry picked from commit 67e789ae32fadc540c10839f08ad53ff01e2d732)

2023-07-28  Maciej W. Rozycki  <macro@orcam.me.uk>

	MIPS/GAS/testsuite: Disable compact EH #7 tests with OpenBSD targets
	Compact EH #7 tests use output templates that are not suitable for the
	n64 ABI, which `mips64*-*-openbsd*' targets use by default, because the
	contents of the sections examined are expected to be differnt.  Disable
	the tests then, removing these regressions:

	mips64-openbsd  -FAIL: Compact EH EB #7 with personality id and fallback FDE
	mips64-openbsd  -FAIL: Compact EH EL #7 with personality id and fallback FDE
	mips64el-openbsd  -FAIL: Compact EH EB #7 with personality id and fallback FDE
	mips64el-openbsd  -FAIL: Compact EH EL #7 with personality id and fallback FDE

	Suitable corresponding tests for the n64 ABI can be added separately.

		gas/
		* testsuite/gas/mips/compact-eh-eb-7.d: Exclude for
		`mips64*-*-openbsd*'.
		* testsuite/gas/mips/compact-eh-el-7.d: Likewise.

	(cherry picked from commit 2b4a60ab59f14a8fc1039c0cea41d22674447c1e)

2023-07-28  YunQiang Su  <yunqiang.su@cipunited.com>

	MIPS/LD: Include n64 `.interp' with INITIAL_READONLY_SECTIONS
	In ld/emulparams/elf64bmip-defs.sh there is no explicit handling of the
	`.interp' section, which causes it to be positioned in output at an odd
	place.

	Let's include it with INITIAL_READONLY_SECTIONS, just like o32/n32 do,
	fixing a regression from commit 5a8e7be242f3 ("INITIAL_READONLY_SECTIONS
	in elf.sc"), where the handling of n64 was missed due to an unfortunate
	sequence of events where ld/emulparams/elf64bmip-defs.sh was only added
	with commit 94bb04b3c611 ("Use .reginfo rather than .MIPS.options in n32
	linker scripts") the day before.

	Add test cases covering section ordering across the three ABIs.  This
	change also fixes ld/pr23658-2:

	FAIL: Build pr23658-2

	Co-Authored-By: Maciej W. Rozycki <macro@orcam.me.uk>

	ld/ChangeLog:
		* emulparams/elf64bmip-defs.sh: Include `.interp' with
		INITIAL_READONLY_SECTIONS.
		* testsuite/ld-mips-elf/pie-n64.d: Adjust addresses.
		* testsuite/ld-mips-elf/sections-1-o32.rd: New test.
		* testsuite/ld-mips-elf/sections-1-o32t.rd: New test.
		* testsuite/ld-mips-elf/sections-1-n32.rd: New test.
		* testsuite/ld-mips-elf/sections-1-n32t.rd: New test.
		* testsuite/ld-mips-elf/sections-1-n32p.rd: New test.
		* testsuite/ld-mips-elf/sections-1-n64.rd: New test.
		* testsuite/ld-mips-elf/sections-1-n64t.rd: New test.
		* testsuite/ld-mips-elf/sections-2-o32.rd: New test.
		* testsuite/ld-mips-elf/sections-2-o32t.rd: New test.
		* testsuite/ld-mips-elf/sections-2-n32.rd: New test.
		* testsuite/ld-mips-elf/sections-2-n32t.rd: New test.
		* testsuite/ld-mips-elf/sections-2-n32p.rd: New test.
		* testsuite/ld-mips-elf/sections-2-n64.rd: New test.
		* testsuite/ld-mips-elf/sections-2-n64t.rd: New test.
		* testsuite/ld-mips-elf/sections.s: New test source.
		* testsuite/ld-mips-elf/mips-elf.exp: Run the new tests.

	(cherry picked from commit f625926792da741ab196ef71c16e481331965b6f)

2023-07-28  Maciej W. Rozycki  <macro@orcam.me.uk>

	Revert "MIPS: support mips*64 as CPU and gnuabi64 as ABI"
	This reverts commit 32f1c80375ebe8ad25d9805ee5889f0006c51e59.  It had
	two unrelated changes lumped together, one of which changed the meaning
	of the `mipsisa64*-*-linux*' target triplets, which was not properly
	evaluated.

	(cherry picked from commit cc66ad2d2a63cec2eaafd7bbc6a9204490816c0b)

2023-07-28  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-07-27  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-07-26  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-07-25  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-07-24  mengqinggang  <mengqinggang@loongson.cn>

	LoongArch: Fix immediate overflow check bug
	  * elfnn-loongarch.c (RELOCATE_CALC_PC32_HI20): Redefined.
	  (RELOCATE_CALC_PC64_HI32): Redefined.
	  * elfxx-loongarch.c (reloc_bits_pcrel20_s2): Delete.
	  (reloc_bits_b16): Delete.
	  (reloc_bits_b21): Delete.
	  (reloc_bits_b26): Delete.
	  (reloc_sign_bits): New.

2023-07-24  Nick Clifton  <nickc@redhat.com>

	Updated Serbian translations for bfd, gold and opcodes

2023-07-24  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-07-23  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-07-22  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-07-21  Alan Modra  <amodra@gmail.com>

	MIPS: Don't move __gnu_lto_slim to .scommon
		* elfxx-mips.c (_bfd_mips_elf_symbol_processing): Don't treat
		__gnu_lto_slim as SHN_MIPS_SCOMMON.
		(_bfd_mips_elf_add_symbol_hook): Likewise.

2023-07-21  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-07-20  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-07-19  Nick Clifton  <nickc@redhat.com>

	merged

	Updated Romanian translation for the opcodes directory

	Updated Romainian translation for the opcodes directory

2023-07-19  Alan Modra  <amodra@gmail.com>

	[GOLD, PowerPC64] Debug info relocation overflow
	It is possible to build huge binaries on powerpc64, where 32-bit
	addresses in debug info are insufficient to descibe locations in the
	binary.  Help out the user, and only warn about debug overflows.

		* powerpc.cc (Target_powerpc::Relocate::relocate): Warn on
		relocation overflows in debug info.

	(cherry picked from commit 03c02b696e90714a0ae2c0200d3c65cfffcaa1ee)

2023-07-19  Alan Modra  <amodra@gmail.com>

	PR10957, Missing option to really print section+offset
	Many of the reloc error messages have already been converted from
	using %C to using %H in ld.bfd, to print section+offset as well as
	file/line/function.  This catches a few remaining, and changes gold to
	do the same.

		PR 10957
	bfd/
		* elf32-sh.c (sh_elf_relocate_section): Use %H in error messages.
	gold/
		* object.cc (Relocate_info::location): Always report section+offset.
		* testsuite/debug_msg.sh: Adjust to suit.
		* testsuite/x32_overflow_pc32.sh: Likewise.
		* testsuite/x86_64_overflow_pc32.sh: Likewise.
	ld/
		* emultempl/pe.em (read_addend): Use %H in error message.
		* emultempl/pep.em (read_addend): Likewise.
		* ldcref.c (check_reloc_refs): Likewise.
		* ldmain.c (warning_find_reloc, undefined_symbol): Likewise.
		* pe-dll.c (pe_create_import_fixup): Likewise.
		* testsuite/ld-cris/undef2.d: Adjust expected output to suit.
		* testsuite/ld-cris/undef3.d: Likewise.
		* testsuite/ld-elf/shared.exp: Likewise.
		* testsuite/ld-i386/compressed1.d: Likewise.
		* testsuite/ld-ia64/line.exp: Likewise.
		* testsuite/ld-plugin/lto.exp: Likewise.
		* testsuite/ld-undefined/undefined.exp: Likewise.
		* testsuite/ld-x86-64/compressed1.d: Likewise.
		* testsuite/ld-x86-64/line.exp: Likewise.
		* testsuite/ld-x86-64/pr27587.err: Likewise.

	(cherry picked from commit 02d2a36902c7b0fefe05e8d9bdbf11e846ac71fe)

2023-07-19  Alan Modra  <amodra@gmail.com>

	Fix loongarch build with gcc-4.5
		* loongarch-opc.c (loongarch_alias_opcodes): Don't trigger
		gcc-4.5 bug in handling of struct initialisation.

	(cherry picked from commit 4993e5cc1e2e1e192f56f5788453c1b6f9cca894)

2023-07-19  Alan Modra  <amodra@gmail.com>

	elf_object_p load of dynamic symbols
	This fixes an uninitialised memory access on a fuzzed file:
	0 0xf22e9b in offset_from_vma /src/binutils-gdb/bfd/elf.c:1899:2
	1 0xf1e90f in _bfd_elf_get_dynamic_symbols /src/binutils-gdb/bfd/elf.c:2099:13
	2 0x10e6a54 in bfd_elf32_object_p /src/binutils-gdb/bfd/elfcode.h:851:9

	Hopefully it will also stop any attempt to load dynamic symbols from
	eu-strip debug files.

		* elfcode.h (elf_object_p): Do not attempt to load dynamic
		symbols for a file with no section headers until all the
		program headers are swapped in.  Do not fail on eu-strip debug
		files.

	(cherry picked from commit 22e90ac5af46c01ee4972cf04e835266862bbb35)

2023-07-19  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-07-18  Vladimir Mezentsev  <vladimir.mezentsev@oracle.com>

	gprofng: 30602 [2.41] gprofng test hangs on i686-linux-gnu
	There were several problems in the gprofng testing:
	 - we did not catch a timeout for each test.
	 - we used exit() to stop a failed test. But this stops all other tests.
	 - we used a time_t (long) type in smalltest.c instead of a long long type.

		PR gprofng/30602
		* configure.ac: Launch only native testing.
		* configure: Rebuild.
		* testsuite/config/default.exp: Set TEST_TIMEOUT.
		* testsuite/gprofng.display/setpath_map.exp: Use return instead of exit.
		* testsuite/gprofng.display/gp-archive.exp: Likewise.
		* testsuite/gprofng.display/gp-collect-app_F.exp: Likewise.
		* testsuite/gprofng.display/display.exp: Delete an unnecessary test
		for native testing.
		* testsuite/lib/display-lib.exp (run_native_host_cmd): Add timeout.
		* testsuite/lib/smalltest.c: Use a long long type instead of time_t.

2023-07-18  Nick Clifton  <nickc@redhat.com>

	Updated Swedish translation for the binutils subdirectory

2023-07-18  Pter Chubb  <peter.chubb@unsw.edu.au>

	PR 30632 - ld segfaults if linker script includes a STARTUP line.

2023-07-18  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-07-17  Mark Harmstone  <mark@harmstone.com>

	ld/PDB: fix off-by-1 in add_globals_ref()

2023-07-17  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-07-16  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-07-15  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-07-14  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-07-13  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-07-12  Alan Modra  <amodra@gmail.com>

	Re: Keeping track of rs6000-coff archive element pointers
	bfd/
		* coff-rs6000.c (add_range): Revise comment, noting possible fail.
		(_bfd_xcoff_openr_next_archived_file): Start with clean ranges.
	binutils/
		* bfdtest1.c: Enhance to catch errors on second scan.

	(cherry picked from commit 1052fb3ecb1ae46bcf22634c48739c12e585196a)

2023-07-12  Alan Modra  <amodra@gmail.com>

	Use run_host_cmd to run $CC and other no-section-header test fixes
	We should be using run_host_cmd everywhere we invoke a compiler in the
	ld testsuite, if we want to use ld/ld-new just built.  run_host_cmd
	properly inserts $gcc_B_opt in cases where a user wants to test
	binutils with a newly built compiler, ie. when $CC specifies -B itself.

	Also, it is not good practice to exclude tests when non-native except
	of course those tests that run a target binary.  Compiling and linking
	often shows up problems.

		* testsuite/ld-elf/no-section-header.exp (binutils_run_test):
		Use run_host_cmd to invoke $CC_FOR_TARGET.  Run all tests
		non-native too, except for attempting to run the binaries.
		Run tests for ELF in general, not just linux.
		* testsuite/ld-elf/pr25617-1-no-sec-hdr.rd: Allow localentry
		symbol decoration, and support either sorting of symbols.
		* testsuite/ld-elf/pr25617-1a-no-sec-hdr.rd: Likewise.
		* testsuite/ld-elf/pr25617-1a-sec-hdr.rd: Likewise.
		* testsuite/ld-elf/pr25617-1a-no-sec-hdr.nd: Accept D function syms.
		* testsuite/ld-elf/start-shared-noheader-sysv.rd: Accept
		mips-sgi-irix symbol output.
		* testsuite/ld-elf/start-shared-noheader.nd: Likewise.

	(cherry picked from commit 46f51ac38b81df4bf890e13824427c69285fdcaa)

2023-07-12  YunQiang Su  <yunqiang.su@cipunited.com>

	ld: Use run_host_cmd_yesno in indirect.exp instead of catch exec
	Catch "exec $CC_FOR_TARGET" won't use the gas/ld that we just build,
	and in fact run_host_cmd_yesno is a better choice for it.

	ld/ChangeLog:

		* testsuite/ld-elf/indirect.exp: use run_host_cmd_yesno
		instead of handwrite catch exec $CC_FOR_TARGET.

	(cherry picked from commit 0f5cb49f68ae1be4b9702e71c3a9b80ee46b310a)

2023-07-12  YunQiang Su  <yunqiang.su@cipunited.com>

	ld: Use [list ] syntax to define run_tests in indirect.exp
	Currently, the var run_tests is defined by syntax {{}},
	while in this case, variables cannot be used.
	Thus $NOPIE_CFLAGS and $NOPIE_LDFLAGS are passed to cmd as names
	instead of values:
	  gcc ... $NOPIE_CFLAGS -c .../indirect5a.c -o tmpdir/indirect5a.o

	Let's use [list [list ]] syntax instead.

	ld/ChangeLog:

		* testsuite/ld-elf/indirect.exp(run_tests): use [list [list]]
		syntax instead of {{}}.

	(cherry picked from commit 96a73f2cb2a1b4c47e49ff194a94f7394308956b)

2023-07-12  Alan Modra  <amodra@gmail.com>

	Re: Stop the linker's --dependency-file option from including temporary lto files.
		PR 30568
		* ldfile.c (ldfile_try_open_bfd): Fix build failure when
		!BFD_SUPPORTS_PLUGINS.

	(cherry picked from commit 5f60df9974516867c02562b56c3a98cf4714a915)

2023-07-12  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-07-11  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-07-10  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-07-09  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-07-08  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-07-07  Nick Clifton  <nickc@redhat.com>

	Replace local variable called 'rename' with 'renamed'

	Udated Freach and Romainian translations for various sub-directories

2023-07-07  YunQiang Su  <yunqiang.su@cipunited.com>

	ld: fix plugin tests for MIPS PIC
	On MIPS, for PIC objects, symbols may reference 2 times:
	once from the caller, and once from GOT.
	Thus ld may complains 2 times about "undefined reference".

	So we add a new "#?" line to every effected testsuite.

2023-07-07  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-07-06  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-07-05  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-07-04  Nick Clifton  <nickc@redhat.com>

	Updated Ukranian, Romanian and German translations for various sub-directories

2023-07-04  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-07-03  Nick Clifton  <nickc@redhat.com>

	Change version number to 2.40.90 and regenerate files

	Add markers for the 2.41 branch

2023-07-03  WANG Xuerui  <git@xen0n.name>

	gas: NEWS: Announce LoongArch changes in the 2.41 cycle
	gas/ChangeLog:

		* NEWS: Mention LoongArch changes for 2.41.

2023-07-03  WANG Xuerui  <git@xen0n.name>

	binutils: NEWS: Announce LoongArch changes in the 2.41 cycle
	binutils/ChangeLog:

		* NEWS: Mention LoongArch changes for 2.41.

2023-07-03  WANG Xuerui  <git@xen0n.name>

	LoongArch: gas: Fix shared builds
	Formerly an include of libbfd.h was added in commit 56576f4a722
	("LoongArch: gas: Add support for linker relaxation."), in order to
	allow calling _bfd_read_unsigned_leb128 from gas, but doing so broke
	shared builds. Commit d2fddb6d783 fixed this reference but did not
	remove the now unnecessary inclusion of libbfd.h. The gas_assert macro
	expands into a conditional call to abort(), but "abort" is re-defined to
	_bfd_abort in libbfd.h, so the extra include breaks any gas_assert
	usage, and should be removed.

	gas/ChangeLog:

		* config/tc-loongarch.c: Don't include libbfd.h.

	Fixes: d2fddb6d783 ("LoongArch: Fix ld "undefined reference" error with --enable-shared")

2023-07-03  WANG Xuerui  <git@xen0n.name>

	opcodes/loongarch: Mark address offset operands of LVZ/LBT insns as such
	opcodes/ChangeLog:

		* loongarch-opc.c: Mark the offset operands as "so" for
		{,x}v{ld,st}, {,x}v{ldrepl,stelm}.[bhwd], and {ld,st}[lr].[wd].

2023-07-03  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-07-02  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-07-01  Vladimir Mezentsev  <vladimir.mezentsev@oracle.com>

	gprofng: fix data race
	In our GUI project (https://savannah.gnu.org/projects/gprofng-gui), we use
	the output of gprofng to display the data. Sometimes this data is corrupted.

	gprofng/ChangeLog
	2023-06-29  Vladimir Mezentsev  <vladimir.mezentsev@oracle.com>

		* src/ipc.cc (ipc_doWork): Fix data race.
		* src/ipcio.cc (IPCresponse::print): Fix data race.
		Remove unused variables and functions.
		* src/ipcio.h: Declare two variables.
		* src/StringBuilder.cc (StringBuilder::write): New function.
		* src/StringBuilder.h: Likewise.

2023-07-01  Christoph Müllner  <christoph.muellner@vrull.eu>

	binutils: NEWS: Announce new RISC-V vector crypto extensions
	This commit adds the recently added support of the RISC-V vector crypto
	extensions to the NEWS file.

	binutils/ChangeLog:

		* NEWS: Announce new RISC-V vector crypto extensions.

2023-07-01  Nathan Huckleberry  <nhuck@google.com>

	RISC-V: Add support for the Zvksc ISA extension
	Zvksc is part of the vector crypto extensions.

	Zvksc is shorthand for the following set of extensions:
	- Zvks
	- Zvbc

	bfd/ChangeLog:

		* elfxx-riscv.c: Define Zvksc extension.

	gas/ChangeLog:

		* testsuite/gas/riscv/zvksc.d: New test.
		* testsuite/gas/riscv/zvksc.s: New test.

2023-07-01  Nathan Huckleberry  <nhuck@google.com>

	RISC-V: Add support for the Zvknc ISA extension
	Zvknc is part of the vector crypto extensions.

	Zvknc is shorthand for the following set of extensxions:
	- Zvkn
	- Zvbc

	bfd/ChangeLog:

		* elfxx-riscv.c: Define Zvknc extension.

	gas/ChangeLog:

		* testsuite/gas/riscv/zvknc.d: New test.
		* testsuite/gas/riscv/zvknc.s: New test.

2023-07-01  Nathan Huckleberry  <nhuck@google.com>

	RISC-V: Add support for the Zvksg ISA extension
	Zvksg is part of the vector crypto extensions.

	Zvksg is shorthand for the following set of extensions:
	- Zvks
	- Zvkg

	bfd/ChangeLog:

		* elfxx-riscv.c: Define Zvksg extension.

	gas/ChangeLog:

		* testsuite/gas/riscv/zvksg.d: New test.
		* testsuite/gas/riscv/zvksg.s: New test.

2023-07-01  Christoph Müllner  <christoph.muellner@vrull.eu>

	RISC-V: Add support for the Zvks ISA extension
	Zvks is part of the vector crypto extensions.

	Zvks is shorthand for the following set of extensions:
	- Zvksed
	- Zvksh
	- Zvbb
	- Zvkt

	bfd/ChangeLog:

		* elfxx-riscv.c: Define Zvks extension.

	gas/ChangeLog:

		* testsuite/gas/riscv/zvks.d: New test.
		* testsuite/gas/riscv/zvks.s: New test.

2023-07-01  Nathan Huckleberry  <nhuck@google.com>

	RISC-V: Add support for the Zvkng ISA extension
	Zvkng is part of the vector crypto extensions.

	Zvkng is shorthand for the following set of extensions:
	- Zvkn
	- Zvkg

	bfd/ChangeLog:

		* elfxx-riscv.c: Define Zvkng extension.

	gas/ChangeLog:

		* testsuite/gas/riscv/zvkng.d: New test.
		* testsuite/gas/riscv/zvkng.s: New test.

2023-07-01  Nathan Huckleberry  <nhuck@google.com>

	RISC-V: Allow nested implications for extensions
	Certain extensions require two levels of implications.  For example,
	zvkng implies zvkn and zvkn implies zvkned.  Enabling zvkng should also
	enable zvkned.

	This patch fixes this behavior.

	bfd/ChangeLog:

		* elfxx-riscv.c (riscv_parse_add_implicit_subsets): Allow nested
		implications for extensions.

2023-07-01  Christoph Müllner  <christoph.muellner@vrull.eu>

	RISC-V: Add support for the Zvkn ISA extension
	Zvkn is part of the vector crypto extensions.

	Zvkn is shorthand for the following set of extensions:
	- Zvkned
	- Zvknhb
	- Zvbb
	- Zvkt

	bfd/ChangeLog:

		* elfxx-riscv.c: Define Zvkn extension.

	gas/ChangeLog:

		* testsuite/gas/riscv/zvkn.d: New test.
		* testsuite/gas/riscv/zvkn.s: New test.

2023-07-01  Christoph Müllner  <christoph.muellner@vrull.eu>

	RISC-V: Add support for the Zvksh ISA extension
	Zvksh is part of the vector crypto extensions.

	This extension adds the following instructions:
	- vsm3me.vv
	- vsm3c.vi

	bfd/ChangeLog:

		* elfxx-riscv.c (riscv_multi_subset_supports): Add instruction
		class support for Zvksh.
		(riscv_multi_subset_supports_ext): Likewise.

	gas/ChangeLog:

		* testsuite/gas/riscv/zvksh.d: New test.
		* testsuite/gas/riscv/zvksh.s: New test.

	include/ChangeLog:

		* opcode/riscv-opc.h (MATCH_VSM3C_VI): New.
		(MASK_VSM3C_VI): New.
		(MATCH_VSM3ME_VV): New.
		(MASK_VSM3ME_VV): New.
		(DECLARE_INSN): New.
		* opcode/riscv.h (enum riscv_insn_class): Add instruction class
		support for Zvksh.

	opcodes/ChangeLog:

		* riscv-opc.c: Add Zvksh instructions.

2023-07-01  Christoph Müllner  <christoph.muellner@vrull.eu>

	RISC-V: Add support for the Zvksed ISA extension
	Zvksed is part of the vector crypto extensions.

	This extension adds the following instructions:
	- vsm4k.vi
	- vsm4r.[vv,vs]

	bfd/ChangeLog:

		* elfxx-riscv.c (riscv_multi_subset_supports): Add instruction
		class support for Zvksed.
		(riscv_multi_subset_supports_ext): Likewise.

	gas/ChangeLog:

		* testsuite/gas/riscv/zvksed.d: New test.
		* testsuite/gas/riscv/zvksed.s: New test.

	include/ChangeLog:

		* opcode/riscv-opc.h (MATCH_VSM4K_VI): New.
		(MASK_VSM4K_VI): New.
		(MATCH_VSM4R_VS): New.
		(MASK_VSM4R_VS): New.
		(MATCH_VSM4R_VV): New.
		(MASK_VSM4R_VV): New.
		(DECLARE_INSN): New.
		* opcode/riscv.h (enum riscv_insn_class): Add instruction class
		support for Zvksed.

	opcodes/ChangeLog:

		* riscv-opc.c: Add Zvksed instructions.

2023-07-01  Christoph Müllner  <christoph.muellner@vrull.eu>

	RISC-V: Add support for the Zvknh[a,b] ISA extensions
	Zvknh[a,b] are parts of the vector crypto extensions.

	This extension adds the following instructions:
	- vsha2ms.vv
	- vsha2c[hl].vv

	bfd/ChangeLog:

		* elfxx-riscv.c (riscv_multi_subset_supports): Add instruction
		class support for Zvknh[a,b].
		(riscv_multi_subset_supports_ext): Likewise.

	gas/ChangeLog:

		* testsuite/gas/riscv/zvknha.d: New test.
		* testsuite/gas/riscv/zvknha_zvknhb.s: New test.
		* testsuite/gas/riscv/zvknhb.d: New test.

	include/ChangeLog:

		* opcode/riscv-opc.h (MATCH_VSHA2CH_VV): New.
		(MASK_VSHA2CH_VV): New.
		(MATCH_VSHA2CL_VV): New.
		(MASK_VSHA2CL_VV): New.
		(MATCH_VSHA2MS_VV): New.
		(MASK_VSHA2MS_VV): New.
		(DECLARE_INSN): New.
		* opcode/riscv.h (enum riscv_insn_class): Add instruction class
		support for Zvknh[a,b].

	opcodes/ChangeLog:

		* riscv-opc.c: Add Zvknh[a,b] instructions.

2023-07-01  Christoph Müllner  <christoph.muellner@vrull.eu>

	RISC-V: Add support for the Zvkned ISA extension
	Zvkned is part of the vector crypto extensions.

	This extension adds the following instructions:
	- vaesef.[vv,vs]
	- vaesem.[vv,vs]
	- vaesdf.[vv,vs]
	- vaesdm.[vv,vs]
	- vaeskf1.vi
	- vaeskf2.vi
	- vaesz.vs

	bfd/ChangeLog:

		* elfxx-riscv.c (riscv_multi_subset_supports): Add instruction
		class support for Zvkned.
		(riscv_multi_subset_supports_ext): Likewise.

	gas/ChangeLog:

		* testsuite/gas/riscv/zvkned.d: New test.
		* testsuite/gas/riscv/zvkned.s: New test.

	include/ChangeLog:

		* opcode/riscv-opc.h (MATCH_VAESDF_VS): New.
		(MASK_VAESDF_VS): New.
		(MATCH_VAESDF_VV): New.
		(MASK_VAESDF_VV): New.
		(MATCH_VAESDM_VS): New.
		(MASK_VAESDM_VS): New.
		(MATCH_VAESDM_VV): New.
		(MASK_VAESDM_VV): New.
		(MATCH_VAESEF_VS): New.
		(MASK_VAESEF_VS): New.
		(MATCH_VAESEF_VV): New.
		(MASK_VAESEF_VV): New.
		(MATCH_VAESEM_VS): New.
		(MASK_VAESEM_VS): New.
		(MATCH_VAESEM_VV): New.
		(MASK_VAESEM_VV): New.
		(MATCH_VAESKF1_VI): New.
		(MASK_VAESKF1_VI): New.
		(MATCH_VAESKF2_VI): New.
		(MASK_VAESKF2_VI): New.
		(MATCH_VAESZ_VS): New.
		(MASK_VAESZ_VS): New.
		(DECLARE_INSN): New.
		* opcode/riscv.h (enum riscv_insn_class): Add instruction class
		support for Zvkned.

	opcodes/ChangeLog:

		* riscv-opc.c: Add Zvkned instructions.

2023-07-01  Christoph Müllner  <christoph.muellner@vrull.eu>

	RISC-V: Add support for the Zvkg ISA extension
	Zvkg is part of the vector crypto extensions.

	This extension adds the following instructions:
	- vghsh.vv
	- vgmul.vv

	bfd/ChangeLog:

		* elfxx-riscv.c (riscv_multi_subset_supports): Add instruction
		class support for Zvkg.
		(riscv_multi_subset_supports_ext): Likewise.

	gas/ChangeLog:

		* testsuite/gas/riscv/zvkg.d: New test.
		* testsuite/gas/riscv/zvkg.s: New test.

	include/ChangeLog:

		* opcode/riscv-opc.h (MATCH_VGHSH_VV): New.
		(MASK_VGHSH_VV): New.
		(MATCH_VGMUL_VV): New.
		(MASK_VGMUL_VV): New.
		(DECLARE_INSN): New.
		* opcode/riscv.h (enum riscv_insn_class): Add instruction class
		support for Zvkg.

	opcodes/ChangeLog:

		* riscv-opc.c: Add Zvkg instructions.

2023-07-01  Nathan Huckleberry  <nhuck@google.com>

	RISC-V: Add support for the Zvbc extension
	Zvbc is part of the crypto vector extensions.

	This extension adds the following instructions:
	- vclmul.[vv,vx]
	- vclmulh.[vv,vx]

	bfd/ChangeLog:

		* elfxx-riscv.c (riscv_multi_subset_supports): Add instruction
		class support for Zvbc.
		(riscv_multi_subset_supports_ext): Likewise.

	gas/ChangeLog:

		* testsuite/gas/riscv/zvbc.d: New test.
		* testsuite/gas/riscv/zvbc.s: New test.

	include/ChangeLog:

		* opcode/riscv-opc.h (MATCH_VCLMUL_VV): New.
		(MASK_VCLMUL_VV): New.
		(MATCH_VCLMUL_VX): New.
		(MASK_VCLMUL_VX): New.
		(MATCH_VCLMULH_VV): New.
		(MASK_VCLMULH_VV): New.
		(MATCH_VCLMULH_VX): New.
		(MASK_VCLMULH_VX): New.
		(DECLARE_INSN): New.
		* opcode/riscv.h (enum riscv_insn_class): Add instruction class
		  support for Zvbc.

	opcodes/ChangeLog:

		* riscv-opc.c: Add Zvbc instruction.

2023-07-01  Christoph Müllner  <christoph.muellner@vrull.eu>

	RISC-V: Add support for the Zvbb ISA extension
	Zvbb is part of the vector crypto extensions.

	This extension adds the following instructions:
	- vandn.[vv,vx]
	- vbrev.v
	- vbrev8.v
	- vrev8.v
	- vclz.v
	- vctz.v
	- vcpop.v
	- vrol.[vv,vx]
	- vror.[vv,vx,vi]
	- vwsll.[vv,vx,vi]

	bfd/ChangeLog:

		* elfxx-riscv.c (riscv_multi_subset_supports): Add instruction
		class support for Zvbb.
		(riscv_multi_subset_supports_ext): Likewise.

	gas/ChangeLog:

		* config/tc-riscv.c (validate_riscv_insn): Add 'l' as new format
		string directive.
		(riscv_ip): Likewise.
		* testsuite/gas/riscv/zvbb.d: New test.
		* testsuite/gas/riscv/zvbb.s: New test.

	include/ChangeLog:

		* opcode/riscv-opc.h (MATCH_VANDN_VV): New.
		(MASK_VANDN_VV): New.
		(MATCH_VANDN_VX): New.
		(MASK_VANDN_VX): New.
		(MATCH_VBREV8_V): New.
		(MASK_VBREV8_V): New.
		(MATCH_VBREV_V): New.
		(MASK_VBREV_V): New.
		(MATCH_VCLZ_V): New.
		(MASK_VCLZ_V): New.
		(MATCH_VCPOP_V): New.
		(MASK_VCPOP_V): New.
		(MATCH_VCTZ_V): New.
		(MASK_VCTZ_V): New.
		(MATCH_VREV8_V): New.
		(MASK_VREV8_V): New.
		(MATCH_VROL_VV): New.
		(MASK_VROL_VV): New.
		(MATCH_VROL_VX): New.
		(MASK_VROL_VX): New.
		(MATCH_VROR_VI): New.
		(MASK_VROR_VI): New.
		(MATCH_VROR_VV): New.
		(MASK_VROR_VV): New.
		(MATCH_VROR_VX): New.
		(MASK_VROR_VX): New.
		(MATCH_VWSLL_VI): New.
		(MASK_VWSLL_VI): New.
		(MATCH_VWSLL_VV): New.
		(MASK_VWSLL_VV): New.
		(MATCH_VWSLL_VX): New.
		(MASK_VWSLL_VX): New.
		(DECLARE_INSN): New.
		* opcode/riscv.h (EXTRACT_RVV_VI_UIMM6): New.
		(ENCODE_RVV_VI_UIMM6): New.
		(enum riscv_insn_class): Add instruction class for Zvbb.

	opcodes/ChangeLog:

		* riscv-dis.c (print_insn_args): Add 'l' as new format string
		directive.
		* riscv-opc.c: Add Zvbb instructions.

2023-07-01  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-06-30  Tom Tromey  <tom@tromey.com>

	Fix regressions caused by agent expression C++-ification
	Simon pointed out that my agent expression C++-ification patches
	caused a regression with the native-gdbserver target board.  The bug
	is that append_const is supposed to write in big-endian order, but I
	switched this by mistake.

2023-06-30  Philipp Tomsich  <philipp.tomsich@vrull.eu>

	binutils: NEWS: announce new RISC-V extensions
	We picked up support for a few new extensions over the last weeks
	(this may need further updating prior to the next release), list them
	in the NEWS file.

	binutils/ChangeLog:

		* binutils/NEWS: announce suuport for the new RISC-V
	          extensions (Zicond, Zfa, XVentanaCondOps).

2023-06-30  Christoph Müllner  <christoph.muellner@vrull.eu>

	RISC-V: Add support for the Zfa extension
	This patch adds support for the RISC-V Zfa extension,
	which introduces additional floating-point instructions:
	* fli (load-immediate) with pre-defined immediates
	* fminm/fmaxm (like fmin/fmax but with different NaN behaviour)
	* fround/froundmx (round to integer)
	* fcvtmod.w.d (Modular Convert-to-Integer)
	* fmv* to access high bits of FP registers in case XLEN < FLEN
	* fleq/fltq (quiet comparison instructions)

	Zfa defines its instructions in combination with the following
	extensions:
	* single-precision floating-point (F)
	* double-precision floating-point (D)
	* quad-precision floating-point (Q)
	* half-precision floating-point (Zfh)

	This patch is based on an earlier version from Tsukasa OI:
	  https://sourceware.org/pipermail/binutils/2022-September/122939.html
	Most significant change to that commit is the switch from the rs1-field
	value to the actual floating-point value in the last operand of the fli*
	instructions. Everything that strtof() can parse is accepted and
	the '%a' printf specifier is used to output hex floating-point literals
	in the disassembly.

	The Zfa specification is frozen (and has passed public review).  It is
	available as a chapter in "The RISC-V Instruction Set Manual: Volume 1":
	  https://github.com/riscv/riscv-isa-manual/releases

	bfd/ChangeLog:

		* elfxx-riscv.c (riscv_multi_subset_supports): Add instruction
		class support for 'Zfa' extension.
		(riscv_multi_subset_supports_ext): Likewise.
		(riscv_implicit_subsets): Add 'Zfa' -> 'F' dependency.

	gas/ChangeLog:

		* config/tc-riscv.c (flt_lookup): New helper to lookup a float value
		in an array.
		(validate_riscv_insn): Add 'Wfv' as new format string directive.
		(riscv_ip): Likewise.
		* doc/c-riscv.texi: Add floating-point chapter and describe
		limiations of the Zfa FP literal parsing.
		* testsuite/gas/riscv/zfa-32.d: New test.
		* testsuite/gas/riscv/zfa-32.s: New test.
		* testsuite/gas/riscv/zfa-64.d: New test.
		* testsuite/gas/riscv/zfa-64.s: New test.
		* testsuite/gas/riscv/zfa-fail.d: New test.
		* testsuite/gas/riscv/zfa-fail.l: New test.
		* testsuite/gas/riscv/zfa-fail.s: New test.
		* testsuite/gas/riscv/zfa.d: New test.
		* testsuite/gas/riscv/zfa.s: New test.
		* testsuite/gas/riscv/zfa.s: New test.

		* opcode/riscv-opc.h (MATCH_FLI_H): New.
		(MASK_FLI_H): New.
		(MATCH_FMINM_H): New.
		(MASK_FMINM_H): New.
		(MATCH_FMAXM_H): New.
		(MASK_FMAXM_H): New.
		(MATCH_FROUND_H): New.
		(MASK_FROUND_H): New.
		(MATCH_FROUNDNX_H): New.
		(MASK_FROUNDNX_H): New.
		(MATCH_FLTQ_H): New.
		(MASK_FLTQ_H): New.
		(MATCH_FLEQ_H): New.
		(MASK_FLEQ_H): New.
		(MATCH_FLI_S): New.
		(MASK_FLI_S): New.
		(MATCH_FMINM_S): New.
		(MASK_FMINM_S): New.
		(MATCH_FMAXM_S): New.
		(MASK_FMAXM_S): New.
		(MATCH_FROUND_S): New.
		(MASK_FROUND_S): New.
		(MATCH_FROUNDNX_S): New.
		(MASK_FROUNDNX_S): New.
		(MATCH_FLTQ_S): New.
		(MASK_FLTQ_S): New.
		(MATCH_FLEQ_S): New.
		(MASK_FLEQ_S): New.
		(MATCH_FLI_D): New.
		(MASK_FLI_D): New.
		(MATCH_FMINM_D): New.
		(MASK_FMINM_D): New.
		(MATCH_FMAXM_D): New.
		(MASK_FMAXM_D): New.
		(MATCH_FROUND_D): New.
		(MASK_FROUND_D): New.
		(MATCH_FROUNDNX_D): New.
		(MASK_FROUNDNX_D): New.
		(MATCH_FLTQ_D): New.
		(MASK_FLTQ_D): New.
		(MATCH_FLEQ_D): New.
		(MASK_FLEQ_D): New.
		(MATCH_FLI_Q): New.
		(MASK_FLI_Q): New.
		(MATCH_FMINM_Q): New.
		(MASK_FMINM_Q): New.
		(MATCH_FMAXM_Q): New.
		(MASK_FMAXM_Q): New.
		(MATCH_FROUND_Q): New.
		(MASK_FROUND_Q): New.
		(MATCH_FROUNDNX_Q): New.
		(MASK_FROUNDNX_Q): New.
		(MATCH_FLTQ_Q): New.
		(MASK_FLTQ_Q): New.
		(MATCH_FLEQ_Q): New.
		(MASK_FLEQ_Q): New.
		(MATCH_FCVTMOD_W_D): New.
		(MASK_FCVTMOD_W_D): New.
		(MATCH_FMVH_X_D): New.
		(MASK_FMVH_X_D): New.
		(MATCH_FMVH_X_Q): New.
		(MASK_FMVH_X_Q): New.
		(MATCH_FMVP_D_X): New.
		(MASK_FMVP_D_X): New.
		(MATCH_FMVP_Q_X): New.
		(MASK_FMVP_Q_X): New.
		(DECLARE_INSN): New.
		* opcode/riscv.h (enum riscv_insn_class): Add instruction
		classes for the Zfa extension.

	opcodes/ChangeLog:

		* riscv-dis.c (print_insn_args): Add support for
		new format string directive 'Wfv'.
		* riscv-opc.c: Add Zfa instructions.

	Co-Developed-by: Tsukasa OI <research_trasio@irq.a4lg.com>
	Co-Developed-by: Philipp Tomsich <philipp.tomsich@vrull.eu>
	Acked-by: Palmer Dabbelt <palmer@rivosinc.com>

2023-06-30  Nick Clifton  <nickc@redhat.com>

	strings: Improve code to detect excessively large minimum string lengths.
	  PR 30598
	  * strings.c (set_string_min): New function. (main): Use it. (print_unicode_stream): Calculate buffer size using a size_t.

	Prevent an illegal memory access when running the strings program with an excessively lerge minimum string length.
	  PR 30595
	  * strings.c (main): Check for an excessively large minimum string length.

	Fix used-before-initialized warnings when compiling elf.c with Clang-16.

2023-06-30  mengqinggang  <mengqinggang@loongson.cn>

	LoongArch: gas: Fix code style issues
	  Blocks of 8 spaces be replaced with tabs.
	  Fix alignment issues.

2023-06-30  mengqinggang  <mengqinggang@loongson.cn>

	LoongArch: gas: Add LVZ and LBT instructions support
	gas/ChangeLog:
		* config/tc-loongarch.c (md_parse_option): Add LARCH_opts.ase_lvz and
		LARCH_opts.ase_lbt.
		* testsuite/gas/loongarch/uleb128.d: Regenerated.
		* testsuite/gas/loongarch/lvz-lbt.d: New test.
		* testsuite/gas/loongarch/lvz-lbt.s: New test.

	include/ChangeLog:
		* opcode/loongarch.h (ase_lvz): New.
		(ase_lbt): New.

	opcodes/ChangeLog:
		* loongarch-dis.c (set_default_loongarch_dis_options): Add
		LARCH_opts.ase_lvz and LARCH_opts.ase_lbt.
		* loongarch-opc.c (struct loongarch_ase): Add LVZ and LBT instructions.

2023-06-30  WANG Xuerui  <git@xen0n.name>

	LoongArch: Deprecate $v[01], $fv[01] and $x names per spec
	As outlined in the LoongArch ELF psABI spec [1], it is actually already
	2 versions after the initial LoongArch support, and the $v[01] and
	$fv[01] names should really get sunset by now.

	In addition, the "$x" name for $r21 was never included in any released
	version of the ABI spec, and such usages are all fixed to say just $r21
	for every project I could think of that accepted a LoongArch port.

	Plus, the upcoming LSX/LASX support makes use of registers named
	"$vrNN" and "$xrNN", so having "$vN" and "$x" alongside would almost
	certainly create confusion for developers.

	Issue warnings for such usages per the deprecation procedure detailed
	in the spec, so we can finally remove support in the next release cycle
	after this.

	[1]: https://loongson.github.io/LoongArch-Documentation/LoongArch-ELF-ABI-EN.html

	gas/ChangeLog:

		* config/tc-loongarch.c: Init canonical register ABI name
		mappings and deprecated register names.
		(loongarch_args_parser_can_match_arg_helper): Warn in case of
		deprecated register name usage.
		* testsuite/gas/loongarch/deprecated_reg_aliases.d: New test.
		* testsuite/gas/loongarch/deprecated_reg_aliases.l: Likewise.
		* testsuite/gas/loongarch/deprecated_reg_aliases.s: Likewise.

	include/ChangeLog:

		* opcode/loongarch.h: Rename global variables.

	opcodes/ChangeLog:

		* loongarch-opc.c: Rename the alternate/deprecated register name
		mappings, and move $x to the deprecated name map.

2023-06-30  WANG Xuerui  <git@xen0n.name>

	opcodes/loongarch: print unrecognized insn words with the .word directive
	For better round-trip fidelity and readability in general.

	gas/ChangeLog:

		* testsuite/gas/loongarch/uleb128.d: Update test case.
		* testsuite/gas/loongarch/raw-insn.d: New test.
		* testsuite/gas/loongarch/raw-insn.s: Likewise.

	opcodes/ChangeLog:

		* loongarch-dis.c (disassemble_one): Print ".word" if !opc.

2023-06-30  WANG Xuerui  <git@xen0n.name>

	opcodes/loongarch: do not print hex notation for signed immediates
	The additional hex notation was minimally useful when one had to
	inspect code with heavy bit manipulation, or of unclear signedness, but
	it clutters the output, and the style is not regular assembly language
	syntax either.

	Precisely how one approaches the original use case is not taken care of
	in this patch (maybe we want a disassembler option forcing a certain
	style for immediates, like for example printing every immediate in
	decimal or hexadecimal notation), but at least let's stop the current
	practice.

	ChangeLog:

		* testsuite/gas/loongarch/imm_ins.d: Update test case.
		* testsuite/gas/loongarch/imm_ins_32.d: Likewise.
		* testsuite/gas/loongarch/imm_op.d: Likewise.
		* testsuite/gas/loongarch/jmp_op.d: Likewise.
		* testsuite/gas/loongarch/load_store_op.d: Likewise.
		* testsuite/gas/loongarch/macro_op.d: Likewise.
		* testsuite/gas/loongarch/macro_op_32.d: Likewise.
		* testsuite/gas/loongarch/privilege_op.d: Likewise.
		* testsuite/gas/loongarch/uleb128.d: Likewise.
		* testsuite/gas/loongarch/vector.d: Likewise.

	ld/ChangeLog:

		* testsuite/ld-loongarch-elf/jmp_op.d: Update test case.
		* testsuite/ld-loongarch-elf/macro_op.d: Likewise.
		* testsuite/ld-loongarch-elf/macro_op_32.d: Likewise.

	opcodes/ChangeLog:

		* loongarch-dis.c (dis_one_arg): Remove the "(0x%x)" part from
		disassembly output of signed immediate operands.

2023-06-30  WANG Xuerui  <git@xen0n.name>

	opcodes/loongarch: style disassembled address offsets as such
	Add a modifier char 'o' telling the disassembler to print the immediate
	using the address offset style, and mark the memory access instructions'
	offset operands as such.

	opcodes/ChangeLog:

		* loongarch-dis.c (dis_one_arg): Style disassembled address
		offsets as such when the operand has a modifier char 'o'.
		* loongarch-opc.c: Add 'o' to operands that represent address
		offsets.

2023-06-30  WANG Xuerui  <git@xen0n.name>

	opcodes/loongarch: implement style support in the disassembler
	Update the LoongArch disassembler to supply style information to the
	disassembler output. The output formatting remains unchanged.

	opcodes/ChangeLog:

		* disassemble.c: Mark LoongArch as created_styled_output=true.
		* loongarch-dis.c (dis_one_arg): Use fprintf_styled_func
		throughout with proper styles.

2023-06-30  WANG Xuerui  <git@xen0n.name>

	opcodes/loongarch: remove unused code
	Remove some unused declarations and code.

	include/ChangeLog:

		* opcode/loongarch.h: Remove unused declarations.

	opcodes/ChangeLog:

		* loongarch-dis.c (loongarch_parse_dis_options): Remove.
		(my_print_address_func): Likewise.
		(loongarch_disassemble_one): Likewise.

2023-06-30  WANG Xuerui  <git@xen0n.name>

	LoongArch: support disassembling certain pseudo-instructions
	Add a flag in the pinfo field for being able to mark certain specialized
	matchers as disassembler-only, so some degree of isolation between
	assembler-side and disassembler-side can be achieved.

	This isolation is necessary, firstly because some pseudo-instructions
	cannot be fully described in the opcode table, like `li.[wd]`, so the
	corresponding opcode entry cannot have meaningful match/mask values.
	Secondly, some of these pseudo-instructions can be realized in more than
	one plausible ways; e.g. `li.w rd, <something between 0 and 0x7ff>` can
	be realized on LA64 with any of `addi.w`, `addi.d` or `ori`. If we tie
	disassembly of such aliases with the corresponding GAS support, only one
	canonical form among the above would be recognized as `li.w`, and it
	would mildly impact the readability of disassembly output.
	People wanting the exact disassembly can always set `-M no-aliases` to
	get the original behavior back.

	In addition, in certain cases, information is irreversibly lost after
	assembling, so perfect round-trip would not be possible in such cases.
	For example, `li.w` and `li.d` of immediates within int32_t range
	produce the same code; in this patch, `addi.d rd, $zero, imm` is treated
	as `li.d`, while `addi.w` and `ori` immediate loads are shown as `li.w`,
	due to the expressible value range well within 32 bits.

	gas/ChangeLog:

		* config/tc-loongarch.c (get_loongarch_opcode): Ignore
		disassembler-only aliases.
		* testsuite/gas/loongarch/64_pcrel.d: Update test case.
		* testsuite/gas/loongarch/imm_ins.d: Likewise.
		* testsuite/gas/loongarch/imm_ins_32.d: Likewise.
		* testsuite/gas/loongarch/jmp_op.d: Likewise.
		* testsuite/gas/loongarch/li.d: Likewise.
		* testsuite/gas/loongarch/macro_op.d: Likewise.
		* testsuite/gas/loongarch/macro_op_32.d: Likewise.
		* testsuite/gas/loongarch/macro_op_large_abs.d: Likewise.
		* testsuite/gas/loongarch/macro_op_large_pc.d: Likewise.
		* testsuite/gas/loongarch/nop.d: Likewise.
		* testsuite/gas/loongarch/relax_align.d: Likewise.
		* testsuite/gas/loongarch/reloc.d: Likewise.

	include/ChangeLog:

		* opcode/loongarch.h (INSN_DIS_ALIAS): Add.

	ld/ChangeLog:

		* testsuite/ld-loongarch-elf/jmp_op.d: Update test case.
		* testsuite/ld-loongarch-elf/macro_op.d: Likewise.
		* testsuite/ld-loongarch-elf/macro_op_32.d: Likewise.
		* testsuite/ld-loongarch-elf/relax-align.dd: Likewise.

	opcodes/ChangeLog:

		* loongarch-dis.c: Move register name map declarations to top.
		(get_loongarch_opcode_by_binfmt): Consider aliases when
		disassembling without the no-aliases option.
		(parse_loongarch_dis_option): Support the no-aliases option.
		* loongarch-opc.c: Collect pseudo instructions into a new
		dedicated table.

2023-06-30  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-06-30  Indu Bhagat  <indu.bhagat@oracle.com>

	binutils/NEWS: announce SFrame version 2 as the new default

2023-06-30  Indu Bhagat  <indu.bhagat@oracle.com>

	doc: sframe: update specification for SFRAME_VERSION_2
	Add details for the changes made from Version 1 to Version 2 of the format.

	Also add details about alignment in the SFrame format.  A portion of the
	SFrame stack trace format has an unaligned on-disk representation.  Add
	description at relevant points in the specificatin to clarify the
	alignment related details.

2023-06-30  Indu Bhagat  <indu.bhagat@oracle.com>

	sframe: bfd: gas: ld: format bump to SFrame version 2
	SFrame version 2 encodes the size of repetitive insn block explicitly
	in the format.  Add information in the SFrame FDE to convey the size
	of the block of repeating instructions.  This information is used only
	for SFrame FDEs of type SFRAME_FDE_TYPE_PCMASK.

	Introduce two extra bytes for padding: this ensures that the memory
	accesses to the members of the SFrame Frame Descriptor Entry (FDE) are
	naturally aligned.

	gas generates SFrame section with version SFRAME_VERSION_2 by default.

	libsframe provides two new APIs to:
	  - get an SFrame FDE data from the decoder context, and
	  - add an SFrame FDE to the encoder context.
	The additional argument (for rep_block_size) is useful for SFrame FDEs
	where FDE type is SFRAME_FDE_TYPE_PCMASK.

	The linker will generate the output SFrame sections in the
	SFRAME_VERSION_2 format.  If the input sections offered to the linker
	are not all in the SFRAME_VERSION_2 format, the linker issues an error
	to the user.

	objdump/readelf will show the following message to the user if .sframe
	section in SFRAME_VERSION_1 format is seen:

	 "No further information can be displayed.  SFrame version not
	 supported."

	In other words, like the rest of the binutils, only the current SFrame
	format version, i.e., SFRAME_VERSION_2 is supported by the textual dump
	facilities.

	bfd/
		* elf-sframe.c (_bfd_elf_merge_section_sframe): Generate an
		output SFrame section with version SFRAME_VERSION_2.  Also,
		error out if the SFrame sections do not all have
		SFRAME_VERSION_2.
		* elfxx-x86.c (_bfd_x86_elf_create_sframe_plt): Generate SFrame
		section for plt entries with version SFRAME_VERSION_2.
	gas/
		* gen-sframe.c (sframe_set_version): Update to SFRAME_VERSION_2.
		(output_sframe): Likewise.
	gas/testsuite/
		* gas/cfi-sframe/cfi-sframe-aarch64-1.d: Use SFRAME_VERSION_2.
		* gas/cfi-sframe/cfi-sframe-aarch64-2.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-aarch64-pac-ab-key-1.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-common-1.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-common-2.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-common-3.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-common-4.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-common-5.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-common-6.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-common-7.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-common-8.d: Likewise.
		* gas/cfi-sframe/cfi-sframe-x86_64-1.d: Likewise.
		* gas/cfi-sframe/common-empty-1.d: Likewise.
		* gas/cfi-sframe/common-empty-2.d: Likewise.
		* gas/cfi-sframe/common-empty-3.d: Likewise.
	ld/testsuite/
		* ld-aarch64/sframe-simple-1.d: Adjust for SFRAME_VERSION_2.
		* ld-x86-64/sframe-plt-1.d: Likewise.
		* ld-x86-64/sframe-simple-1.d: Likewise.
	libsframe/
		* libsframe.ver: Add the new APIs.
		* sframe.c (sframe_decoder_get_funcdesc_v2): New definition.
		(sframe_encoder_add_funcdesc_v2): Likewise.
		(sframe_header_sanity_check_p): Include SFRAME_VERSION_2.
		(sframe_fre_check_range_p): Get rep_block_size info from SFrame
		FDE.
		* sframe-dump.c (dump_sframe_header): Add support for
		SFRAME_VERSION_2.
		(dump_sframe): Inform user if SFrame section in SFRAME_VERSION_1
		format is seen.
	libsframe/testsuite/
		* libsframe.decode/DATA-BE: Regenerated data file.
		* libsframe.decode/DATA1: Likewise.
		* libsframe.decode/DATA2: Likewise.
		* libsframe.find/plt-findfre-1.c: Use new API in the testcase.
	include/
		* sframe.h: Add member to encode size of the code block of
		repeating instructions.  Add 2 bytes of padding.
		* sframe-api.h (sframe_decoder_get_funcdesc_v2): New
		declaration.
		(sframe_encoder_add_funcdesc_v2): Likewise.

2023-06-30  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: add new APIs to get SFrame version
	While the SFrame preamble is guaranteed to not change between versions,
	providing these access APIs from the SFrame decoder and encoder APIs is
	for convenience only.  The linker may want to use these APIs as the
	format evolves.

	include/
		* sframe-api.h (sframe_decoder_get_version): New declaration.
		(sframe_encoder_get_version): Likewise.

	libsframe/
		* libsframe/libsframe.ver: Add new APIs.
		* libsframe/sframe.c (sframe_decoder_get_version): New
		definition.
		(sframe_encoder_get_version): Likewise.

2023-06-29  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: fix sframe_find_fre for pltN entries
	For a toy application on x86_64, for example, following is the SFrame
	stack trace information for the 3 pltN entries of 16 bytes each:

	   func idx [1]: pc = 0x401030, size = 48 bytes
	   STARTPC[m]      CFA       FP        RA
	   0000000000000000  sp+8      u         u
	   000000000000000b  sp+16     u         u

	The data in first column is the start_ip_offset.  Also note that the FDE
	is of type SFRAME_FDE_TYPE_PCMASK (denoted by the [m] on LHS).

	Where each pltN (note: excluding plt0 entry) entry looks like:

	  401030: jmp    *0x2fca(%rip)
	  401036: push   $0x0
	  40103b: jmp    401020<_init+0x20>

	  401040: jmp    *0x2fc2(%rip)
	  401046: push   $0x1
	  40104b: jmp    401020<_init+0x20>

	  401050: jmp    *0x2fba(%rip)
	  401056: push   $0x2
	  40105b: jmp    401020<_init+0x20>

	Now, to find SFrame stack trace information from an FDE of type
	SFRAME_FDE_TYPE_PCMASK, sframe_find_fre () was doing an operation
	like,
	  (start_ip_offset & 0xf) >= (pc & 0xf)

	This works for pltN entry of size, say, less than 16 bytes.  But if the
	pltN entries or similar code stubs (for which SFrame FDE of type
	SFRAME_FDE_TYPE_PCMASK may be used), evolve to be of size > 16 bytes,
	this will cease to work.

	To match the range covered by the SFrame FRE, one should instead perform
	a modulo operation.  The constant for the modulo operation must be the
	size of the pltN entry.  Further, this constant should ideally be
	encoded in the format, as it may be different for each ABI.

	In SFrame Version 2 of the format, we will move towards encoding it
	explicitly in the SFrame FDE.  For now, fix up the logic to at least
	move towards modulo operation.

	libsframe/
		* sframe.c (sframe_fre_check_range_p): New definition.
		(sframe_find_fre): Refactor a bit and use the new definition
		above.
	include/
		* sframe.h (SFRAME_FDE_TYPE_PCMASK): Update comment.
	libsframe/doc/
		* sframe-spec.texi: Fix the text for SFRAME_FDE_TYPE_PCMASK FDE
		type.

2023-06-29  H.J. Lu  <hjl.tools@gmail.com>

	ld: Add -z nosectionheader test to bootstrap.exp
		PR ld/25617
		* testsuite/ld-bootstrap/bootstrap.exp: Add -z nosectionheader
		test.

2023-06-29  H.J. Lu  <hjl.tools@gmail.com>

	ld: Add tests for -z nosectionheader and --strip-section-headers
	Add tests to verify that the linker option, -z nosectionheader and
	objcopy and strip option, --strip-section-headers, work correctly as well
	as linker issues an error when dynamic symbol table from PT_DYNAMIC
	segment is used.

		PR ld/25617
		* testsuite/ld-elf/hash-2.d: New file.
		* testsuite/ld-elf/no-section-header.exp: Likewise.
		* testsuite/ld-elf/pr25617-1-no-sec-hdr.nd: Likewise.
		* testsuite/ld-elf/pr25617-1-no-sec-hdr.rd: Likewise.
		* testsuite/ld-elf/pr25617-1-static-no-sec-hdr.rd: Likewise.
		* testsuite/ld-elf/pr25617-1a-no-sec-hdr.nd: Likewise.
		* testsuite/ld-elf/pr25617-1a-no-sec-hdr.rd: Likewise.
		* testsuite/ld-elf/pr25617-1a-sec-hdr.rd: Likewise.
		* testsuite/ld-elf/pr25617-1a.c: Likewise.
		* testsuite/ld-elf/pr25617-1b.c: Likewise.
		* testsuite/ld-elf/start-noheader.rd: Likewise.
		* testsuite/ld-elf/start-shared-noheader-gnu.rd: Likewise.
		* testsuite/ld-elf/start-shared-noheader-sysv.rd: Likewise.
		* testsuite/ld-elf/start-shared-noheader.nd: Likewise.

2023-06-29  H.J. Lu  <hjl.tools@gmail.com>

	binutils: Add a --strip-section-headers test
		PR ld/25617
		* testsuite/binutils-all/objcopy.exp: Run strip-section-headers-1.
		* testsuite/binutils-all/strip-section-headers-1.d: New file.

2023-06-29  Kaylee Blake  <klkblake@gmail.com>

	ld: Add simple tests for -z nosectionheader
	2020-06-06  Kaylee Blake  <klkblake@gmail.com>
		    H.J. Lu  <hongjiu.lu@intel.com>

		PR ld/25617
		* testsuite/ld-elf/nosectionheader-1.d: New file.
		* testsuite/ld-elf/nosectionheader-2.d: Likewise.

2023-06-29  H.J. Lu  <hjl.tools@gmail.com>

	bfd: Improve nm and objdump without section header
	When there is no section header in an executable or shared library, we
	reconstruct dynamic symbol table from the PT_DYNAMIC segment, which
	contains DT_HASH/DT_GNU_HASH/DT_MIPS_XHASH, DT_STRTAB, DT_SYMTAB,
	DT_STRSZ, and DT_SYMENT entries, to improve nm and objdump.  For DT_HASH,
	the number of dynamic symbol table entries equals the number of chains.
	For DT_GNU_HASH/DT_MIPS_XHASH, only defined symbols with non-STB_LOCAL
	indings are in hash table.  Since DT_GNU_HASH/DT_MIPS_XHASH place all
	symbols with STB_LOCAL binding before symbols with other bindings and
	all undefined symbols defined ones in dynamic symbol table, the highest
	symbol index in DT_GNU_HASH/DT_MIPS_XHASH is the highest dynamic symbol
	table index.  We can also get symbol version from DT_VERSYM, DT_VERDEF
	and DT_VERNEED entries.

	dt_symtab, dt_versym, dt_verdef, dt_verneed, dt_symtab_count,
	dt_verdef_count, dt_verneed_count and dt_strtab are added to
	elf_obj_tdata to store dynamic symbol table information.

		PR ld/25617
		* elf-bfd.h (elf_obj_tdata): Add dt_symtab, dt_verdef, dt_verneed,
		dt_symtab_count, dt_verdef_count, dt_verneed_count and dt_strtab.
		(elf_use_dt_symtab_p): New.
		(_bfd_elf_get_dynamic_symbols): Likewise.
		(_bfd_elf_get_section_from_dynamic_symbol): Likewise.
		* elf.c (bfd_elf_get_elf_syms): Use dynamic symbol table if
		neeeded.
		(_bfd_elf_get_dynamic_symtab_upper_bound): Likewise.
		(_bfd_elf_slurp_version_tables): Likewise.
		(offset_from_vma): New function.
		(get_hash_table_data): Likewise.
		(_bfd_elf_get_dynamic_symbols): Likewise.
		(_bfd_elf_get_section_from_dynamic_symbol): Likewise.
		(_bfd_elf_get_symbol_version_name): Likewise.
		* elfcode.h (elf_object_p): Call _bfd_elf_get_dynamic_symbols
		to reconstruct dynamic symbol table from PT_DYNAMIC segment if
		there is no section header.
		(elf_slurp_symbol_table): Use dynamic symbol table if neeeded.
		Don't free isymbuf when dynamic symbol table is used.
		* elflink.c (elf_link_is_defined_archive_symbol): Return wrong
		format error when dynamic symbol table is used.
		(elf_link_add_object_symbols): Likewise.

2023-06-29  H.J. Lu  <hjl.tools@gmail.com>

	ELF: Discard non-alloc sections without section header
	Discard non-alloc sections when section headers are stripped.

	bfd/

		PR ld/25617
		* elf.c (_bfd_elf_assign_file_positions_for_non_load): Skip
		non-load sections without section header.
		(_bfd_elf_write_object_contents): Don't set the sh_name field
		without section header.  Write out the .shstrtab section only
		if its sh_offset field isn't -1.

	binutils/

		PR ld/25617
		* objcopy.c (is_strip_section_1): Remove non-alloc sections for
		--strip-section-headers.

	ld/

		PR ld/25617
		* ldlang.c (lang_discard_section_p): Discard non-alloc sections
		if we are stripping section headers.

2023-06-29  Kaylee Blake  <klkblake@gmail.com>

	ELF: Strip section header in ELF objects
	Section header isn't mandatory on ELF executable nor shared library.
	This patch adds a new linker option, -z nosectionheader, to omit ELF
	section header, a new objcopy and strip option, --strip-section-headers,
	to remove ELF section headers.

	bfd/

	2023-06-06  H.J. Lu  <hongjiu.lu@intel.com>
		    Kaylee Blake  <klkblake@gmail.com>

		PR ld/25617
		* bfd.c (BFD_NO_SECTION_HEADER): New.
		(BFD_FLAGS_SAVED): Add BFD_NO_SECTION_HEADER.
		(BFD_FLAGS_FOR_BFD_USE_MASK): Likewise.
		* elfcode.h (elf_swap_ehdr_out): Omit section header with
		BFD_NO_SECTION_HEADER.
		(elf_write_shdrs_and_ehdr): Likewise.
		* elfxx-target.h (TARGET_BIG_SYM): Add BFD_NO_SECTION_HEADER
		to object_flags.
		(TARGET_LITTLE_SYM): Likewise.
		* bfd-in2.h: Regenerated.

	binutils/

	2023-06-06  H.J. Lu  <hongjiu.lu@intel.com>

		PR ld/25617
		* NEWS: Mention --strip-section-headers for objcopy and strip.
		* objcopy.c (strip_section_headers): New.
		(command_line_switch): Add OPTION_STRIP_SECTION_HEADERS.
		(strip_options): Add --strip-section-headers.
		(copy_options): Likewise.
		(copy_usage): Add --strip-section-headers.
		(strip_usage): Likewise.
		(copy_object): Handle --strip-section-headers for ELF files.
		(strip_main): Handle OPTION_STRIP_SECTION_HEADERS.
		(copy_main): Likewise.
		* doc/binutils.texi: Document --strip-section-headers for objcopy
		and strip.

	ld/

	2023-06-06  H.J. Lu  <hongjiu.lu@intel.com>
		    Kaylee Blake  <klkblake@gmail.com>

		PR ld/25617
		* NEWS: Mention -z nosectionheader.
		* emultempl/elf.em: Support -z sectionheader and
		-z nosectionheader.
		* ld.h (ld_config_type): Add no_section_header.
		* ld.texi: Document -z sectionheader and -z nosectionheader.
		* ldlang.c (ldlang_open_output): Handle
		config.no_section_header.
		* lexsup.c (parse_args): Enable --strip-all with
		-z nosectionheader.  Disallow -r with -z nosectionheader.
		(elf_static_list_options): Add -z sectionheader and
		-z nosectionheader.

2023-06-29  Matthias Klose  <doko@debian.org>

	Ignore --prefix-file-map compiler option whist running testsuite.

	ignore lto-wrapper warnings for lto builds.
	  I see these warnings from time to time, when configuring a build with  --enable-pgo-build=lto, I haven't yet found out why I see these sometime, and  why not. E.g. https://gcc.gnu.org/PR109241. Just ignore these when they appear  in test cases. lto-wrapper: warning: using serial compilation of N LTRANS jobs

2023-06-29  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-06-28  Vladimir Mezentsev  <vladimir.mezentsev@oracle.com>

	gprofng: Add new tests
	gprofng/ChangeLog
	2023-06-26  Vladimir Mezentsev  <vladimir.mezentsev@oracle.com>

		* Makefile.am: Pass CLOCK_GETTIME_LINK to the testsuite
		* Makefile.in: Rebuild.
		* testsuite/gprofng.display/gp-archive.exp: New file.
		* testsuite/gprofng.display/gp-collect-app_F.exp: New file.
		* testsuite/gprofng.display/setpath_map.exp: New file.
		* testsuite/lib/smalltest.c: New file.

2023-06-28  Andrew Carlotti  <andrew.carlotti@arm.com>

	aarch64: Remove version dependencies from features
	Many instructions were enabled only when both a feature flag and a minimum
	architecture version are specified.  This behaviour differs from GCC, which (in
	most cases) allows features to be enabled at any architecture version.

	There is no need for the toolchain to restrict combinations of unrelated
	features in this way, so this patch removes the unnecessary dependencies.

2023-06-28  Tom Tromey  <tromey@adacore.com>

	Remove Python 2 from gdb documentation
	GDB can't be built using Python 2 any more, so remove the remaining
	vestiges of this from the documentation.

	Approved-By: Eli Zaretskii <eliz@gnu.org>

2023-06-28  Michael Matz  <matz@suse.de>

	section-match: Check parent archive name as well
	rewriting the section matching routines lost a special case
	of matching: section statements of the form

	    NAME(section-glob)

	normally match against NAME being an object file, but like in
	the exclude list we happened to accept archive names as NAME
	(undocumented).  The documented way to specify (all) archive members
	is by using e.g.

	    lib.a:(section-glob)

	(that does work also with the prefix tree matcher).

	But I intended to not actually change behaviour with the prefix
	tree implementation.  So, let's also implement checking against
	archive names with a similar FIXME comment we already have in
	walk_wild_file_in_exclude_list.

		PR 30590

		ld/
		* ldlang.c (walk_wild_section_match): Also look at archive
		parents for a name match.

2023-06-28  Tom Tromey  <tromey@adacore.com>

	Fix handling of DW_TAG_unspecified_type for Ada
	Commit 80eaec735e ("[gdb/symtab] Handle named DW_TAG_unspecified_type
	DIE") changed the handling of DW_TAG_unspecified_type.  Before this
	change, such types were not entered into the symbol table.

	It turns out that, when such a type is in the symtab, it can cause
	failures in Ada.  In particular, a private type in another package may
	be seen locally as "void".

	Now, it would probably be better to fix this via check_typedef.
	However, that is somewhat difficult given the state of the DWARF
	reader -- in particular with gdb_index, this would require expanding
	potentially many CUs to find the correct type.

	Instead, this patch changes gdb to not enter a symbol for an
	unspecified type -- but only for Ada.

2023-06-28  Tom Tromey  <tromey@adacore.com>

	Remove some Python 2 code
	I found some Python 2 compatibility code in gdb's Python library.
	There's no need for this any more, so this removes it.  There is still
	a bit more of this remaining in __init__.py, but I haven't tried
	removing that yet.

	Reviewed-By: Bruno Larsen <blarsen@redhat.com>

2023-06-28  Nick Clifton  <nickc@redhat.com>

	Stop the linker's --dependency-file option from including temporary lto files.
	  PR 30568
	  * ldfile.c (ldfile_try_open_bfd): Do not track lto generated temporary files.

	Updated French translation for the gold sub-directory

2023-06-28  mengqinggang  <mengqinggang@loongson.cn>

	LoongArch: gas: Add LSX and LASX instructions test
	gas/ChangeLog:

		* testsuite/gas/loongarch/vector.d: New test.
		* testsuite/gas/loongarch/vector.s: New test.

2023-06-28  mengqinggang  <mengqinggang@loongson.cn>

	LoongArch: gas: Add lsx and lasx instructions support
	gas/ChangeLog:

		* config/tc-loongarch.c (md_parse_option): Add lsx and lasx option.
		(loongarch_after_parse_args): Add lsx and lasx option.

	opcodes/ChangeLog:

		* loongarch-opc.c (struct loongarch_ase): Add lsx and lasx
		instructions.

2023-06-28  mengqinggang  <mengqinggang@loongson.cn>

	LoongArch: Add R_LARCH_64_PCREL relocation support
	  Gas defaults to emit R_LARCH_ADD64/R_LARCH_SUB64 unless explcitly declared
	  to emit R_LARCH_64_PCREL.

	  The LoongArch ABI at here:
	    https://github.com/loongson/la-abi-specs/blob/release/la-abi.adoc

	bfd/ChangeLog:

		* bfd-in2.h (not): Add R_LARCH_64_PCREL
		* elfnn-loongarch.c (perform_relocation): Likewise.
		* elfxx-loongarch.c: Likewise.
		* libbfd.h: Likewise.
		* reloc.c: Likewise.

	gas/ChangeLog:

		* config/tc-loongarch.c (loongarch_args_parser_can_match_arg_helper):
		(md_apply_fix): Add R_LARCH_64_PCREL.
		* testsuite/gas/loongarch/64_pcrel.d: New test.
		* testsuite/gas/loongarch/64_pcrel.s: New test.

	include/ChangeLog:

		* elf/loongarch.h (RELOC_NUMBER): Add R_LARCH_64_PCREL.

	ld/ChangeLog:

		* testsuite/ld-loongarch-elf/ld-loongarch-elf.exp: Add test.
		* testsuite/ld-loongarch-elf/64_pcrel.d: New test.
		* testsuite/ld-loongarch-elf/64_pcrel.s: New test.

2023-06-28  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-06-27  Indu Bhagat  <indu.bhagat@oracle.com>

	binutils/NEWS: add note about upcoming libsframe changes
	Some of these changes update the ABI in an incompatible way.

2023-06-27  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: bfd: use uint32_t for return type of get_num_fidx APIs
	Keep the data types usage in libsframe look consistent.

	bfd/
		* elf-sframe.c (_bfd_elf_merge_section_sframe): Use uint32_t
		type alias.
		* libsframe/sframe.c (sframe_decoder_get_funcdesc_at_index):
		Likewise.
		(sframe_decoder_get_num_fidx): Likewise.
		(sframe_encoder_get_num_fidx): Likewise.
	include/
		* sframe-api.h (sframe_decoder_get_num_fidx): Likewise.
		(sframe_encoder_get_num_fidx): Likewise.

2023-06-27  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: use appropriate data types for args of sframe_encode
	include/
		* sframe-api.h (sframe_encode): Use of uint8_t is more
		appropriate.
	libsframe/
		* sframe.c (sframe_encode): Likewise.

2023-06-27  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: use uint8_t for return type of sframe_fre_get_base_reg_id
	Use a more appropriate data type.

	include/
		* sframe-api.h (sframe_fre_get_base_reg_id): Use uint8_t as
		return type.
	libsframe/
		* sframe-dump.c (dump_sframe_func_with_fres): Use uint8_t type
		for base reg id.
		* sframe.c (sframe_fre_get_base_reg_id): Use uin8_t as return
		type.

2023-06-27  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: use uint8_t instead of unsigned char for abi_arch
	Use uint8_t consistently for identifying ABI/arch in SFrame format.

	bfd/
		* elf-sframe.c (_bfd_elf_merge_section_sframe):
	libsframe/
		* sframe-dump.c (is_sframe_abi_arch_aarch64): Use uint8_t for
		local variable.
		* sframe.c (sframe_decoder_get_abi_arch): Update return type to
		uint8_t.
		(sframe_encoder_get_abi_arch): Likewise.
	include/
		* sframe-api.h (sframe_decoder_get_abi_arch): Likewise.
		(sframe_encoder_get_abi_arch): Likewise.

2023-06-27  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: bfd: use uint32_t for return type of sframe_calc_fre_type
	Use uint32_t type alias consistently for all APIs in libsframe.

	bfd/
		* elfxx-x86.c (_bfd_x86_elf_create_sframe_plt): Adjust for the
		changed return type.
	libsframe/
		* sframe.c (sframe_calc_fre_type): Use uint32_t for return type.
	include/
		* sframe-api.h (sframe_calc_fre_type): Likewise.

2023-06-27  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: use uint32_t for fre_type and fde_type function args
	The API sframe_fde_create_func_info is provided by libsframe.  Current
	users are the bfd linker.  Adjust the argument type for the variables
	carrying the SFrame FRE type and SFrame FDE type to consistenly use
	uint32_t type alias.

	include/
		* sframe-api.h (sframe_fde_create_func_info): Use uint32_t
		instead of unsigned int.
	libsframe/
		* sframe.c (sframe_get_fre_type): Likewise.
		(sframe_get_fde_type): Likewise.
		(flip_fre_start_address): Likewise.
		(sframe_fre_start_addr_size): Likewise.
		(sframe_fre_entry_size): Likewise.
		(flip_fre): Likewise.
		(flip_sframe): Likewise.
		(sframe_fde_create_func_info): Likewise.
		(sframe_calc_fre_type): Likewise.
		(sframe_decode_fre_start_address): Likewise.
		(sframe_decode_fre): Likewise.
		(sframe_find_fre): Likewise.
		(sframe_decoder_get_fre): Likewise.
		(sframe_encoder_add_fre): Likewise.
		(sframe_encoder_write_fre_start_addr): Likewise.
		(sframe_encoder_write_fre): Likewise.
		(sframe_encoder_write_sframe): Likewise.

2023-06-27  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: update the semantics of sframe_fre_get_fp_offset
	Until now, sframe_fre_get_fp_offset () would return
	SFRAME_ERR_FREOFFSET_NOPRESENT if the ABI uses fixed FP offset.  A stack
	tracer, then, would call an explicit sframe_decoder_get_fixed_fp_offset ()
	to get the FP offset.

	On second look, it appears to make sense to hide these details of
	whether the FP offset is fixed or not in an ABI from the consumer.  Now,
	with the changed semantics, the call to sframe_fre_get_fp_offset () will
	fetch the fixed FP offset if applicable, or get the FP offset from FRE
	when there is no fixed FP offset.

	This patch changes the behavior of sframe_fre_get_fp_offset (): it turns
	an error into non-error.  This change will be included with the next
	release of libsframe, where all the exposed symbols will be versioned
	with version node LIBSFRAME_1.0 for the first time.

	libsframe/
		* sframe.c (sframe_fre_get_fp_offset): Return the fixed offset, if
		applicable. Else return the FP offset from the FRE.

2023-06-27  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: update the semantics of sframe_fre_get_ra_offset
	Until now, sframe_fre_get_ra_offset () would return
	SFRAME_ERR_FREOFFSET_NOPRESENT if the ABI uses fixed RA offset (e.g.,
	AMD64).  A stack tracer, then, will call an explicit
	sframe_decoder_get_fixed_ra_offset () to get the RA offset.

	On second look, it appears to make sense to hide these details of
	whether the RA offset is fixed or not from the consumer.  Now, with the
	changed semantics, the call to sframe_fre_get_ra_offset () will fetch
	the fixed RA offset if applicable, or get the RA offset from FRE when
	there is no fixed RA offset.

	Adjustments need to be made to ensure the textual dump remains the same
	as preivous.  Currently, e.g., if RA is not being tracked per FRE,
	following is seen with objdump --sframe:

	    STARTPC         CFA       FP        RA
	    000000000000NNNN  sp+X      u         u

	This patch changes the behavior of sframe_fre_get_ra_offset: it turns an
	error into non-error.  This change will be included with the next
	release of libsframe, where all exposed symbols will be versioned for
	the first time.

	libsframe/
		* sframe.c (sframe_fre_get_ra_offset): Return the fixed offset,
		if applicable.  Else return the RA offset from the FRE.
		* sframe-dump.c (dump_sframe_func_with_fres): Make adjustments
		to keep the textual dump same as previous.

2023-06-27  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: add symbol versioning
	Define an empty base version LIBSFRAME_0.0 and add all symbols to
	version LIBSFRAME_1.0.

	The previous release of libsframe (libsframe.so.0) did not have
	versioned symbols.  Adding a libsframe.ver file so that future releases
	of the library (and its consumers) can manage the changes better.

	For Solaris ld, use -M mapfile command line option.  libsframe does not
	restrict the set of exported symbols, so at this time there is no need
	to fall back on the libtool's -export-symbols option for platforms where
	some other linker (with a different command line option for symbol
	versioning) may be used.

	libsframe/
		* Makefile.am: Use symbol versioning for libsframe.
		* Makefile.in: Regenerated.
		* configure: Check for Solaris ld.
		* configure.ac: Regenerated.
		* libsframe.ver: New file.

2023-06-27  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: remove sframe_get_funcdesc_with_addr API
	This is an incompatible ABI change in libsframe.

	The interface provided by this function is not a healthy abstraction to
	expose: the return type sframe_func_desc_entry, which is defined in
	include/sframe.h (the SFrame binary format definition).  This ties up
	the library in a undesirable way.  Most importantly, this function
	should technically not be directly necessary for a stack tracer.  A
	stack tracer will likely only need to do a sframe_find_fre ().

	Rename the API to continue to use the functionality internally in the
	library.  bfd/linker does not use this function.

	Change the return type of the previous definition and make a note about
	its planned deprecation.

	include/
		* sframe-api.h:  Change return type of sframe_get_funcdesc_with_addr.
		Add comment for intention to deprecate.
	libsframe/
		*sframe.c (sframe_get_funcdesc_with_addr): Change return type
		and set error code. This API is deprecated.
	        (sframe_get_funcdesc_with_addr_internal): New definition for
		internal use.
		(sframe_find_fre): Use sframe_get_funcdesc_with_addr_internal
		instead.

2023-06-27  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: add library versioning
	lisbframe was first released with Bintuils 2.40.  As the library
	evolves, some changes will break the ABI.  Add library versioning for
	users to manage these changes.

	For the next release of the library (libsframe.so.1), incompatible ABI
	changes are planned. These will include:
	 - Deprecation of some APIs, like sframe_get_funcdesc_with_addr (), and
	 - Change in the contract of some APIs (e.g., return type, behavior).

	In libtool-version, set the current to 1 to prepare for the upcoming
	release.  Reset revision and age to 0.

	Add libtool-version file to EXTRA_DIST.

	libsframe/
		* Makefile.am: Use libtool versioning.
		* Makefile.in: Regenerated.
		* libtool-version: New file.

2023-06-27  Philipp Tomsich  <philipp.tomsich@vrull.eu>

	    RISC-V: Support Zicond extension
	    This implements the Zicond (conditional integer operations) extension,
	    as of version 1.0-rc2.

	    The Zicond extension acts as a building block for branchless sequences
	    including conditional-arithmetic, conditional-logic and
	    conditional-select/move.
	    The following instructions constitute Zicond:
	      - czero.eqz rd, rs1, rs2  =>  rd = (rs2 == 0) ? 0 : rs1
	      - czero.nez rd, rs1, rs2  =>  rd = (rs2 != 0) ? 0 : rs1

	    See
	      https://github.com/riscv/riscv-zicond/releases/download/v1.0-rc2/riscv-zicond-v1.0-rc2.pdf
	    for the proposed specification and usage details.

	    bfd/ChangeLog:

	            * elfxx-riscv.c (riscv_multi_subset_supports): Recognize
	            INSN_CLASS_ZICOND.
	            (riscv_multi_subset_supports_ext): Recognize INSN_CLASS_ZICOND.

	    gas/ChangeLog:

	            * testsuite/gas/riscv/zicond.d: New test.
	            * testsuite/gas/riscv/zicond.s: New test.

	    include/ChangeLog:

	            * opcode/riscv-opc.h (MATCH_CZERO_EQZ): Define.
	            (MASK_CZERO_EQZ): Define.
	            (MATCH_CZERO_NEZ): Define,
	            (MASK_CZERO_NEZ): Define.
	            (DECLARE_INSN): Add czero.eqz and czero.nez.
	            * opcode/riscv.h (enum riscv_insn_class): Add
	            INSN_CLASS_ZICOND.

	    opcodes/ChangeLog:

	            * riscv-opc.c: Add czero.eqz and czero.nez.

	    Signed-off-by: Philipp Tomsich <philipp.tomsich@vrull.eu>

2023-06-27  Nick Clifton  <nickc@redhat.com>

	Add note about adding ChangeLog.git to src-release.sh

2023-06-27  Cui, Lili  <lili.cui@intel.com>

	gprofng: Update intel url
	Since the old software.intel.com has been removed, update a new one.

	gprofng/ChangeLog
	2023-06-27  Lili Cui  <lili.cui@intel.com>

		* gp-display-html/gp-display-html.in: Update intel url.

2023-06-27  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-06-26  Nick Clifton  <nickc@redhat.com>

	Fix gas tests for aarch64-pe

	Synchromize libiberty sources with master version in gcc repository

	Sync config.guess and config.sub with upstream master versions.

	Updated French translation for the gprof sub-directory

2023-06-26  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-06-25  Feiyang Chen  <chenfeiyang@loongson.cn>

	LoongArch: Support referring to FCSRs as $fcsrX
	Previously, FCSRs were referred to as $rX, which seemed strange.
	We refer to FCSRs as $fcsrX, which ensures compatibility with LLVM
	IAS as well.

	gas/ChangeLog:

	        * config/tc-loongarch.c:
	        (loongarch_fc_normal_name): New definition.
	        (loongarch_fc_numeric_name): New definition.
	        (loongarch_single_float_opcodes): Modify `movgr2fcsr` and
	        `movfcsr2gr`.
	        testsuite/gas/loongarch/float_op.d: Likewise.
	        testsuite/gas/loongarch/float_op.s: Likewise.

	include/ChangeLog:

	        * opcode/loongarch.h:
	        (loongarch_fc_normal_name): New extern.
	        (loongarch_fc_numeric_name): New extern.

	opcodes/ChangeLog:

	        * opcodes/loongarch-dis.c (loongarch_after_parse_args): Support
	        referring to FCSRs as $fcsrX.
	        * opcodes/loongarch-opc.c (loongarch_args_parser_can_match_arg_helper):
	        Likewise.

2023-06-25  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-06-24  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-06-23  Thiago Jung Bauermann  <thiago.bauermann@linaro.org>

	gdb/testsuite: Avoid infinite loop in gdb.reverse/step-reverse.exp
	This testcase sometimes gets stuck in a loop for hours when running in our
	CI.  The problem is that due to an issue unrelated to reverse debugging the
	inferior exits early, and because of the overly generic ".*" pattern the
	testcase keeps sending the "next" command without noticing that the
	inferior is gone.

	gdb_test_multiple has a pattern to detect that "The program is not being
	run.", but since it is placed after the patterns from the caller it won't
	be triggered.  It also has a timeout pattern but because it is triggered
	between successful matches, each time the test matches the '-re -wrap ".*"'
	this counts as a successful match and the timeout is reset.

	Since the test binary is compiled with debug information, fix by changing
	one of the generic patterns to match entering the main function and the
	other one to match the source code line number that is shown by GDB right
	after the "step" command.

	Also, as a precaution add a maximum number of times the "next" command will
	be sent.

	Co-Authored-By: Tom de Vries <tdevries@suse.de>
	Reviewed-By: Bruno Larsen <blarsen@redhat.com>
	Approved-By: Tom de Vries <tdevries@suse.de>

2023-06-23  Alan Modra  <amodra@gmail.com>

	[GOLD] PowerPC64 huge branch dynamic relocs
	PowerPC64 gold and ld.bfd implement an indirect branch trampoline,
	used when the destination of a branch exceeds a bounce through another
	"b" instruction.  When generating PIEs or shared libraries, the
	addresses need dynamic relocations.  This was implemented in gold
	using a dedicated relocation section, but this means the relative
	relocations for these addresses are not sorted properly with other
	dynamic relative relocations: gold doesn't support merging relocation
	sections, then sorting.  Instead we need to use a single .rela.dyn
	section.

	This is done by increasing the size of rela_dyn_ during do_relax to
	account for needed dynamic relocations, delaying adding the actual
	relocations until the end of relaxation once the layout has
	stabilised.

		* powerpc.cc (Target_powerpc): Add rela_dyn_size_;
		(update_current_size): New function.
		(Target_powerpc::do_relax): Capture the size of rela_dyn_ at
		the start of relaxation.  Artifically increase its size during
		relaxation to account for needed indirect branches, and add
		those relocations at the end.
		(Output_data_brlt_powerpc::rel_, reset_brlt_sizes),
		(finalize_brlt_sizes, add_reloc, set_current_size): Delete.
		(Target_powerpc::make_brlt_section): Don't make reloc section.

2023-06-23  Alan Modra  <amodra@gmail.com>

	[GOLD] Support setting DT_RELACOUNT late
	PowerPC gold adds relative dynamic relocs in do_relax.  These aren't
	accounted for in the value set in add_target_dynamic_tags, which is
	called before do_relax.  Provide a way of setting DT_RELCOUNT and
	DT_RELACOUNT at the point where .dynamic is written.

		* layout.cc (Layout::add_target_dynamic_tags): Add custom_relcount
		parameter.  Emit DT_RELCOUNT/RELACOUNT as a custom target handled
		dynamic tag if set.
		* layout.h(Layout::add_target_dynamic_tags): Update prototype.
		* aarch64.cc (Target_aarch64::do_finalize_sections): Adjust
		add_target_dynamic_tags call.
		* arm.cc (Target_arm::do_finalize_sections): Likewise.
		* i386.cc (Target_i386::do_finalize_sections): Likewise.
		* mips.cc (Target_mips::do_finalize_sections): Likewise.
		* s390.cc (Target_s390::do_finalize_sections): Likewise.
		* sparc.cc (Target_sparc::do_finalize_sections): Likewise.
		* tilegx.cc (Target_tilegx::do_finalize_sections): Likewise.
		* x86_64.cc (Target_x86_64::do_finalize_sections): Likewise.
		* powerpc.cc (Target_powerpc::do_finalize_sections): Likewise.
		(Target_powerpc::do_dynamic_tag_custom_value): New function.

2023-06-23  Alan Modra  <amodra@gmail.com>

	[GOLD] powerpc DT_RELACOUNT
	DT_RELACOUNT was calculated incorrectly, and relative relocs not
	sorted as they should be to the start of .rela.dyn, due to adding one
	particular class of dynamic reloc using the wrong "add" method.

		* powerpc.cc (Target_powerpc::Scan::global): Add relative
		dyn relocs for ADDR64 and similar using add_global_relative.

2023-06-23  Alan Modra  <amodra@gmail.com>

	lto test fails with -fno-inline in CFLAGS
	Putting -fno-inline in CFLAGS results in these failures.
	FAIL: Build liblto-17b.so 1
	FAIL: PR ld/12365
	FAIL: PR ld/13183

		* ld-plugin/lto.exp: Add -finline to compiler flags in some tests.

2023-06-23  Tom Tromey  <tom@tromey.com>

	Fix off-by-one error
	Simon pointed out that commit a2bbca9fa5e ("Use std::vector<bool> for
	agent_expr::reg_mask") caused a regression in libstdc++ debug mode.
	This was due to an off-by-one error in a vector resize.  This patch
	fixes the problem.

2023-06-23  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-06-22  Ilya Leoshkevich  <iii@linux.ibm.com>

	gdb/testsuite: fix gdb.python/py-unwind.exp with python >= 3.11
	Python 3.11 changed the AttributeError message - see commit
	0cb765b2cec9 ("bpo-46730: Add more info to @property AttributeError
	messages (GH-31311)").  Add the new message to the expectations.

	Approved-By: Tom Tromey <tom@tromey.com>
	Link: https://sourceware.org/pipermail/gdb-patches/2023-June/200433.html

2023-06-22  H.J. Lu  <hjl.tools@gmail.com>

	Revert "x86: Don't check if AVX512 template requires AVX512VL"
	This reverts commit c7face14225296a2f5d3ebeb8ace88c166d80c3e.

2023-06-22  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Clean or check standard_output_file dir in gdb_init
	In commit e2adba909e7 ("[gdb/testsuite] Clean up before compilation in
	gdb.ada/call-no-debug.exp") I added some code in the test-case to remove some
	files at the start of the test-case:
	...
	remote_file host delete [standard_output_file prog.o]
	remote_file host delete [standard_output_file prog.ali]
	...

	Then in commit b7b77500dc5 ("[gdb/testsuite] Clean standard_output_file dir in
	gdb_init") I tried to do this more structurally, by cleaning up the entire
	standard_output_file directory, for all test-cases.

	This caused a regression when using "make check -j 2", due to the cleanup
	removing the active gdb.log, so I reverted the commit.

	Try again, this time handling the two cases separately.

	If the standard_output_file directory contains an active gdb.log, check that
	the directory contains no files other than gdb.log and gdb.sum.  This puts
	the reponsibility for the cleanup at the callers in gdb/testsuite/Makefile.in
	which use --outdir.

	If the standard_output_file directory doesn't contain an active gdb.log, clean
	it by removing the entire directory.

	An exception is made for performance tests, where cleaning up the
	standard_output_file dir is the wrong thing to do, because an invocation with
	GDB_PERFTEST_MODE == run is intended to reuse binaries left there by an
	earlier invocation with GDB_PERFTEST_MODE == compile.

	Tested on x86_64-linux.

	Suggested-By: Tom Tromey <tom@tromey.com>
	Reviewed-By: Tom Tromey <tom@tromey.com>
	Tested-By: Luis Machado <luis.machado@arm.com>

2023-06-22  Tom Tromey  <tromey@adacore.com>

	Implement DAP "hover" context
	A DAP client can request that an expression be evaluated in "hover"
	context, meaning that it should not cause side effects.  In gdb, this
	can be implemented by temporarily setting a few "may-" parameters to
	"off".

	In order to make this work, I had to also change "may-write-registers"
	so that it can be changed while the program is running.  I don't think
	there was any reason for this prohibition in the first place.

	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=30476

2023-06-22  Tom Tromey  <tromey@adacore.com>

	Implement DAP logging breakpoints
	DAP allows a source breakpoint to specify a log message.  When this is
	done, the breakpoint acts more like gdb's dprintf: it logs a message
	but does not cause a stop.

	I looked into implement this using dprintf with the new %V printf
	format.  However, my initial attempt at this did not work, because
	when the inferior is continued, the dprintf output is captured by the
	gdb.execute call.  Maybe this could be fixed by having all
	inferior-continuation commands use the "&" form; the main benefit of
	this would be that expressions are only parsed a single time.

2023-06-22  Tom Tromey  <tromey@adacore.com>

	Handle supportsVariablePaging in DAP
	A bug report about the supportsVariablePaging capability in DAP
	resulted in a clarification: when this capability is not present, DAP
	implementations should ignore the paging parameters to the "variables"
	request.  This patch implements this clarification.

	Implement type checking for DAP breakpoint requests
	I realized that with a small refactoring, it is possible to type-check
	the parameters to the various DAP breakpoint requests.  This would
	have caught the earlier bug involving hitCondition.

	Handle exceptions when creating DAP breakpoints
	When creating a DAP breakpoint, a failure should be returned by
	setting "verified" to False.  gdb didn't properly implement this, and
	there was a FIXME comment to this effect.  This patch fixes the
	problem.

	Reuse breakpoints more frequently in DAP
	The DAP breakpoint code tries to reuse a breakpoint when possible.
	Currently it uses the condition and the hit condition (aka ignore
	count) when making this determination.  However, these attributes are
	just going to be reset anyway, so this patch changes the code to
	exclude these from the reuse decision.

	Fix type of DAP hitCondition
	DAP specifies a breakpoint's hitCondition as a string, meaning it is
	an expression to be evaluated.  However, gdb implemented this as if it
	were an integer instead.  This patch fixes this oversight.

2023-06-22  Simon Farre  <simon.farre.cx@gmail.com>

	gdb/DAP Few bug fixes & Evaluate Array Watch vars
	v2.

	EvaluateResult does not need a name, just as what Tom pointed out in
	previous review. It's only the *children* that need to be made sure that
	their names are valid. An identifier for a variable, can't ever have an
	integer as a name, anyhow (not as far as I am aware, no programming
	languages allow for that).

	Removed the f-strings and use str() instead as pointed out that
	f-strings might not be supported fully.

	v1.

	This patch fixes a few bugs.

	First of all, name of VariableReferences must always be of string type.
	This patch makes sure that this is the case by formatting the name. If
	(when) the name is an integer, this will cause clients to fail or throw
	errors.

	Fixes a bug in NoOpArrayPrinter that calculated children to be N, but
	only ever retrieves N-1 children, which makes Python at some time later
	(during fetch_children -> fetch_one_child(N) ) raise an exception (out
	of list index) which makes the entire request go bad.

	The result[self.result_name] also f-strings the printer.to_string()
	value, because this can potentially be a LazyString (which is a Python
	object, not a string) and is not serializable by json.dumps.

	Approved-By: Tom Tromey <tom@tromey.com>

2023-06-22  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-06-21  H.J. Lu  <hjl.tools@gmail.com>

	x86: Free the symbol buffer and the relocation buffer after use
	When --no-keep-memory is used, the symbol buffer and the relocation
	buffer aren't cached.  When packing relative relocations, we may
	allocate a new symbol buffer and a new relocation buffer for each
	eligible section in an object file.  If there are many sections,
	memory may be exhausted.  In this case, we should free the symbol
	buffer and the relocation buffer after use.  If symbol buffer entries
	are used to track relative relocations against local symbols for later
	use, the symbol buffer should be cached.

		PR ld/30566
		* elfxx-x86.c (elf_x86_relative_reloc_record_add): Add an
		argument to inform caller if the symbol buffer should be kept.
		(_bfd_x86_elf_link_relax_section): Call
		_bfd_elf_link_info_read_relocs instead of
		_bfd_elf_link_read_relocs.  Free the symbol buffer and the
		relocation buffer after use.  Cache the symbol buffer if it
		is used.

2023-06-21  Tom Tromey  <tromey@adacore.com>

	Add missing backslash to update-gnulib.sh
	A user on irc noticed a missing backslash on one line in
	update-gnulib.sh.  This patch adds it.

	Re-running update-gnulib.sh causes a few copyright notices to change.
	Presumably these are from upstream gnulib and shouldn't be touched by
	our yearly update.  I've updated the script to account for this, but I
	did not want to try testing it...

2023-06-21  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Add have_host_locale
	With test-case gdb.tui/pr30056.exp, I run into:
	...
	sh: warning: setlocale: LC_ALL: cannot change locale (C.UTF-8)^M
	...
	and then subsequently into:
	...
	WARNING: timeout in accept_gdb_output
	FAIL: gdb.tui/pr30056.exp: Control-C
	...

	This is on a CentOS 7 distro for powerpc64le.

	Either it has no C.UTF-8 support, or it's not installed:
	...
	$ locale -a | grep ^C
	C
	$
	...

	Fix this by:
	- adding a new proc have_host_locale, and
	- using it in all test-cases using setenv LC_ALL.

	Tested on powerpc64le-linux and x86_64-linux.

2023-06-21  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Fix gdb.tui/wrap-line.exp
	PR testsuite/30458 reports the following FAIL:
	...
	PASS: gdb.tui/wrap-line.exp: width-auto-detected: cli: wrap
	^CQuit
	(gdb) WARNING: timeout in accept_gdb_output
	Screen Dump (size 50 columns x 24 rows, cursor at column 6, row 3):
	    0 Quit
	    1 (gdb) 7890123456789012345678901234567890123456789
	    2 W^CQuit
	    3 (gdb)
	  ...
	FAIL: gdb.tui/wrap-line.exp: width-auto-detected: cli: prompt after wrap
	...

	The problem is that the regexp doesn't account for the ^C:
	...
	    gdb_assert { [Term::wait_for "^WQuit"] } "prompt after wrap"
	...

	The ^C occurs occasionally.  This is something we'd like to fix.  It's
	reported as a readline problem here (
	https://lists.gnu.org/archive/html/bug-readline/2023-06/msg00000.html ).

	For now, fix this by updating the regexp, and likewise in another place in the
	test-case where we use ^C.

	Tested on x86_64-linux.

	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=30458

2023-06-21  Alan Modra  <amodra@gmail.com>

	PR30536, ppc64el gold linker produces unusable clang-16 binary
	In commit 0961e631575b, the fix for PR30217, make_lplt_section and
	make_brlt_section were changed to use rela_dyn_ rather than their own
	separate dynamic reloc sections.  This fails miserably whenever brlt_
	is needed for long branches, due to needing to iterate sizing and thus
	reset brlt_ sizes.

		PR 30536
		PR 30217
		* powerpc.cc (Target_powerpc::make_brlt_section): Don't use
		rela_dyn_.

2023-06-21  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Reimplement Term::command_no_prompt_prefix
	Say we run test-case gdb.tui/basic.exp.  It calls Term::enter_tui, which does:
	...
		command_no_prompt_prefix "tui enable"
	...

	The proc command_no_prompt_prefix is documented as:
	...
	    # As proc command, but don't wait for an initial prompt.  This is used for
	    # initial terminal commands, where there's no prompt yet.
	...

	Indeed, before the "tui enable" command, the tuiterm is empty, so there is no
	prompt and just before switching to TUI we have in the tuiterm:
	...
	tui enable
	...

	The reason that there is no prompt, is that:
	- in order for tuiterm to show something, its input processing procs need to
	  be called, and
	- the initial gdb prompt, and subsequent prompts generated by gdb_test-style
	  procs, are all consumed by those procs instead.

	This is in principle not a problem, but the absence of a prompt makes a
	tuiterm session look less like a session on an actual xterm.

	Add a new proc gen_prompt, that:
	- generates a prompt using echo
	- consumes the response before the prompt using gdb_expect
	- consumes the prompt using Term::wait_for "".

	This allows us to reimplement Term::command_no_prompt_prefix using
	Term::command, and just before switching to TUI we have in the tuiterm:
	...
	(gdb) tui enable
	...

	Tested on x86_64-linux.

2023-06-21  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Make Term::wait_for "" match only a prompt
	The semantics of Term::wait_for is:
	...
	    # Accept some output from gdb and update the screen.  WAIT_FOR is
	    # a regexp matching the line to wait for.  Return 0 on timeout, 1
	    # on success.
	    proc wait_for {wait_for} {
	...

	Note that besides the regexp, also a subsequent gdb prompt is matched.

	I recently used wait_for "" in a few test-cases, thinking that this would
	match just a prompt, but in fact that's not the case.

	Fix this in wait_for, and add a corresponding test in gdb.tui/tuiterm-2.exp.

	Tested on x86_64-linux.

2023-06-21  Nick Clifton  <nickc@redhat.com>

	Prune linker warnings about an executable stack being created with the -z execstack option.
	  * testsuite/lib/binutils-common.exp (prune_warnings_extra): Prune warnings about -z execstack creating an executable stack.

	For test for PR 29072 when the linker is configured with --enable-default-execstack=no.
	  PR 29072
	  * testsuite/ld-elf/elf.exp (target_defaults_to_execstack): Always return false for linkers configured with the --enable-default-execstack=no option.

2023-06-21  Tankut Baris Aktemur  <tankut.baris.aktemur@intel.com>

	gdbserver: use target_waitstatus::to_string in 'prepare_resume_reply'
	Use the to_string method of target_waitstatus in
	'prepare_resume_reply' for a more readable log message.

	Approved-By: Tom Tromey <tom@tromey.com>

2023-06-21  Jan Beulich  <jbeulich@suse.com>

	x86: fix expansion of %XV
	Only %LV should continue on to S handling; avoid emitting a stray 'l'
	(typically) in suffix-always mode.

2023-06-21  Alan Modra  <amodra@gmail.com>

	elf32_arm_get_synthetic_symtab memory leak
	ARM get_synthetic_symtab reads .plt and caches that data.  Caching the
	data doesn't make a lot of sense since get_synthetic_symtab is only
	called once per bfd, and the memory might be put to better use.  It
	also leaks on closing the bfd.

		* elf32-arm.c (elf32_arm_get_synthetic_symtab): Don't cache
		plt contents.  Free plt data before returning.

2023-06-21  Alan Modra  <amodra@gmail.com>

	macho-o.c don't leak strtab
		* mach-o.c (bfd_mach_o_write_symtab_content): Free strtab on
		success path.

2023-06-21  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-06-20  Tom Tromey  <tom@tromey.com>

	Use ARRAY_SIZE in ax-general.c
	This changes a couple of spots in ax-general.c to use ARRAY_SIZE.
	While making this change, I noticed that one of the bounds checks was
	incorrect.

	Reviewed-by: John Baldwin <jhb@FreeBSD.org>

2023-06-20  Tom Tromey  <tom@tromey.com>

	Remove aop_last
	aop_last is only used for an assertion.  However, due to the '.def'
	construct in the sources, this assert could never plausibly trigger
	(the assert predates the use of a .def file here).  This patch removes
	the constant and the assert.

	Reviewed-by: John Baldwin <jhb@FreeBSD.org>

2023-06-20  Tom Tromey  <tom@tromey.com>

	Make aop_map 'static'
	This changes aop_map to be 'static'.

	Reviewed-by: John Baldwin <jhb@FreeBSD.org>

2023-06-20  Tom Tromey  <tom@tromey.com>

	Use bool for agent_expr::tracing
	This changese agent_expr::tracing to have type bool, allowing inline
	initialization and cleaning up the code a little.

	Reviewed-by: John Baldwin <jhb@FreeBSD.org>

2023-06-20  Tom Tromey  <tom@tromey.com>

	Simplify agent_expr constructor
	This simplifies the agent_expr constructor a bit, and removes the
	destructor entirely.

	Reviewed-by: John Baldwin <jhb@FreeBSD.org>

2023-06-20  Tom Tromey  <tom@tromey.com>

	Use std::vector<bool> for agent_expr::reg_mask
	agent_expr::reg_mask implements its own packed boolean vector.  This
	patch replaces it with a std::vector<bool>, simplifying the code.

	Reviewed-by: John Baldwin <jhb@FreeBSD.org>

2023-06-20  Tom Tromey  <tom@tromey.com>

	Use gdb::byte_vector in agent_expr
	This changes agent_expr to use gdb::byte_vector rather than manually
	reimplementing a vector.

	Reviewed-by: John Baldwin <jhb@FreeBSD.org>

2023-06-20  Tom Tromey  <tom@tromey.com>

	Remove mem2hex
	tracepoint.c has a 'mem2hex' function that is functionally equivalent
	to bin2hex.  This patch removes the redundancy.

	Reviewed-by: John Baldwin <jhb@FreeBSD.org>

2023-06-20  H.J. Lu  <hjl.tools@gmail.com>

	x86: Don't check if AVX512 template requires AVX512VL
	If the ZMM operand in an AVX12 template also allows XMM or ZMM, this
	template must require AVX512VL.  Drop the AVX512VL requirement check
	on such AVX512 templates.

		* config/tc-i386.c (check_VecOperands): Don't check if AVX512
		template requires AVX512VL.

2023-06-20  Tom Tromey  <tom@tromey.com>

	Use std::string in do_set_command
	do_set_command manually updates a string, only to copy it to a
	std::string and free the working copy.  This patch changes this code
	to use std::string for everything, simplifying the code and removing a
	copy.

	Reviewed-by: John Baldwin <jhb@FreeBSD.org>

2023-06-20  Tom Tromey  <tom@tromey.com>

	Use byte_vector in remote.c:readahead_cache
	This patch changes the remote.c readahead_cache to use
	gdb::byte_vector.  This simplifies the code by removing manual memory
	management.

	Reviewed-by: John Baldwin <jhb@FreeBSD.org>

2023-06-20  Tom Tromey  <tom@tromey.com>

	Use std::string in linux-osdata.c
	I found some code in linux-osdata that manually managed a string.
	Replacing this with std::string simplifies it.

	Reviewed-by: John Baldwin <jhb@FreeBSD.org>

2023-06-20  Tom Tromey  <tromey@adacore.com>

	Use unique_xmalloc_ptr for mi_parse::command
	This changes mi_parse::command to be a unique_xmalloc_ptr and fixes up
	all the uses.  This avoids some manual memory management.  std::string
	is not used here due to how the Python API works -- this approach
	avoids an extra copy there.

	Reviewed-by: Keith Seitz <keiths@redhat.com>

2023-06-20  Tom Tromey  <tromey@adacore.com>

	Use std::string for MI token
	This changes the MI "token" to be a std::string, removing some manual
	memory management.  It also makes current_token 'const' in order to
	support this change.

	Reviewed-by: Keith Seitz <keiths@redhat.com>

2023-06-20  Alan Modra  <amodra@gmail.com>

	Don't segfault in mips reloc special_functions
	A symbol defined in a section from a shared library will have a NULL
	section->output_section during linking.

		* elf32-mips.c (gprel32_with_gp): Don't segfault on NULL
		symbol->section->output_section.
		* elf64-mips.c (mips_elf64_gprel32_reloc): Likewise.
		* elfn32-mips.c (mips_elf_gprel16_reloc): Likewise.
		(mips_elf_literal_reloc, mips_elf_gprel32_reloc): Likewise.
		(gprel32_with_gp, mips16_gprel_reloc): Likewise.
		* elfxx-mips.c (_bfd_mips_elf_gprel16_with_gp): Likewise.
		(_bfd_mips_elf_generic_reloc): Likewise.

2023-06-20  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-06-19  Tom de Vries  <tdevries@suse.de>

	Revert "[gdb/testsuite] Clean standard_output_file dir in gdb_init"
	This reverts commit b7b77500dc56e5bc21473dd4f3dde2543d894557.

2023-06-19  Simon Farre  <simon.farre.cx@gmail.com>

	Fixes 28ab59607ef40b9571c0702ffba8f6aa6fb1b033
	Python formatting errors fixed, introduced by this commit.

	Fixes f1a614dc8f015743e9fe7fe5f3f019303f8db718
	Fixes failure reported by buildbot regarding ill-formatted Python code.

2023-06-19  Simon Farre  <simon.farre.cx@gmail.com>

	gdb/Python: Added ThreadExitedEvent
	v6:
	Fix comments.
	Fix copyright
	Remove unnecessary test suite stuff. save_var had to stay, as it mutates
	some test suite state that otherwise fails.

	v5:
	Did what Tom Tromey requested in v4; which can be found here: https://pi.simark.ca/gdb-patches/87pmjm0xar.fsf@tromey.com/

	v4:
	Doc formatting fixed.

	v3:
	Eli:
	Updated docs & NEWS to reflect new changes. Added
	a reference from the .ptid attribute of the ThreadExitedEvent
	to the ptid attribute of InferiorThread. To do this,
	I've added an anchor to that attribute.

	Tom:
	Tom requested that I should probably just emit the thread object;
	I ran into two issues for this, which I could not resolve in this patch;

	1 - The Thread Object (the python type) checks it's own validity
	by doing a comparison of it's `thread_info* thread` to nullptr. This
	means that any access of it's attributes may (probably, since we are
	in "async" land) throw Python exceptions because the thread has been
	removed from the thread object. Therefore I've decided in v3 of this
	patch to just emit most of the same fields that gdb.InferiorThread has, namely
	global_num, name, num and ptid (the 3-attribute tuple provided by
	gdb.InferiorThread.ptid).

	2 - A python user can hold a global reference to an exiting thread. Thus
	in order to have a ThreadExit event that can provide attribute access
	reliably (both as a global reference, but also inside the thread exit
	handler, as we can never guarantee that it's executed _before_ the
	thread_info pointer is removed from the gdbpy thread object),
	the `thread_info *` thread pointer must not be null. However, this
	comes at the cost of gdb.InferiorThread believing it is "valid" - which means,
	that if a user holds takes a global reference to that
	exiting event thread object, they can some time later do `t.switch()` at which
	point GDB will 'explode' so to speak.

	v2:
	Fixed white space issues and NULL/nullptr stuff,
	as requested by Tom Tromey.

	v1:
	Currently no event is emitted for a thread exit.

	This adds this functionality by emitting a new gdb.ThreadExitedEvent.

	It currently provides four attributes:
	- global_num: The GDB assigned global thread number
	- num: the per-inferior thread number
	- name: name of the thread or none if not set
	- ptid: the PTID of the thread, a 3-attribute tuple, identical to
	InferiorThread.ptid attribute

	Added info to docs & the NEWS file as well.

	Added test to test suite.

	Fixed formatting.

	Feedback wanted and appreciated.

2023-06-19  Simon Farre  <simon.farre.cx@gmail.com>

	gdb/dap - Getting thread names
	Renamed thread_name according to convention (_ first)

	When testing firefox tests, it is apparent that
	_get_threads returns threads with name field = None.

	I had initially thought that this was due to Firefox setting the names
	using /proc/pid/task/tid/comm, by writing directly to the proc fs the
	names, but apparently GDB seems to catch this, because I re-wrote
	the basic-dap.exp/c to do this specifically and it saw the changes.

	So I couldn't determine right now, what operation of name change that
	GDB does not pick up, but with this patch, GDB will pick up the thread
	names for an applications that set the name of a thread in ways that
	aren't obvious.

2023-06-19  Nick Clifton  <nickc@redhat.com>

	Fix illegal memory access implementing relocs in a fuzzed x86_64 object file.
	  PR 30560
	  * elf64-x86-64.c (elf_x86_64_relocate_section): Add more checks for a valid relocation offset.

2023-06-19  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Add shared_gnat_runtime_has_debug_info
	Test-case gdb.ada/catch_ex_std.exp passes for me with package
	libada7-debuginfo installed, but after removing it I get:
	...
	(gdb) catch exception some_kind_of_error^M
	Your Ada runtime appears to be missing some debugging information.^M
	Cannot insert Ada exception catchpoint in this configuration.^M
	(gdb) FAIL: gdb.ada/catch_ex_std.exp: catch exception some_kind_of_error
	...

	The test-case contains a require gnat_runtime_has_debug_info to deal with
	this, but the problem is that this checks the static gnat runtime, while this
	test-case uses the shared one.

	Fix this by introducing shared_gnat_runtime_has_debug_info, and requiring that
	one instead.

	Tested on x86_64-linux.

	PR testsuite/30094
	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=30094

2023-06-19  Tom de Vries  <tdevries@suse.de>

	[gdb/tui] Simplify tui_update_variables
	Simplify tui_update_variables by using template function
	assign_return_if_changed.

	Tested on x86_64-linux.

2023-06-19  Tom de Vries  <tdevries@suse.de>

	[gdb] Add template functions assign_return/set_if_changed
	Add template functions assign_return_if_changed and assign_set_if_changed in
	gdb/utils.h:
	...
	template<typename T> void assign_set_if_changed (T &lval, const T &val, bool &changed)
	{ ... }
	template<typename T> bool assign_return_if_changed (T &lval, const T &val)
	{ ... }
	...

	This allows us to rewrite code like this:
	...
	  if (tui_border_attrs != entry->value)
	    {
	      tui_border_attrs = entry->value;
	      need_redraw = true;
	    }
	...
	into this:
	...
	  need_redraw |= assign_return_if_changed<int> (tui_border_attrs, entry->value);
	...
	or:
	...
	  assign_set_if_changed<int> (tui_border_attrs, entry->value, need_redraw);
	...

	The names are a composition of the functionality.  The functions:
	- assign VAL to LVAL, and either
	- return true if the assignment changed LVAL, or
	- set CHANGED to true if the assignment changed LVAL.

	Tested on x86_64-linux.

2023-06-19  Andreas Schwab  <schwab@suse.de>

	riscv: Use run-time endianess for floating point literals
	gas/
		PR binutils/30551
		* config/tc-riscv.c (md_atof): Use target_big_endian instead of
		TARGET_BYTES_BIG_ENDIAN.
		* testsuite/gas/riscv/float-be.d: New file.
		* testsuite/gas/riscv/float-le.d: New file.
		* testsuite/gas/riscv/float.s: New file.

2023-06-19  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-06-18  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Clean standard_output_file dir in gdb_init
	In commit e2adba909e7 ("[gdb/testsuite] Clean up before compilation in
	gdb.ada/call-no-debug.exp") I added some code in the test-case to remove some
	files at the start of the test-case:
	...
	remote_file host delete [standard_output_file prog.o]
	remote_file host delete [standard_output_file prog.ali]
	...

	Replace this with cleaning up the entire directory instead, for all
	test-cases.

	Tested on x86_64-linux.

	Suggested-By: Tom Tromey <tom@tromey.com>
	Reviewed-By: Tom Tromey <tom@tromey.com>

2023-06-18  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-06-17  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Remove f-string in gdb.python/py-unwind.py
	on openSUSE Leap 42.3, with python 3.4, I run into a
	"SyntaxError: invalid syntax" due to usage of an f-string in test-case
	gdb.python/py-unwind.py.

	Fix this by using string concatenation using '+' instead.

	Tested on x86_64-linux.

2023-06-17  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Add nopie in a few test-cases
	When running test-case gdb.arch/i386-disp-step.exp with target board
	unix/-m32/-fPIE/-pie we run into:
	...
	gdb compile failed, ld: i386-disp-step0.o: warning: relocation in read-only section `.text'
	ld: warning: creating DT_TEXTREL in a PIE
	...

	Fix this by adding nopie in the compilation flags.

	Likewise in a few other test-cases.

	Tested on x86_64-linux.

2023-06-17  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Use require in gdb.dwarf2/implptr.exp
	In test-case gdb.dwarf2/implptr.exp I noticed:
	...
	} elseif {![is_x86_like_target]} {
	    # This test can only be run on x86 targets.
	    unsupported "needs x86-like target"
	    return 0
	}
	...

	Use instead "require is_x86_like_target".

	Tested on x86_64-linux.

2023-06-17  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-06-16  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Clean up before compilation in gdb.ada/call-no-debug.exp
	Running test-case gdb.ada/call-no-debug.exp with target board unix/-m64 works
	fine, but if we run it again with target board unix-m32, we run into:
	...
	gnatlink prog.ali -m32 -g -o prog^M
	ld: i386:x86-64 architecture of input file `b~prog.o' is incompatible with \
	  i386 output^M
	...

	This is due to compiling with no-force.

	The test-case:
	- first compiles pck.adb into pck.o (without debug info), and
	- then compiles prog.adb and pck.o into prog (with debug info).

	Using no-force in the second compilation make sure that pck.adb is not
	compiled again, with debug info.

	But it also means it will pick up intermediate files related to prog.adb from
	a previous compilation.

	Fix this by removing prog.o and prog.ali before compilation.

	Tested on x86_64-linux.

2023-06-16  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Use %progbits in gdb.arch/thumb*.S
	In commit 0f2cd53cf4f ("[gdb/testsuite] Handle missing .note.GNU-stack") I
	updated a gdb.arch/arm*.S test-case to use %progbits rather than @progbits,
	but failed to do so for gdb.arch/thumb*.S.  Fix this oversight.

	Tested on arm-linux-gnueabihf.

2023-06-16  mengqinggang  <mengqinggang@loongson.cn>

	LoongArch: Fix ld "undefined reference" error with --enable-shared
	  Because _bfd_read_unsigned_leb128 is hidden visibility, so it can't
	  be referenced out of shared object.

	  The new function loongarch_get_uleb128_length just used to call
	  _bfd_read_unsigned_leb128.

	bfd/ChangeLog:

		* elfxx-loongarch.c (loongarch_get_uleb128_length): New function.
		* elfxx-loongarch.h (loongarch_get_uleb128_length): New function.

	gas/ChangeLog:

		* config/tc-loongarch.c (md_apply_fix): Use
		loongarch_get_uleb128_length.

2023-06-16  Andrew Burgess  <aburgess@redhat.com>

	gdb: update IRC reference from Freenode to Libera.Chat
	It's been some time since the switch from Freenode to Libera.Chat,
	however, there's still a reference to Freenode in the 'gdb --help'
	output.  Lets update that.

2023-06-16  Jan Beulich  <jbeulich@suse.com>

	x86: shrink Masking insn attribute to a single bit (boolean)
	The logic can actually be expressed with less code that way, utilizing
	that there are common patterns of when which form of masking is
	permitted. This then also eliminates the large set of open-codings of
	BOTH_MASKING in the opcode table.

2023-06-16  Alan Modra  <amodra@gmail.com>

	Correct ld-elf/eh5 test for hppa64
	Commit 3c0afdb78988 regressed this test for hppa64, because the test
	had been enabled for hppa64 in the time between the mips changes and
	their reversion.  This patch isn't just a simple reapply, I recreated
	the testsuite change by hand for hppa64: Two lines in eh5.d might need
	further changes for mips.

2023-06-16  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-06-15  Maciej W. Rozycki  <macro@orcam.me.uk>

	binutils/NEWS: Mention Sony Allegrex MIPS CPU support
	Mention the addition of Sony Allegrex processor support to the MIPS port.

		binutils/
		* NEWS: Mention Sony Allegrex MIPS CPU support.

2023-06-15  Maciej W. Rozycki  <macro@orcam.me.uk>

	MIPS/GAS/testsuite: Fix `-modd-spreg'/`-mno-odd-spreg' test invocations
	Reformat `-modd-spreg'/`-mno-odd-spreg' test invocations in mips.exp to
	fit in 79 columns

		gas/
		* testsuite/gas/mips/mips.exp: Reformat
		`-modd-spreg'/`-mno-odd-spreg' test invocations.

2023-06-15  David Guillen Fandos  <david@davidgf.net>

	Add additional missing Allegrex CPU instructions
	Allegrex supports some MIPS32 and MIPS32r2 instructions (albeit with
	some encoding differences) such as bit manipulation (ins/ext) and MLA
	(madd/msub).  It also features some new instructions like wsbw and
	min/max or device-specific ones such as mfic.

	Add rotation instructions to MIPS Allegrex CPU
	The Allegrex CPU supports bit rotation instructions as described in the
	MIPS32 release 2 CPU (even though it is a MIPS-2 based CPU).

	Add MIPS Allegrex CPU as a MIPS2-based CPU
	The Allegrex CPU was created by Sony Interactive Entertainment to power
	their portable console, the PlayStation Portable.
	The pspdev organization maintains all sorts of tools to create software
	for said device including documentation.

2023-06-15  Maciej W. Rozycki  <macro@orcam.me.uk>

	GAS/doc: Correct Tag_GNU_MIPS_ABI_MSA attribute description
	Rewrite the paragraph to match the style of Tag_GNU_MIPS_ABI_FP text
	immediately above, correcting grammar and formatting at the same time.

		gas/
		* doc/as.texi (MIPS Attributes): Correct Tag_GNU_MIPS_ABI_MSA
		attribute description.

2023-06-15  Maciej W. Rozycki  <macro@orcam.me.uk>

	Revert "MIPS: gas: alter 64 or 32 for mipsisa triples if march is implicit"
	This reverts commit 094025a30bb2da19df3990e0c0ff8167af823aa1.  It was
	applied unapproved.

	Revert "MIPS: default r6 if vendor is img"
	This reverts commit be0d391f22fe6009c3be907753975a984cbbcc23.  It was
	applied unapproved.

	Revert "MIPS: fix r6 testsuites"
	This reverts commit ffc528aed56b9e2c171137da28690a9bb6861b0b.  It was
	applied unapproved.

	Revert "MIPS: fix -gnuabi64 testsuite"
	This reverts commit cb81e84c72933a7fad10b75b7e270d92d8d65251.  It was
	applied unapproved.

	Revert "MIPS: fix some ld testcases with compiler"
	This reverts commit a0631c1501c113c04891c9a24a9ff5276257f28d.  It was
	applied unapproved.

	Revert "MIPS: add MT ASE support for micromips32"
	This reverts commit acce83dacff0ce43677410c67aaae32817afe991.  It was
	applied unapproved.

	Revert "MIPS: sync oprand char usage between mips and micromips"
	This reverts commit 5b207b919483f67311a73dfc1de8897ecfd8e776.  It was
	applied unapproved.

2023-06-15  Alan Modra  <amodra@gmail.com>

	Re: Add some expected failures for bfin linker tests
	After commit 7ade0f1582c4 I was seeing bfin-elf +XPASS: weak symbols,
	and on looking into the bfin targets a little, discovered we have two
	bfin-linux targets.  One, bfin-uclinux, is like bfin-elf in that
	ld -m elf32bfin is the default, and the other, bfin-linux-uclibc where
	ld -m elf32bfinfd is the default.  So putting bfin-*-*linux* in test
	xfails or elsewhere is wrong.  We want bfin-*-linux* instead to just
	select the fdpic bfin target.

	This patch corrects wrong bfin target triples in the ld testsuite,
	not just the recent change but others I'd added to xfails too.
	It also fixes the bfin-linux-uclibc ld-elf/64ksec fail

2023-06-15  Alan Modra  <amodra@gmail.com>

	vms write_archive memory leaks
	This fixes two memory leaks in the vms archive handling.

		* vms-lib.c (_bfd_vms_lib_build_map): Free input symbols.
		(_bfd_vms_lib_write_archive_contents): Free archive map symbols.

2023-06-15  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-06-14  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Fix gdb.base/step-over-exit.exp with glibc debuginfo
	In test-case gdb.base/step-over-exit.exp, we set a breakpoint on _exit and
	continue, expecting to hit the breakpoint.

	Without glibc debug info installed, we have with target board unix/-m64:
	...
	Thread 2.1 "step-over-exit" hit Breakpoint 2.2, 0x00007ffff7d46aee in \
	  _exit () from /lib64/libc.so.6^M
	(gdb) PASS: gdb.base/step-over-exit.exp: continue to exit
	...
	and with target board unix/-m32:
	...
	Thread 2.1 "step-over-exit" hit Breakpoint 2.2, 0xf7d84c25 in _exit () from \
	  /lib/libc.so.6^M
	(gdb) PASS: gdb.base/step-over-exit.exp: continue to exit
	...

	However after installing debug info (packages glibc-debuginfo and
	glibc-32bit-debuginfo), we have for -m64 (note: __GI__exit instead of _exit):
	...
	Thread 2.1 "step-over-exit" hit Breakpoint 2.2, \
	  __GI__exit (status=<optimized out>) at \
	  ../sysdeps/unix/sysv/linux/_exit.c:27^M
	27      {^M
	(gdb) PASS: gdb.base/step-over-exit.exp: continue to exit
	...
	and -m32 (note: _Exit instead of _exit):
	...
	Thread 2.1 "step-over-exit" hit Breakpoint 2.2, _Exit () at \
	  ../sysdeps/unix/sysv/linux/i386/_exit.S:24^M
	24      ../sysdeps/unix/sysv/linux/i386/_exit.S: No such file or directory.^M
	(gdb) FAIL: gdb.base/step-over-exit.exp: continue to exit
	...

	The gdb_test allows for both _exit and __GI__exit, but not _Exit:
	...
	gdb_test "continue" \
	    "Continuing\\..*Breakpoint $decimal.*_exit \\(.*\\).*" \
	    "continue to exit"
	...

	Fix this by allowing _Exit as well.

	Tested on x86_64-linux.

2023-06-14  Nick Clifton  <nickc@redhat.com>

	Add some expected failures for bfin linker tests

	Add --remap-inputs option to the BFD linker.
	  PR 30374
	  * ldfile.c (struct input_remap): New structure. (ldfile_add_remap): New function. (ldfile_remap_input_free): New function. (ldfile_add_remap_file): New function. (ldfile_possibly_remap_input): New function. (ldfile_print_input_remaps): New function. * ldfile.h: Add prototypes for new functions.
	  * ldlang.c (new_afile): Call ldfile_possibly_remap_input. (lang_finish): Call ldfile_remap_input_free. (lang_map): Call ldfile_print_input_remaps.
	  * ldlex.h (OPTION_REMAP_INPUTS, OPTION_REMAP_INPUTS_FILE): Define.
	  * lexsup.c (ld_options): Add --remap-inputs-file and --remap-inputs. (parse_args): Handle new options.
	  * NEWS: Mention the new feature.
	  * ld.texi: Document the new options.
	  * testsuite/ld-misc/input-remap.exp: New test driver.
	  * testsuite/ld-misc/remaps.r: New file: Expected linker output.
	  * testsuite/ld-misc/remaps.txt: New file.  Input remaps file.

2023-06-14  Alan Modra  <amodra@gmail.com>

	asprintf memory leaks
	A number of backends want to return bfd_reloc_dangerous messaqes from
	relocation special_function, and construct the message using asprintf.
	Such messages are not freed anywhere, leading to small memory leaks
	inside libbfd.  To limit the leaks, I'd implemented a static buffer in
	the ppc backends that was freed before use in asprintf output.  This
	patch extends that scheme to other backends using a shared static
	buffer and goes further in freeing the buffer on any bfd_close.

	The patch also fixes a few other cases where asprintf output was not
	freed after use.

	bfd/
		* bfd.c (_input_error_msg): Make global and rename to..
		(_bfd_error_buf): ..this.
		(bfd_asprintf): New function.
		(bfd_errmsg): Use bfd_asprintf.
		* opncls.c (bfd_close_all_done): Free _buf_error_buf.
		* elf32-arm.c (find_thumb_glue, find_arm_glue): Use bfd_asprintf.
		* elf32-nios2.c (nios2_elf32_relocate_section): Likewise.
		* elf32-ppc.c (ppc_elf_unhandled_reloc): Likewise.
		* elf64-ppc.c (ppc64_elf_unhandled_reloc): Likewise.
		* elfnn-riscv.c (riscv_resolve_pcrel_lo_relocs): Likewise.
		(riscv_elf_relocate_section): Likewise.
		* libbfd.h: Regenerate.
	gas/
		* read.c (read_end): Free current_name and current_label.
		(do_s_func): Likewise on error path.  strdup label.
	ld/
		* pe-dll.c (make_head, make_tail, make_one),
		(make_singleton_name_thunk, make_import_fixup_entry),
		(make_runtime_pseudo_reloc),
		(pe_create_runtime_relocator_reference: Free oname after use.

2023-06-14  Alan Modra  <amodra@gmail.com>

	Re: bfd/elf.c strtab memory leak
	There are other places that leak the strtab.

		* elf.c (_bfd_elf_compute_section_file_positions): Free strtab
		on error paths.

2023-06-14  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-06-13  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Fix gdb.tui/long-prompt.exp with read1
	When running test-case gdb.tui/long-prompt.exp with check-read1, we get:
	...
	(gdb) FAIL: gdb.tui/long-prompt.exp: prompt size == width + 1: \
	  end of screen: at last line
	...

	The problem is in these commands:
	...
	    Term::command "echo \\n"
	    Term::command "echo \\n"
	    Term::command "echo \\n"
	    Term::command "echo \\n"
	...

	The last one makes the terminal scroll, and the scrolling makes the expected
	output match on a different line.

	Fix this by replacing the sequence with a single command:
	...
	    Term::command "echo \\n\\n\\n\\n\\n\\n"
	...
	which avoids scrolling.

	Tested on x86_64-linux.

2023-06-13  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Fix and add prompt anchoring in tuiterm
	There is a test-case that contains a unit test for tuiterm:
	gdb.tui/tuiterm.exp.

	However, this only excercises the tuiterm itself, and not the functions that
	interact with it, like Term::command.

	Add a new test-case gdb.tui/tuiterm-2.exp that:
	- overrides proc accept_gdb_output (to be able simulate incorrect responses
	  while avoiding the timeout),
	- overrides proc send_gdb (to be able to call Term::command without a gdb
	  instance, such that all tuiterm input is generated by the test-case).
	- issues Term::command calls, and
	- checks whether they behave correctly.

	This exposes a problem in Term::command.  The "prompt before command" regexp
	starts with a bit that is supposed to anchor the prompt to the border:
	...
		set str "(^|\|)$gdb_prompt $str"
	...
	but that doesn't work due to insufficient escaping.  Fix this by adding the
	missing escape:
	...
		set str "(^|\\|)$gdb_prompt $str"
	...

	Futhermore, the "prompt after command" regexp in Term::wait_for has no
	anchoring at all:
	...
		set prompt_wait_for "$gdb_prompt \$"
	...
	so add that as well.

	Tested on x86_64-linux.

2023-06-13  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Allow procs with default value args in with_override
	Currently proc with_override does not work with procs with default value args.

	Fix this, and add a test-case excercising this scenario.

	Tested on x86_64-linux.

2023-06-13  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Fix gdb.dap/type_check.exp with older python
	On openSUSE Leap 15.4 with system python 3.6, I run into:
	...
	(gdb) python check_everything()^M
	(gdb) FAIL: gdb.dap/type_check.exp: type checker
	...

	In check_everything, the hasattr test fails silently:
	...
	def check_everything():
	    # Older versions of Python can't really implement this.
	    if hasattr(typing, "get_origin"):
	...
	and that makes the gdb_test in the test-case fail.

	Fix this by emitting UNSUPPORTED instead in check_everything, and detecting
	this in the test-case.

	Tested on x86_64-linux.

2023-06-13  Lancelot SIX  <lancelot.six@amd.com>

	gdb/testsuite: use proper int size for gdb.dwarf2/symbol_needs_eval*.exp
	We recently realized that symbol_needs_eval_fail.exp and
	symbol_needs_eval_timeout.exp invalidly dereference an int (4 bytes on
	x86_64) by reading 8 bytes (the size of a pointer).

	Here how it goes:

	In gdb/testsuite/gdb.dwarf2/symbol_needs_eval.c a global variable is
	defined:

	    int exec_mask = 1;

	and later both tests build some DWARF using the assembler doing:

	    set exec_mask_var [gdb_target_symbol exec_mask]
	    ...
	        DW_TAG_variable {
	          {DW_AT_name a}
	          {DW_AT_type :$int_type_label}
	          {DW_AT_location {
	            DW_OP_addr $exec_mask_var
	            DW_OP_deref
	            ...
	          }
	        }

	The definition of the DW_OP_deref (from Dwarf5 2.5.1.3 Stack Operations)
	says that "The size of the data retrieved from the dereferenced address
	is the size of an address on the target machine."

	On x86_64, the size of an int is 4 while the size of an address is 8.
	The result is that when evaluating this expression, the debugger reads
	outside of the `a` variable.

	Fix this by using `DW_OP_deref_size $int_size` instead.  To achieve
	this, this patch adds the necessary steps so we can figure out what
	`sizeof(int)` evaluates to for the current target.

	While at it, also change the definition of the int type in the assembled
	DWARF information so we use the actual target's size for an int instead
	of the literal 4.

	Tested on x86_64 Linux.

	Approved-By: Tom Tromey <tom@tromey.com>

2023-06-13  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-06-13  Kevin Buettner  <kevinb@redhat.com>

	Simplify case DW_OP_GNU_uninit in dwarf_expr_context::execute_stack_op
	Tom Tromey pointed out that the test and call to error() for the
	DW_OP_GNU_uninit case in dwarf_expr_context::execute_stack_op (in
	gdb/dwarf2/expr.c)...

		  if (op_ptr != op_end && *op_ptr != DW_OP_piece
		      && *op_ptr != DW_OP_bit_piece)
		    error (_("DWARF-2 expression error: DW_OP_GNU_uninit must always "
			   "be the very last op in a DWARF expression or "
			   "DW_OP_piece/DW_OP_bit_piece piece."));

	...could be replaced by a call to dwarf_expr_require_composition which
	performs a similar check and outputs a suitable error message.

2023-06-12  Simon Farre  <simon.farre.cx@gmail.com>

	Added self to W.A.A. maintainers

2023-06-12  Richard Bunt  <richard.bunt@linaro.org>

	gdb/testsuite: Testing with the armflang compiler
	Currently the Fortran test suite does not run with armflang because the
	compiler detection fails. This in turn means fortran_runto_main does not
	know which main method to use to start a test case.

	Fortran compiler detection was added in 44d469c5f85; however, the commit
	message notes that it was not tested with armflang.

	This commit tests and fixes up a minor issue to get the detection
	working.

	The goal here is to get the tests running and preventing further
	regressions during future work. This change does not do anything to fix
	existing failures.

	>From what I can understand, the auto detection leverages the
	preprocessor to extract the Fortran compiler identity from the defines.
	This preprocessor output is then evaluated by the test suite to import
	these defines.

	In the case of armflang, this evaluation step is disrupted by the
	presence of the following warning:

	    $ armflang -E -fdiagnostics-color=never testsuite/lib/compiler.F90 -o compiler.exp
	    $ clang-13: warning: argument unused during compilation: '-fdiagnostics-color=never' [-Wunused-command-line-argument]

	The evaluation logic is already set up to filter this warning, but the
	prefix differs.

	This commit fixes the issue by updating the filter to exclude the
	armflang flavour of warning.

	gdb.fortran regression tests run with GNU, Intel and Intel LLVM. No
	regressions detected.

	The gdb.fortran test results with ACfL 23.04.1 are as follows.

	Before:

	 # of expected passes		560
	 # of unexpected failures	113
	 # of unresolved testcases	2
	 # of untested testcases	5
	 # of duplicate test names	2

	After:

	 # of expected passes		5388
	 # of unexpected failures	628
	 # of known failures		10
	 # of untested testcases	8
	 # of unsupported tests		5
	 # of duplicate test names	5

	As can be seen from the above, there are now considerably more passing
	assertions.

	Reviewed-By: Luis Machado <luis.machado@arm.com>
	Approved-By: Tom Tromey <tom@tromey.com>

2023-06-12  Tom Tromey  <tromey@adacore.com>

	Remove f-strings from DAP
	Kévin pointed out that gdb claims a minimum Python version of 3.2, but
	the DAP code uses f-strings, which were added in 3.6.

	This patch removes the uses of f-strings from the DAP code.  I can't
	test an older version of Python, but I did confirm that this still
	works with the version I have.

2023-06-12  Tom Tromey  <tromey@adacore.com>

	Implement DAP conditional breakpoints
	I realized that I had only implemented DAP breakpoint conditions for
	exception breakpoints, and not other kinds of breakpoints.  This patch
	corrects the oversight.

2023-06-12  Tom Tromey  <tromey@adacore.com>

	Do not report totalFrames from DAP stackTrace request
	Currently, gdb will unwind the entire stack in response to the
	stackTrace request.  I had erroneously thought that the totalFrames
	attribute was required in the response.  However, the spec says:

	    If omitted or if `totalFrames` is larger than the available
	    frames, a client is expected to request frames until a request
	    returns less frames than requested (which indicates the end of the
	    stack).

	This patch removes this from the response in order to improve
	performance when the stack trace is very long.

2023-06-12  Tom Tromey  <tromey@adacore.com>

	Implement DAP breakpointLocations request
	This implements the DAP breakpointLocations request.

2023-06-12  Tom Tromey  <tromey@adacore.com>

	Add "stop at main" extension to DAP launch request
	Co-workers who work on a program that uses DAP asked for the ability
	to have gdb stop at the main subprogram when launching.  This patch
	implements this extension.

	Reviewed-By: Eli Zaretskii <eliz@gnu.org>

2023-06-12  Tom Tromey  <tromey@adacore.com>

	Add "target" parameter to DAP attach request
	This adds a new "target" to the DAP attach request.  This is passed to
	"target remote".  I thought "attach" made the most sense for this,
	because in some sense gdb is attaching to a running process.  It's
	worth noting that all DAP "attach" parameters are defined by the
	implementation.

	Reviewed-By: Eli Zaretskii <eliz@gnu.org>

2023-06-12  Tom Tromey  <tromey@adacore.com>

	Handle DAP supportsVariableType capability
	A DAP client can report the supportsVariableType capability in the
	initialize request.  In this case, gdb can include the type of a
	variable or expression in various results.

	Implement DAP setExpression request
	This implements the DAP setExpression request.

2023-06-12  Tom Tromey  <tromey@adacore.com>

	Add gdb.Value.assign method
	This adds an 'assign' method to gdb.Value.  This allows for assignment
	without requiring the use of parse_and_eval.

	Reviewed-By: Eli Zaretskii <eliz@gnu.org>

2023-06-12  Tom Tromey  <tromey@adacore.com>

	Add type-checking to DAP requests
	It occurred to me recently that gdb's DAP implementation should
	probably check the types of objects coming from the client.  This
	patch implements this idea by reusing Python's existing type
	annotations, and supplying a decorator that verifies these at runtime.

	Python doesn't make it very easy to do runtime type-checking, so the
	core of the checker is written by hand.  I haven't tried to make a
	fully generic runtime type checker.  Instead, this only checks the
	subset that is needed by DAP.  For example, only keyword-only
	functions are handled.

	Furthermore, in a few spots, it wasn't convenient to spell out the
	type that is accepted.  I've added a couple of comments to this effect
	in breakpoint.py.

	I've tried to make this code compatible with older versions of Python,
	but I've only been able to try it with 3.9 and 3.10.

2023-06-12  Tom Tromey  <tromey@adacore.com>

	Use tuples for default arguments in DAP
	My co-worker Kévin taught me that using a mutable object as a default
	argument in Python is somewhat dangerous, because the object is
	created a single time (when the function is defined), and so if it is
	mutated in the body of the function, the changes will stick around.

	This patch changes the cases like this in DAP to use () rather than []
	as the default.  This patch is merely preventative, as no bugs like
	this are in the code.

2023-06-12  Tom Tromey  <tromey@adacore.com>

	Fix a latent bug in DAP request decorator
	The 'request' decorator is intended to also ensure that the request
	function runs in the DAP thread.  However, the unwrapped function is
	installed in the global request map, so the wrapped version is never
	called.  This patch fixes the bug.

	Add test for DAP pause request
	I neglected to write a test for the DAP "pause" request.  This patch
	adds one.

	Rename one DAP function
	When I first started implementing DAP, I had some vague plan of having
	the implementation functions use the same name as the request.  I
	abandoned this idea, but one vestige remained.  This patch renames the
	one remaining function to be gdb-ish.

	Add singleThread support to some DAP requests
	A few DAP requests support a "singleThread" parameter, which is
	somewhat similar to scheduler-locking.  This patch implements support
	for this.

	Implement DAP stepOut request
	This implements the DAP "stepOut" request.

2023-06-12  Tom Tromey  <tromey@adacore.com>

	Implement DAP attach request
	This implements the DAP "attach" request.

	Note that the copyright dates on the new test source file are not
	incorrect -- this was copied verbatim from another directory.

	Reviewed-By: Eli Zaretskii <eliz@gnu.org>

2023-06-12  Tom Tromey  <tromey@adacore.com>

	Implement DAP setExceptionBreakpoints request
	This implements the DAP setExceptionBreakpoints request for Ada.  This
	is a somewhat minimal implementation, in that "exceptionOptions" are
	not implemented (or advertised) -- I wasn't completely sure how this
	feature is supposed to work.

	I haven't added C++ exception handling here, but it's easy to do if
	needed.

	This patch relies on the new MI command execution support to do its
	work.

2023-06-12  Tom Tromey  <tromey@adacore.com>

	Don't require inferior execution for Ada catchpoints
	Currently, Ada catchpoints require that the inferior be running.
	However, there's no deep reason for this -- for example, C++ exception
	catchpoints do not have this requirement.  Instead, those work like
	ordinary breakpoints: they are pending until the needed runtime
	locations are seen.

	This patch changes Ada catchpoints to work the same way.

2023-06-12  Tom Tromey  <tromey@adacore.com>

	Mark members of ada_catchpoint "private"
	This changes the members of ada_catchpoint to be private.

	Turn should_stop_exception into a method of ada_catchpoint
	This turns the should_stop_exception function in ada-lang.c into a
	method of ada_catchpoint.

	Combine create_excep_cond_exprs and ada_catchpoint::re_set
	This patch merges create_excep_cond_exprs into ada_catchpoint::re_set.
	This is less verbose and is also a step toward making ada_catchpoint
	work more like the other code_breakpoint-based exception catchpoints.

	Transfer ownership of exception string to ada_catchpoint
	This changes the ada_catchpoint to require an rvalue ref, so that
	ownership of the exception string can be transferred to the catchpoint
	object.

	Pass tempflag to ada_catchpoint constructor
	This is a minor cleanup to pass tempflag to the ada_catchpoint
	constructor.

	Use gnat_runtime_has_debug_info in Ada catchpoint tests
	This changes the Ada catchpoint tests to use
	gnat_runtime_has_debug_info.  This simplifies the code.

	Stop gdb in gnat_runtime_has_debug_info
	gnat_runtime_has_debug_info starts a new gdb to do its work.  However,
	it also leaves this gdb running, which can potentially confuse the
	calling test -- I encountered this when writing a new DAP test.  This
	patch changes the proc to shut down gdb.

2023-06-12  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Relax breakpoint count check in gdb.python/py-rbreak.exp
	With a gdb 13.2 based package on SLE-15 aarch64,  I run into:
	...
	(gdb) PASS: gdb.python/py-rbreak.exp: nosharedlibrary
	py sl = gdb.rbreak("^[^_]",minsyms=False)^M
	Breakpoint 2 at 0x4004ac: file ../sysdeps/aarch64/crti.S, line 63.^M
	  ...
	(gdb) py print(len(sl))^M
	12^M
	(gdb) FAIL: gdb.python/py-rbreak.exp: check number of returned breakpoints is 11
	...

	The FAIL is due to:
	- the glibc object crti.o containing debug information for function
	  call_weak_fn, and
	- the test-case not expecting this.

	The debug information is there due to compiling glibc using a binutils which
	contains commit 591cc9fbbfd ("gas/Dwarf: record functions").

	I've run into a similar issue before, see commit 3fbbcf473a5 ("[gdb/testsuite]
	Fix regexp in py-rbreak.exp").

	The fix I applied there was to use a regexp "^[^_]" to filter out
	__libc_csu_fini and __libc_csu_init, but that doesn't work for call_weak_fn.

	Fix this by:
	- reverting the regexp to "", and
	- rewriting the check to require at least 11 functions, rather than a precise
	  match.

	Tested on x86_64-linux.

	PR testsuite/30538
	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=30538

2023-06-12  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Fix breakpoint regexp in gdb.ada/out_of_line_in_inlined.exp
	With a gdb 13.2 based package on openSUSE Tumbleweed i586, I ran into:
	...
	(gdb) run ^M
	Starting program: out_of_line_in_inlined/foo_o224_021-all ^M
	[Thread debugging using libthread_db enabled]^M
	Using host libthread_db library "/lib/libthread_db.so.1".^M
	^M
	Breakpoint 1.1, foo_o224_021.child1.child2 (s=...) at foo_o224_021.adb:26^M
	26                  for C of S loop^M
	(gdb) FAIL: gdb.ada/out_of_line_in_inlined.exp: scenario=all: \
	  run to foo_o224_021.child1.child2
	...

	I can reproduce the same issue with gdb trunk on x86_64, by using optimize=-O3
	instead of optimize=-O2.

	Fix this by using $bkptno_num_re.

	Tested on x86_64-linux.

	PR testsuite/30539
	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=30539

2023-06-12  Tom de Vries  <tdevries@suse.de>

	[gdb/tui] Replace macro HELP_ATTRIBUTE_MODE with std::string
	Replace macro HELP_ATTRIBUTE_MODE with a std::string.

	Tested on x86_64-linux.

	Reviewed-By: Bruno Larsen <blarsen@redhat.com>
	Reviewed-By: Tom Tromey <tom@tromey.com>

2023-06-12  mengqinggang  <mengqinggang@loongson.cn>

	LoongArch: gas: Relocations simplification when -mno-relax
	  Gas does not emit ADD/SUB relocation pairs for label differences
	  when -mno-relax.

2023-06-12  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-06-11  Kevin Buettner  <kevinb@redhat.com>

	Permit DW_OP_GNU_uninit to be used with DW_OP_piece
	This commit implements a fix for a bug reported against GDB on
	Fedora bugzilla...

	https://bugzilla.redhat.com/show_bug.cgi?id=2166796

	The test case in that bug report involved running gdb against the 'jq'
	program (which is a command-line JSON processor) on Fedora 37.  Since
	the debug info is compiler (and compile-time option) dependent, it
	won't necessarily show up in other distributions or even past or
	future versions of Fedora.  (E.g. when trying the example shown below
	on Fedora 38, GDB says that the value of 'value' has been optimized
	out.  I.e. it does not demonstrate the same DWARF error that can be
	see when using Fedora 37.)

	That said, on Fedora 37, the bug could be reproduced as follows:

	[kev@f37-1 ~]$ gdb jq -q -ex 'b src/util.c:415' -ex 'r </dev/null'
	Reading symbols from jq...

	This GDB supports auto-downloading debuginfo from the following URLs:
	  <https://debuginfod.fedoraproject.org/>
	Enable debuginfod for this session? (y or [n]) y
	Debuginfod has been enabled.
	To make this setting permanent, add 'set debuginfod enabled on' to .gdbinit.
	Reading symbols from /home/kev/.cache/debuginfod_client/9d3c8b4197350a190a74972d481de32abf641aa4/debuginfo...
	No source file named src/util.c.
	Make breakpoint pending on future shared library load? (y or [n]) y
	Breakpoint 1 (src/util.c:415) pending.
	Starting program: /usr/bin/jq </dev/null
	[Thread debugging using libthread_db enabled]
	Using host libthread_db library "/lib64/libthread_db.so.1".

	Breakpoint 1, jq_util_input_next_input (state=0x55555555d7f0) at src/util.c:416
	416	    if (state->parser == NULL) {
	(gdb) p value
	DWARF-2 expression error: DW_OP_GNU_uninit must always be the very last op.

	This is undesirable - rather than output an error about the DWARF
	info, we'd prefer to see a value, even if it is uninitialized.

	Examination of the debuginfo showed the following:

	 <1><468f1>: Abbrev Number: 112 (DW_TAG_subprogram)
	    <468f2>   DW_AT_external    : 1
	    <468f2>   DW_AT_name        : (indirect string, offset: 0x4781): jq_util_input_next_input
	    <468f6>   DW_AT_decl_file   : 10
	    <468f6>   DW_AT_decl_line   : 411
	    <468f8>   DW_AT_decl_column : 4
	    <468f9>   DW_AT_prototyped  : 1
	    <468f9>   DW_AT_type        : <0x3f2>
	    <468fd>   DW_AT_sibling     : <0x4692e>
	...
	 <2><46921>: Abbrev Number: 102 (DW_TAG_variable)
	    <46922>   DW_AT_name        : (indirect string, offset: 0x8cb): value
	    <46926>   DW_AT_decl_file   : 10
	    <46926>   DW_AT_decl_line   : 414
	    <46928>   DW_AT_decl_column : 6
	    <46929>   DW_AT_type        : <0x3f2>

	Note that there's no DW_AT_location, so I looked for an abstract origin entry:

	 <2><2dfa0>: Abbrev Number: 90 (DW_TAG_variable)
	    <2dfa1>   DW_AT_abstract_origin: <0x46921>
	    <2dfa5>   DW_AT_location    : 0x27cf1 (location list)
	    <2dfa9>   DW_AT_GNU_locviews: 0x27ce1

	(Note that the DW_AT_abstract_origin attribute's value is 0x46921 which
	is the DIE for the local variable "value".)

	Looking at the location list, I see:

	    00027cf1 v000000000000000 v000000000000000 views at 00027ce1 for:
	             000000000002f8fe 000000000002f92e (DW_OP_reg13 (r13); DW_OP_GNU_uninit; DW_OP_piece: 8; DW_OP_reg12 (r12); DW_OP_GNU_uninit; DW_OP_piece: 8)

	While DW_OP_GNU_uninit is not the very last op, it is the last op
	prior to DW_OP_piece.  The fix involved changing the DW_OP_GNU_uninit
	case in dwarf_expr_context::execute_stack_op in gdb/dwarf2/expr.c so
	that DW_OP_GNU_uninit may appear just before DW_OP_piece.

	With the fix in place, attempting to print 'value' now looks like
	this:

	(gdb) p value
	$1 =  [uninitialized] {kind_flags = 0 '\000', pad_ = 0 '\000', offset = 0,
	  size = 0, u = {ptr = 0x0, number = 0}}

	Note that "[uninitialized]" is part of the output.  (But also note
	that there's an extra space character.)

	I've made a new test case,
	gdb.dwarf2/DW_OP_piece_with_DW_OP_GNU_uninit.exp, by adapting an
	existing one, gdb.dwarf2/opt-out-not-implptr.exp.  Since it uses the
	DWARF assembler, the test case does not depend on a specific compiler
	version or compiler options.

	Tested on Fedora 37 and Fedora 38.

2023-06-11  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-06-10  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-06-09  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: testsuite: add sframe_find_fre tests for pltN entries
	Add a new test plt-findfre-1 to ensure lookup of SFrame stack trace
	information for pltN entries is correct.

	In this test, a dummy SFrame FDE of type SFRAME_FDE_TYPE_PCMASK is
	created.  The size of the 'function code block' covered by the SFrame
	FDE is equivalent to 5 pltN entries of 16 bytes each.

	The test first looks up SFrame FREs for some addresses in the first pltN
	entry, followed by lookups for some addresses in the fourth pltN entry.

	libsframe/
		* Makefile.in: Regenerated.
		* testsuite/libsframe.find/find.exp: Add new test.
		* testsuite/libsframe.find/local.mk: Likewise.
		* testsuite/libsframe.find/plt-findfre-1.c: New test.

2023-06-09  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: fix sframe_find_fre for pltN entries
	To find SFrame stack trace information from an FDE of type
	SFRAME_FDE_TYPE_PCMASK, sframe_find_fre () was doing an operation
	like,
	  (start_ip_offset & 0xff) >= (pc & 0xff), etc.

	This is buggy and needs correction.  The mask 0xff should be 0xf (to
	work for a pltN entry of size say, 16 bytes).

	At this time, the size of the pltN entry is implicitly assumed to be 16
	bytes by libsframe.  In next version of the SFrame format, we can encode
	this information explicitly in the SFrame FDE.

	For now, we should fix the code to at least behave correctly for the
	generated code and the generated SFrame stack trace information for the
	pltN entries on x86_64.

	libsframe/
		* sframe.c (sframe_find_fre): Correct the bitmask used for
		SFrame FDEs of type SFRAME_FDE_TYPE_PCMASK.

2023-06-09  Luis Machado  <luis.machado@arm.com>

	[AArch64,arm] Fix some formatting issues in the aarch64/arm codebase
	As noted by Tom Tromey, there are some formatting issues with the ternary
	operator in the aarch64/arm codebase.  This patch fixes those.

	Reviewed-By: Tom Tromey <tom@tromey.com>

2023-06-09  Tom de Vries  <tdevries@suse.de>

	[gdb/tui] Simplify tui_puts_internal
	Simplify tui_puts_internal by using continue, as per this [1] coding standard
	rule, making the function more readable and easier to understand.

	No functional changes.

	Tested on x86_64-linux.

	[1] https://llvm.org/docs/CodingStandards.html#use-early-exits-and-continue-to-simplify-code

	Reviewed-By: Tom Tromey <tom@tromey.com>

2023-06-09  Tom de Vries  <tdevries@suse.de>

	[gdb/tui] Delete line buffer when switching to singlekey
	Say we're in TUI mode, and type "sun":
	...
	(gdb) sun
	...

	After switching to SingleKey mode using C-x s, we have just:
	...
	sun
	...

	After typing "d", we get:
	...
	sun
	Undefined command: "sundown".  Try "help".
	...

	The SingleKey "d" is supposed run the "down" command.

	Fix this by clearing the readline line buffer when switching to SingleKey
	mode.

	Tested on x86_64-linux.

	PR tui/30522
	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=30522

	Reviewed-By: Tom Tromey <tom@tromey.com>

2023-06-09  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Add test-case gdb.tui/single-key.exp
	I noticed that there's no test-case excercising SingleKey mode, so add a test-case.

	Tested on x86_64-linux.

	Reviewed-By: Tom Tromey <tom@tromey.com>

2023-06-09  Andrew Burgess  <aburgess@redhat.com>

	gdb/debuginfod: cleanup debuginfod earlier
	A GDB crash was discovered on Fedora GDB that was tracked back to an
	issue with the way that debuginfod is cleaned up.

	The bug was reported on Fedora 37, 38, and 39.  Here are the steps to
	reproduce:

	1. The file /etc/ssl/openssl.cnf contains the following lines:

	   [provider_sect]
	   default = default_sect
	   ##legacy = legacy_sect
	   ##
	   [default_sect]
	   activate = 1

	   ##[legacy_sect]
	   ##activate = 1

	   The bug will occur when the '##' characters are removed so that the
	   lines in question look like this:

	   [provider_sect]
	   default = default_sect
	   legacy = legacy_sect

	   [default_sect]
	   activate = 1

	   [legacy_sect]
	   activate = 1

	2. Clean up any existing debuginfod cache data:

	   > rm -rf $HOME/.cache/debuginfod_client

	3. Run GDB:

	   > gdb -nx -q -iex 'set trace-commands on' \
	                -iex 'set debuginfod enabled on' \
	                -iex 'set confirm off' \
			-ex 'start' -ex 'quit' /bin/ls
	   +set debuginfod enabled on
	   +set confirm off
	   Reading symbols from /bin/ls...
	   Downloading separate debug info for /usr/bin/ls
	   ... snip ...
	   Temporary breakpoint 1, main (argc=1, argv=0x7fffffffde38) at ../src/ls.c:1646
	   1646    {
	   +quit

	   Fatal signal: Segmentation fault
	   ----- Backtrace -----
	   ... snip ...

	So GDB ends up crashing during exit.

	What's happening is that when debuginfod is initialised
	debuginfod_begin is called (this is in the debuginfod library), this
	in turn sets up libcurl, which makes use of openssl.  Somewhere during
	this setup process an at_exit function is registered to cleanup some
	state.

	Back in GDB the debuginfod_client object is managed using this code:

	  /* Deleter for a debuginfod_client.  */

	  struct debuginfod_client_deleter
	  {
	    void operator() (debuginfod_client *c)
	    {
	      debuginfod_end (c);
	    }
	  };

	  using debuginfod_client_up
	    = std::unique_ptr<debuginfod_client, debuginfod_client_deleter>;

	And then a global debuginfod_client_up is created to hold a pointer to
	the debuginfod_client object.  As a global this will be cleaned up
	using the standard C++ global object destructor mechanism, which is
	run after the at_exit handlers.

	However, it is expected that when debuginfod_end is called the
	debuginfod_client object will still be in a usable state, that is, we
	don't expect the at_exit handlers to have run and started cleaning up
	the library state.

	To fix this issue we need to ensure that debuginfod_end is called
	before the at_exit handlers have a chance to run.

	This commit removes the debuginfod_client_up type, and instead has GDB
	hold a raw pointer to the debuginfod_client object.  We then make use
	of GDB's make_final_cleanup to register a function that will call
	debuginfod_end.

	As GDB's final cleanups are called before exit is called, this means
	that debuginfod_end will be called before the at_exit handlers are
	called, and the crash identified above is resolved.

	It's not obvious how this issue can easily be tested for. The bug does
	not appear to manifest when using a local debuginfod server, so we'd
	need to setup something more involved.  For now I'm proposing this
	patch without any associated tests.

	Co-Authored-By: Mark Wielaard <mark@klomp.org>
	Co-Authored-By: Simon Marchi <simark@simark.ca>
	Reviewed-By: Tom Tromey <tom@tromey.com>
	Reviewed-By: Aaron Merey <amerey@redhat.com>

2023-06-09  Andrew Burgess  <aburgess@redhat.com>

	gdb: fix ASan failure after recent string changes
	After this commit:

	  commit baab375361c365afee2577c94cbbd3fdd443d6da
	  Date:   Tue Jul 13 14:44:27 2021 -0400

	      gdb: building inferior strings from within GDB

	It was pointed out that a new ASan failure had been introduced which
	was triggered by gdb.base/internal-string-values.exp:

	  (gdb) PASS: gdb.base/internal-string-values.exp: test_setting: all langs: lang=ada: ptype "foo"
	  print $_gdb_maint_setting("test-settings string")
	  =================================================================
	  ==80377==ERROR: AddressSanitizer: heap-buffer-overflow on address 0x603000068034 at pc 0x564785cba682 bp 0x7ffd20644620 sp 0x7ffd20644610
	  READ of size 1 at 0x603000068034 thread T0
	      #0 0x564785cba681 in find_command_name_length(char const*) /tmp/src/binutils-gdb/gdb/cli/cli-decode.c:2129
	      #1 0x564785cbacb2 in lookup_cmd_1(char const**, cmd_list_element*, cmd_list_element**, std::__cxx11::basic_string<char, std::char_traits<char>, std::allocator<char> >*, int, bool) /tmp/src/binutils-gdb/gdb/cli/cli-decode.c:2186
	      #2 0x564785cbb539 in lookup_cmd_1(char const**, cmd_list_element*, cmd_list_element**, std::__cxx11::basic_string<char, std::char_traits<char>, std::allocator<char> >*, int, bool) /tmp/src/binutils-gdb/gdb/cli/cli-decode.c:2248
	      #3 0x564785cbbcf3 in lookup_cmd(char const**, cmd_list_element*, char const*, std::__cxx11::basic_string<char, std::char_traits<char>, std::allocator<char> >*, int, int) /tmp/src/binutils-gdb/gdb/cli/cli-decode.c:2339
	      #4 0x564785c82df2 in setting_cmd /tmp/src/binutils-gdb/gdb/cli/cli-cmds.c:2219
	      #5 0x564785c84274 in gdb_maint_setting_internal_fn /tmp/src/binutils-gdb/gdb/cli/cli-cmds.c:2348
	      #6 0x564788167b3b in call_internal_function(gdbarch*, language_defn const*, value*, int, value**) /tmp/src/binutils-gdb/gdb/value.c:2321
	      #7 0x5647854b6ebd in expr::ada_funcall_operation::evaluate(type*, expression*, noside) /tmp/src/binutils-gdb/gdb/ada-lang.c:11254
	      #8 0x564786658266 in expression::evaluate(type*, noside) /tmp/src/binutils-gdb/gdb/eval.c:111
	      #9 0x5647871242d6 in process_print_command_args /tmp/src/binutils-gdb/gdb/printcmd.c:1322
	      #10 0x5647871244b3 in print_command_1 /tmp/src/binutils-gdb/gdb/printcmd.c:1335
	      #11 0x564787125384 in print_command /tmp/src/binutils-gdb/gdb/printcmd.c:1468
	      #12 0x564785caac44 in do_simple_func /tmp/src/binutils-gdb/gdb/cli/cli-decode.c:95
	      #13 0x564785cc18f0 in cmd_func(cmd_list_element*, char const*, int) /tmp/src/binutils-gdb/gdb/cli/cli-decode.c:2735
	      #14 0x564787c70c68 in execute_command(char const*, int) /tmp/src/binutils-gdb/gdb/top.c:574
	      #15 0x564786686180 in command_handler(char const*) /tmp/src/binutils-gdb/gdb/event-top.c:543
	      #16 0x56478668752f in command_line_handler(std::unique_ptr<char, gdb::xfree_deleter<char> >&&) /tmp/src/binutils-gdb/gdb/event-top.c:779
	      #17 0x564787dcb29a in tui_command_line_handler /tmp/src/binutils-gdb/gdb/tui/tui-interp.c:104
	      #18 0x56478668443d in gdb_rl_callback_handler /tmp/src/binutils-gdb/gdb/event-top.c:250
	      #19 0x7f4efd506246 in rl_callback_read_char (/usr/lib/libreadline.so.8+0x3b246) (BuildId: 092e91fc4361b0ef94561e3ae03a75f69398acbb)
	      #20 0x564786683dea in gdb_rl_callback_read_char_wrapper_noexcept /tmp/src/binutils-gdb/gdb/event-top.c:192
	      #21 0x564786684042 in gdb_rl_callback_read_char_wrapper /tmp/src/binutils-gdb/gdb/event-top.c:225
	      #22 0x564787f1b119 in stdin_event_handler /tmp/src/binutils-gdb/gdb/ui.c:155
	      #23 0x56478862438d in handle_file_event /tmp/src/binutils-gdb/gdbsupport/event-loop.cc:573
	      #24 0x564788624d23 in gdb_wait_for_event /tmp/src/binutils-gdb/gdbsupport/event-loop.cc:694
	      #25 0x56478862297c in gdb_do_one_event(int) /tmp/src/binutils-gdb/gdbsupport/event-loop.cc:264
	      #26 0x564786df99f0 in start_event_loop /tmp/src/binutils-gdb/gdb/main.c:412
	      #27 0x564786dfa069 in captured_command_loop /tmp/src/binutils-gdb/gdb/main.c:476
	      #28 0x564786dff61f in captured_main /tmp/src/binutils-gdb/gdb/main.c:1320
	      #29 0x564786dff75c in gdb_main(captured_main_args*) /tmp/src/binutils-gdb/gdb/main.c:1339
	      #30 0x564785381b6d in main /tmp/src/binutils-gdb/gdb/gdb.c:32
	      #31 0x7f4efbc3984f  (/usr/lib/libc.so.6+0x2384f) (BuildId: 2f005a79cd1a8e385972f5a102f16adba414d75e)
	      #32 0x7f4efbc39909 in __libc_start_main (/usr/lib/libc.so.6+0x23909) (BuildId: 2f005a79cd1a8e385972f5a102f16adba414d75e)
	      #33 0x564785381934 in _start (/tmp/build/binutils-gdb/gdb/gdb+0xabc5934) (BuildId: 90de353ac158646e7dab501b76a18a76628fca33)

	  0x603000068034 is located 0 bytes after 20-byte region [0x603000068020,0x603000068034) allocated by thread T0 here:
	      #0 0x7f4efcee0cd1 in __interceptor_calloc /usr/src/debug/gcc/gcc/libsanitizer/asan/asan_malloc_linux.cpp:77
	      #1 0x5647856265d8 in xcalloc /tmp/src/binutils-gdb/gdb/alloc.c:97
	      #2 0x564788610c6b in xzalloc(unsigned long) /tmp/src/binutils-gdb/gdbsupport/common-utils.cc:29
	      #3 0x56478815721a in value::allocate_contents(bool) /tmp/src/binutils-gdb/gdb/value.c:929
	      #4 0x564788157285 in value::allocate(type*, bool) /tmp/src/binutils-gdb/gdb/value.c:941
	      #5 0x56478815733a in value::allocate(type*) /tmp/src/binutils-gdb/gdb/value.c:951
	      #6 0x5647854ae81c in expr::ada_string_operation::evaluate(type*, expression*, noside) /tmp/src/binutils-gdb/gdb/ada-lang.c:10675
	      #7 0x5647854b63b8 in expr::ada_funcall_operation::evaluate(type*, expression*, noside) /tmp/src/binutils-gdb/gdb/ada-lang.c:11184
	      #8 0x564786658266 in expression::evaluate(type*, noside) /tmp/src/binutils-gdb/gdb/eval.c:111
	      #9 0x5647871242d6 in process_print_command_args /tmp/src/binutils-gdb/gdb/printcmd.c:1322
	      #10 0x5647871244b3 in print_command_1 /tmp/src/binutils-gdb/gdb/printcmd.c:1335
	      #11 0x564787125384 in print_command /tmp/src/binutils-gdb/gdb/printcmd.c:1468
	      #12 0x564785caac44 in do_simple_func /tmp/src/binutils-gdb/gdb/cli/cli-decode.c:95
	      #13 0x564785cc18f0 in cmd_func(cmd_list_element*, char const*, int) /tmp/src/binutils-gdb/gdb/cli/cli-decode.c:2735
	      #14 0x564787c70c68 in execute_command(char const*, int) /tmp/src/binutils-gdb/gdb/top.c:574
	      #15 0x564786686180 in command_handler(char const*) /tmp/src/binutils-gdb/gdb/event-top.c:543
	      #16 0x56478668752f in command_line_handler(std::unique_ptr<char, gdb::xfree_deleter<char> >&&) /tmp/src/binutils-gdb/gdb/event-top.c:779
	      #17 0x564787dcb29a in tui_command_line_handler /tmp/src/binutils-gdb/gdb/tui/tui-interp.c:104
	      #18 0x56478668443d in gdb_rl_callback_handler /tmp/src/binutils-gdb/gdb/event-top.c:250
	      #19 0x7f4efd506246 in rl_callback_read_char (/usr/lib/libreadline.so.8+0x3b246) (BuildId: 092e91fc4361b0ef94561e3ae03a75f69398acbb)

	The problem is in cli/cli-cmds.c, in the function setting_cmd, where
	we do this:

	  const char *a0 = (const char *) argv[0]->contents ().data ();

	Here argv[0] is a value* which we know is either a TYPE_CODE_ARRAY or
	a TYPE_CODE_STRING.  The problem is that the above line is casting the
	value contents directly to a C-string, i.e. one that is assumed to
	have a null-terminator at the end.

	After the above commit this can no longer be assumed to be true.  A
	string value will be represented just as it would be in the current
	language, so for Ada and Fortran the string will be an array of
	characters with no null-terminator at the end.

	My proposed solution is to copy the string contents into a std::string
	object, and then use the std::string::c_str() value, this will ensure
	that a null-terminator has been added.

	I had a check through GDB at places TYPE_CODE_STRING was used and
	couldn't see any other obvious places where this type of assumption
	was being made, so hopefully this is the only offender.

	Running the above test with ASan compiled in no longer gives an error.

	Reviewed-By: Tom Tromey <tom@tromey.com>

2023-06-09  Tom Tromey  <tromey@adacore.com>

	Use scoped_value_mark in two more places
	I found a couple of spots that could use scoped_value_mark.  One of
	them is a spot that didn't consider the possibility that value_mark
	can return NULL.  I tend to doubt this can be seen in this context,
	but nevertheless this is safer.

	Regression tested on x86-64 Fedora 36.

2023-06-09  Tom de Vries  <tdevries@suse.de>

	[gdb] Fix typos
	Fix typos:
	- reponse -> response
	- inital -> initial
	- a -> an

2023-06-09  Alan Modra  <amodra@gmail.com>

	readelf/objdump remember_state memory leaks
		* dwarf.c (display_debug_frames <DW_CFA_restore_state>): Do free
		invalid remember_state.

2023-06-09  Alan Modra  <amodra@gmail.com>

	ecoff find_nearest_line and final link leaks
	Freeing ecoff_debug_info "pointers to the unswapped symbolic info"
	isn't a simple matter, due to differing allocation strategies.  In
	_bfd_ecoff_slurp_symbolic_info the pointers are to objalloc memory.
	In the ecoff linker they are to separately malloc'd memory.  In gas we
	have most (obj-elf) or all (obj-ecoff) into a single malloc'd buffer.

	This patch fixes the leaks for binutils and ld, leaving the gas leaks
	for another day.  The mips elf backend already had this covered, and
	the ecoff backend had a pointer, raw_syments used as a flag, so most
	of the patch is moving these around a little so they are accessible
	for both ecoff and elf.

	include/
		* coff/ecoff.h (struct ecoff_debug_info): Add alloc_syments.
	bfd/
		* libecoff.h (struct ecoff_tdata): Delete raw_syments.
		* elfxx-mips.c (free_ecoff_debug): Delete.  Replace uses with
		_bfd_ecoff_free_ecoff_debug_info.
		(_bfd_mips_elf_final_link): Init debug.alloc_syments.
		* ecofflink.c (_bfd_ecoff_free_ecoff_debug_info): New function.
		* ecoff.c (_bfd_ecoff_bfd_free_cached_info): Call
		_bfd_ecoff_free_ecoff_debug_info.
		(_bfd_ecoff_slurp_symbolic_info): Replace uses of raw_syments
		with alloc_syments.
		(ecoff_final_link_debug_accumulate): Likewise.  Use
		_bfd_ecoff_free_ecoff_debug_info.
		(_bfd_ecoff_bfd_copy_private_bfd_data): Set alloc_syments for
		copied output.
		* elf64-alpha.c (elf64_alpha_read_ecoff_info): Use
		_bfd_ecoff_free_ecoff_debug_info.
		* libbfd-in.h (_bfd_ecoff_free_ecoff_debug_info): Declare.
		* libbfd.h: Regenerate.
	gas/
		* config/obj-ecoff.c (ecoff_frob_file): Set alloc_syments.
		* config/obj-elf.c (elf_frob_file_after_relocs): Likewise.

2023-06-09  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-06-08  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Add test-case gdb.tui/long-prompt.exp
	I noticed that the test-suite doesn't excercise the case in
	tui_redisplay_readline that height (initially 1) is changed by this call:
	...
	    tui_puts_internal (w, prompt, &height);
	...

	Add a test-case that excercises this.

	Tested on x86_64-linux.

2023-06-08  Lancelot SIX  <lancelot.six@amd.com>

	gdb/corelow.c: do not try to reopen a file if open failed once
	In the current implementation, core_target::build_file_mappings will try
	to locate and open files which were mapped in the process for which the
	core dump was produced.  If the file cannot be found or cannot be
	opened, GDB will re-try to open it once for each time it was mapped in
	the process's address space.

	This patch makes it so GDB recognizes that it has already failed to open
	a given file once and does not re-try the process for each mapping.

	Reviewed-By: John Baldwin <jhb@FreeBSD.org>
	Approved-By: Andrew Burgess <aburgess@redhat.com>

2023-06-08  Lancelot SIX  <lancelot.six@amd.com>

	gdb/corelow.c: avoid repeated warnings in build_file_mappings
	When GDB opens a coredump it tries to locate and then open all files
	which were mapped in the process.

	If a file is found but cannot be opened with BFD (bfd_open /
	bfd_check_format fails), then a warning is printed to the user.  If the
	same file was mapped multiple times in the process's address space, the
	warning is printed once for each time the file was mapped.  I find this
	un-necessarily noisy.

	This patch makes it so the warning message is printed only once per
	file.

	There was a comment in the code assuming that if the file was found on
	the system, opening it (bfd_open + bfd_check_format) should always
	succeed.  A recent change in BFD (014a602b86f "Don't optimise bfd_seek
	to same position") showed that this assumption is not valid.  For
	example, it is possible to have a core dump of a process which had
	mmaped an IO page from a DRI render node (/dev/dri/runderD$NUM).  In
	such case the core dump does contain the information that portions of
	this special file were mapped in the host process, but trying to seek to
	position 0 will fail, making bfd_check_format fail.  This patch removes
	this comment.

	Reviewed-By: John Baldwin <jhb@FreeBSD.org>
	Approved-By: Andrew Burgess <aburgess@redhat.com>

2023-06-08  Lancelot SIX  <lancelot.six@amd.com>

	gdb/corelow.c: fix use-after-free in build_file_mappings
	In core_target::build_file_mappings, GDB tries to open files referenced
	in the core dump.

	The process goes like this:

	    struct bfd *bfd = bfd_map[filename];
	    if (bfd == nullptr)
	      {
	        bfd = bfd_map[filename]
	          = bfd_openr (expanded_fname.get (), "binary");
	        if (bfd == nullptr || !bfd_check_format (bfd, bfd_object))
	          {
	            if (bfd != nullptr)
	              bfd_close (bfd);
	            return;
	          }
	      }
	    asection *sec = bfd_make_section_anyway (bfd, "load");
	    ...

	The problem is that if bfd_check_format fails, we close the bfd but keep
	a reference to it in the bfd_map.

	If the same filename appears another time in the NT_FILE note, we enter
	this code again.  The second time, bfd_map[filename] is not nullptr and
	we try to call bfd_make_section_anyway on an already closed BFD, which
	is a use-after-free error.

	This patch makes sure that the bfd is only saved in the bfd_map if it
	got opened successfully.

	This error got exposed by a recent change in BFD (014a602b86f "Don't
	optimise bfd_seek to same position").  Since this change, opening a
	coredump which contains mapping to some special files such as a DRI
	render node (/dev/dri/renderD$NUM) exposes the issue.  This happens for
	example for processes using AMDGPU devices to offload compute tasks.

	Reviewed-By: John Baldwin <jhb@FreeBSD.org>
	Approved-By: Andrew Burgess <aburgess@redhat.com>

2023-06-08  Alan Modra  <amodra@gmail.com>

	Re: _bfd_free_cached_info
	Oops, another leak caused by not defining the correct macro.

		* elf32-mips.c: Define bfd_elf32_bfd_free_cached_info.
		* elfn32-mips.c: Likewise.
		* elf64-mips.c: Define bfd_elf64_bfd_free_cached_info.

2023-06-08  Alan Modra  <amodra@gmail.com>

	Re: _bfd_free_cached_info
	ELF targets with target-specific free_cache_info functions need to
	call _bfd_elf_free_cached_info, not _bfd_generic_bfd_free_cached_info.

		* elf64-ppc.c (ppc64_elf_free_cached_info): Call
		_bfd_elf_free_cached_info.
		* elfnn-aarch64.c (elfNN_aarch64_bfd_free_cached_info): Likewise.

2023-06-08  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-06-07  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: reuse static function sframe_decoder_get_funcdesc_at_index
	sframe_decoder_get_funcdesc_at_index () is the function to access SFrame
	FDEs in the SFrame decoder context.  Use it consistently.

	Avoid unnecessary type cast and include minor enhancements as the code
	is moved around.

	libsframe/
		* sframe.c (sframe_decoder_get_funcdesc_at_index): Move some
		checks here.  Move the static function definition before the new
		use.
		(sframe_decoder_get_funcdesc): Use
		sframe_decoder_get_funcdesc_at_index instead.

2023-06-07  Tom Tromey  <tromey@adacore.com>

	Simplify ada_lookup_struct_elt_type
	This patch simplifies ada_lookup_struct_elt_type by changing it to
	call find_struct_field.  The two functions were substantially similar,
	even to the point of having identical comments.

	I tested this using both the gdb test suite and the internal AdaCore
	test suite.  Given this and the fact that it is Ada-specific, I am
	checking it in.

2023-06-07  Nick Clifton  <nickc@redhat.com>

	Add extra linker warning message about discrepancies between normal and common symbols.
	  PR 30499
	  bfd * elflink.c (elf_link_add_object_symbols): Add a message indicating that alignment and size discrepancies between the definition of common symbols and normal symbols are serious and should be investigated.
	  ld  * testsuite/ld-elfcomm/elfcomm.exp: Update regexps to match new output from the linker.

2023-06-07  Tom de Vries  <tdevries@suse.de>

	[gdb/tui] Factor out border-mode help text
	I noticed that the help texts for tui border-mode and tui active-border-mode
	are similar.

	Factor out the common part into macro HELP_ATTRIBUTE_MODE.

	Tested on x86_64-linux.

2023-06-07  Tom de Vries  <tdevries@suse.de>

	[gdb/cli] Handle pending ^C after rl_callback_read_char for readline 7
	In commit faf01aee1d0 ("[gdb] Handle pending ^C after rl_callback_read_char")
	we handled a problem (described in detail in that commit) for readline >= 8
	using public readline functions rl_pending_signal and rl_check_signals.

	For readline 7 (note that we require at least readline 7 so there's no need to
	worry about readline 6), there was no fix though, because rl_check_signals was
	not available.

	Fix this by instead using the private readline function _rl_signal_handler.

	There is precedent for using private readline variables and functions, but
	it's something we want to get rid of (PR build/10723).  Nevertheless, I think
	we can allow this specific instance because it's not used when building
	against readline >= 8.

	[ In the meanwhile, a fix was committed in the devel branch of the readline
	repo, contained in commit 8d0c439 ("rollup of changes since readline-8.2"),
	first proposed here (
	https://lists.gnu.org/archive/html/bug-readline/2022-10/msg00008.html ). ]

	Tested on x86_64-linux, against system readline 7.0 on openSUSE Leap 15.4.

	PR cli/27813
	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=27813

2023-06-07  Tom de Vries  <tdevries@suse.de>

	Fix PR30369 regression on aarch64/arm (PR30506)
	The gdb.dwarf2/dw2-prologue-end-2.exp test was failing for both AArch64 and
	Arm.

	As Tom pointed out here (https://inbox.sourceware.org/gdb-patches/6663707c-4297-c2f2-a0bd-f3e84fc62aad@suse.de/),
	there are issues with both the prologue skipper for AArch64 and Arm and an
	incorrect assumption by the testcase.

	This patch fixes both of AArch64's and Arm's prologue skippers to not skip past
	the end of a function.  It also incorporates a fix to the testcase so it
	doesn't assume the prologue skipper will stop at the first instruction of the
	functions/labels.

	Regression-tested on aarch64-linux/arm-linux Ubuntu 20.04/22.04 and
	x86_64-linux Ubuntu 20.04.

	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=30506

	Co-Authored-By: Tom de Vries <tdevries@suse.de>
	Co-Authored-By: Luis Machado <luis.machado@arm.com>

2023-06-07  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Add missing wait in gdb.python/tui-window-disabled.exp
	While working on PR tui/30526, I noticed a bug in test-case
	gdb.python/tui-window-disabled.exp.

	Here we send "tui enable" to gdb, but don't wait for it to arrive before
	checking for a window box:
	...
	    send_gdb "tui enable\n"
	    Term::check_box "check for python window" 0 0 80 16
	...

	Fix this by waiting for the prompt to be issued in TUI before doing the check.

	Tested on x86_64-linux.

2023-06-07  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Fix two typos in gdb.python/tui-window-disabled.exp
	Fix two typos in test-case gdb.python/tui-window-disabled.exp.

2023-06-07  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Handle output after prompt in gdb.threads/step-N-all-progress.exp
	Using "taskset -c 0" I run into this timeout:
	...
	(gdb) PASS: gdb.threads/step-N-all-progress.exp: non-stop=on: \
	  target-non-stop=on: continue to breakpoint: break here
	next 3^M
	[New Thread 0x7ffff7dbd6c0 (LWP 10202)]^M
	50        return 0;^M
	(gdb) [Thread 0x7ffff7dbd6c0 (LWP 10202) exited]^M
	FAIL: gdb.threads/step-N-all-progress.exp: non-stop=on: target-non-stop=on: \
	  next 3 (timeout)
	...

	The problem is that this test:
	...
	    gdb_test "next 3" "return 0;"
	...
	expects no output after the prompt.

	Fix this by using -no-prompt-anchor.

	Tested on x86_64-linux.

2023-06-07  Alan Modra  <amodra@gmail.com>

	ld-elf/eh5 remove xfail hppa64
	Commit cb81e84c72 resulted in an xpass for hppa64-hp-hpux11, but the
	test still fails on hpp64-linux.  Let's make it pass for hppa64-linux
	too, by accepting pcrel sdata8 encoding in the augmentation data.

2023-06-07  Luis Machado  <luis.machado@arm.com>

	Fix gdb.base/memtag.exp failure
	While running this test on an emulator, I noticed we're failing to match the
	output message when "memory-tag check" is issued with no arguments.  That's
	because I coded the message using "error" and missed a period at the end.  Other
	similar messages are issued with error_no_arg.

	This patch changes that call to use error_no_arg.

	Tested on aarch64-linux Ubuntu 20.04/22.04.

2023-06-07  Alan Modra  <amodra@gmail.com>

	_bfd_free_cached_info
	doc/bfdint.texi and comments in the aout and som code about this
	function are just wrong, and its name is not very apt.  Better would
	be _bfd_mostly_destroy, and we certainly should not be saying anything
	about the possibility of later recreating anything lost by this
	function.  What's more, if _bfd_free_cached_info is called when
	creating an archive map to reduce memory usage by throwing away
	symbols, the target _close_and_cleanup function won't have access to
	tdata or section bfd_user_data to tidy memory.  This means most of the
	target _close_and_cleanup function won't do anything, and therefore
	sometimes will result in memory leaks.

	This patch fixes the documentation problems and moves most of the
	target _close_and_cleanup code to target _bfd_free_cached_info.
	Another notable change is that bfd_generic_bfd_free_cached_info is now
	defined as _bfd_free_cached_info rather than _bfd_bool_bfd_true,
	ie. the default now frees objalloc memory.

2023-06-07  Alan Modra  <amodra@gmail.com>

	Memory leaks in bfd/vms-lib.c
		* vms-lib.c (vms_lib_read_index): Free malloc'd memory on error
		return paths.
		(vms_write_index, _bfd_vms_lib_write_archive_contents): Likewise.

	bfd/elf.c strtab memory leak
		* elf.c (_bfd_elf_compute_section_file_positions): Free strtab
		on set_group_contents failure return path.

2023-06-07  Alan Modra  <amodra@gmail.com>

	objcopy memory leaks after errors
	These aren't important at all, but tidy them in case they obscure
	other more important leaks.

		* objcopy (copy_file): Close input bfd after errors.

2023-06-07  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-06-06  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: fix cosmetic issues and typos
	include/
		* sframe-api.h (sframe_decoder_get_num_fidx): Use extern.
	libsframe/
		* sframe-dump.c (dump_sframe_func_with_fres): Fix line length.
		* sframe.c (sframe_frame_row_entry_copy): Likewise.
		(sframe_decode_fre_start_address): Use the intended type uint32_t.

2023-06-06  Alan Modra  <amodra@gmail.com>

	Re: loongarch readelf support
	Commit 89c70cd358b8 apparently results in a bogus "value may be used
	uninitialized" warning with some combination of compiler and
	optimisation options.

		* readelf.c (target_specific_reloc_handling): Init value.

2023-06-06  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-06-05  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: avoid unnecessary type casts
	Change the data type of some of the members of the sframe_decoder_ctx
	and sframe_encoder_ctx data structures to use the applicable data types
	explicitly. Current implementation in libsframe does type casts, which
	seem unnecessary.

	libsframe/
		* libsframe/sframe-impl.h (struct sframe_decoder_ctx): Use
		applicable data type explicitly.
		(struct sframe_encoder_ctx): Likewise. Use same style of
		comments consistently.
		* libsframe/sframe.c (struct sf_fde_tbl): Define without
		typedef.
		(struct sf_fre_tbl): Likewise.
		(sframe_decode): Remove unnecessary type casts.
		(sframe_encoder_get_funcdesc_at_index): Likewise.
		(sframe_encoder_add_fre): Likewise.
		(sframe_encoder_add_funcdesc): Likewise.
		(sframe_sort_funcdesc): Likewise.
		(sframe_encoder_write_sframe): Likewise.

2023-06-05  H.J. Lu  <hjl.tools@gmail.com>

	ELF: Add "#pass" to ld-elf/pr30508.d
	Add "#pass" to ld-elf/pr30508.d to allow extra segments.

		PR binutils/30508
		* testsuite/ld-elf/pr30508.d: Add "#pass".

2023-06-05  Tom Tromey  <tromey@adacore.com>

	Use unrelocated_addr in dwarf2_fde
	This changes dwarf2_fde to use the unrelocated_addr type.  This
	pointed out a latent bug in dwarf2_frame_cache, where a relocated
	address is compared to an unrelocated address.

2023-06-05  Tom Tromey  <tromey@adacore.com>

	Use local "text offset" variable in dwarf2_frame_cache
	A few spots in dwarf2_frame_cache use:

	    cache->per_objfile->objfile->text_section_offset ()

	... and a subsequent patch will add more, so move this into a local
	variable.

2023-06-05  Tom Tromey  <tromey@adacore.com>

	Constify dwarf2_cie::augmentation
	I noticed that dwarf2_cie::augmentation could be 'const'.

	Use "unrelocated" terminology in linetable_entry
	I forgot to convert struct linetable_entry to use the "unrelocated"
	(as opposed to "raw") terminology.  This patch corrects the oversight.

	Fix comment in address_class
	enum address_class has a stale comment referring to
	MSYMBOL_VALUE_RAW_ADDRESS, which no longer exists.  This patch updates
	the comment.

	Use unrelocated_addr in dwarf_decode_lines
	This changes dwarf_decode_lines to accept an unrelocated_addr and
	fixes up the fallout.

	Use unrelocated_addr in the DWARF reader
	This changes various spots in the DWARF reader to use
	unrelocated_addr.

	Move unrelocated_addr to common-types.h
	unrelocated_addr is currently defined in symtab.h, but in order to
	avoid having to include that in more places, I wanted to move the type
	elsewhere.  I considered defs.h, but it seemed reasonable to have it
	next to CORE_ADDR, which is what this patch does.

	Minor cleanup in loclist_describe_location
	loclist_describe_location already has a per_objfile local variable, so
	use it consistently.

	Remove baseaddr parameter from dwarf2_record_block_ranges
	dwarf2_record_block_ranges is only ever called with the text section
	offset, so this patch removes the parameter entirely.  This makes a
	subsequent patch a little simpler.

2023-06-05  H.J. Lu  <hjl.tools@gmail.com>

	ELF: Don't warn an empty PT_LOAD with the program headers
	When rewriting the program headers, don't warn an empty PT_LOAD with the
	program headers.

	bfd/

		PR binutils/30508
		* elf.c (rewrite_elf_program_header): Don't warn if an empty
		PT_LOAD contains the program headers.

	ld/

		PR binutils/30508
		* testsuite/ld-elf/pr30508.d: New file.
		* testsuite/ld-elf/pr30508.s: Likewise.

2023-06-05  Andrew Burgess  <aburgess@redhat.com>

	gdb: building inferior strings from within GDB
	History Of This Patch
	=====================

	This commit aims to address PR gdb/21699.  There have now been a
	couple of attempts to fix this issue.  Simon originally posted two
	patches back in 2021:

	  https://sourceware.org/pipermail/gdb-patches/2021-July/180894.html
	  https://sourceware.org/pipermail/gdb-patches/2021-July/180896.html

	Before Pedro then posted a version of his own:

	  https://sourceware.org/pipermail/gdb-patches/2021-July/180970.html

	After this the conversation halted.  Then in 2023 I (Andrew) also took
	a look at this bug and posted two versions:

	  https://sourceware.org/pipermail/gdb-patches/2023-April/198570.html
	  https://sourceware.org/pipermail/gdb-patches/2023-April/198680.html

	The approach taken in my first patch was pretty similar to what Simon
	originally posted back in 2021.  My second attempt was only a slight
	variation on the first.

	Pedro then pointed out his older patch, and so we arrive at this
	patch.  The GDB changes here are mostly Pedro's work, but updated by
	me (Andrew), any mistakes are mine.

	The tests here are a combinations of everyone's work, and the commit
	message is new, but copies bits from everyone's earlier work.

	Problem Description
	===================

	Bug PR gdb/21699 makes the observation that using $_as_string with
	GDB's printf can cause GDB to print unexpected data from the
	inferior.  The reproducer is pretty simple:

	  #include <stddef.h>
	  static char arena[100];

	  /* Override malloc() so value_coerce_to_target() gets a known
	     pointer, and we know we"ll see an error if $_as_string() gives
	     a string that isn't null terminated. */
	  void
	  *malloc (size_t size)
	  {
	      memset (arena, 'x', sizeof (arena));
	      if (size > sizeof (arena))
	          return NULL;
	      return arena;
	  }

	  int
	  main ()
	  {
	    return 0;
	  }

	And then in a GDB session:

	  $ gdb -q test
	  Reading symbols from /tmp/test...
	  (gdb) start
	  Temporary breakpoint 1 at 0x4004c8: file test.c, line 17.
	  Starting program: /tmp/test

	  Temporary breakpoint 1, main () at test.c:17
	  17        return 0;
	  (gdb) printf "%s\n", $_as_string("hello")
	  "hello"xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	  (gdb) quit

	The problem above is caused by how value_cstring is used within
	py-value.c, but once we understand the issue then it turns out that
	value_cstring is used in an unexpected way in many places within GDB.

	Within py-value.c we have a null-terminated C-style string.  We then
	pass a pointer to this string, along with the length of this
	string (so not including the null-character) to value_cstring.

	In value_cstring GDB allocates an array value of the given character
	type, and copies in requested number of characters.  However
	value_cstring does not add a null-character of its own.  This means
	that the value created by calling value_cstring is only
	null-terminated if the null-character is included in the passed in
	length.  In py-value.c this is not the case, and indeed, in most uses
	of value_cstring, this is not the case.

	When GDB tries to print one of these strings the value contents are
	pushed to the inferior, and then read back as a C-style string, that
	is, GDB reads inferior memory until it finds a null-terminator.  For
	the py-value.c case, no null-terminator is pushed into the inferior,
	so GDB will continue reading inferior memory until a null-terminator
	is found, with unpredictable results.

	Patch Description
	=================

	The first thing this patch does is better define what the arguments
	for the two function value_cstring and value_string should represent.
	The comments in the header file are updated to describe whether the
	length argument should, or should not, include a null-character.
	Also, the data argument is changed to type gdb_byte.  The functions as
	they currently exist will handle wide-characters, in which case more
	than one 'char' would be needed for each character.  As such using
	gdb_byte seems to make more sense.

	To avoid adding casts throughout GDB, I've also added an overload that
	still takes a 'char *', but asserts that the character type being used
	is of size '1'.

	The value_cstring function is now responsible for adding a null
	character at the end of the string value it creates.

	However, once we start looking at how value_cstring is used, we
	realise there's another, related, problem.  Not every language's
	strings are null terminated.  Fortran and Ada strings, for example,
	are just an array of characters, GDB already has the function
	value_string which can be used to create such values.

	Consider this example using current GDB:

	  (gdb) set language ada
	  (gdb) p $_gdb_setting("arch")
	  $1 = (97, 117, 116, 111)
	  (gdb) ptype $
	  type = array (1 .. 4) of char
	  (gdb) p $_gdb_maint_setting("test-settings string")
	  $2 = (0)
	  (gdb) ptype $
	  type = array (1 .. 1) of char

	This shows two problems, first, the $_gdb_setting and
	$_gdb_maint_setting functions are calling value_cstring using the
	builtin_char character, rather than a language appropriate type.  In
	the first call, the 'arch' case, the value_cstring call doesn't
	include the null character, so the returned array only contains the
	expected characters.  But, in the $_gdb_maint_setting example we do
	end up including the null-character, even though this is not expected
	for Ada strings.

	This commit adds a new language method language_defn::value_string,
	this function takes a pointer and length and creates a language
	appropriate value that represents the string.  For C, C++, etc this
	will be a null-terminated string (by calling value_cstring), and for
	Fortran and Ada this can be a bounded array of characters with no null
	terminator.  Additionally, this new language_defn::value_string
	function is responsible for selecting a language appropriate character
	type.

	After this commit the only calls to value_cstring are from the C
	expression evaluator and from the default language_defn::value_string.

	And the only calls to value_string are from Fortan, Ada, and ObjectC
	related code.

	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=21699

	Co-Authored-By: Simon Marchi <simon.marchi@efficios.com>
	Co-Authored-By: Andrew Burgess <aburgess@redhat.com>
	Co-Authored-By: Pedro Alves <pedro@palves.net>
	Approved-By: Simon Marchi <simon.marchi@efficios.com>

2023-06-05  Tom de Vries  <tdevries@suse.de>

	[gdb] Fix grammar in comments and docs
	Fix grammar in some comments and docs:
	- machines that doesn't -> machines that don't
	- its a -> it's a
	- its the -> it's the
	- if does its not -> if it does it's not
	- one more instructions if doesn't match ->
	  one more instruction if it doesn't match
	- it's own -> its own
	- it's first -> its first
	- it's pointer -> its pointer

	I also came across "it's performance" in gdb/stubs/*-stub.c in the HP public
	domain notice, I've left that alone.

	Tested on x86_64-linux.

2023-06-05  Tom de Vries  <tdevries@suse.de>

	[gdb] Fix more typos
	Fix some more typos:
	- distinquish -> distinguish
	- actualy -> actually
	- singe -> single
	- frash -> frame
	- chid -> child
	- dissassembler -> disassembler
	- uninitalized -> uninitialized
	- precontidion -> precondition
	- regsiters -> registers
	- marge -> merge
	- sate -> state
	- garanteed -> guaranteed
	- explictly -> explicitly
	- prefices (nonstandard plural) -> prefixes
	- bondary -> boundary
	- formated -> formatted
	- ithe -> the
	- arrav -> array
	- coresponding -> corresponding
	- owend -> owned
	- fials -> fails
	- diasm -> disasm
	- ture -> true
	- tpye -> type

	There's one code change, the name of macro SIG_CODE_BONDARY_FAULT changed to
	SIG_CODE_BOUNDARY_FAULT.

	Tested on x86_64-linux.

2023-06-05  Alan Modra  <amodra@gmail.com>

	bfd_error_on_input messages
	bfd_errmsg uses asprintf for bfd_error_on_input, which means we
	currently leak memory.  Keep a static pointer to the message and free
	it in various places to minimise the leaks.
	bfd_set_input_error (NULL, bfd_error_no_error) is a way to free up the
	last string if that matters.

		* bfd.c (input_error_msg): New static var.
		(bfd_set_input_error): Free it here..
		(bfd_init): ..and here..
		(bfd_errmsg): ..and here.  Use it for asprintf output.

2023-06-05  Alan Modra  <amodra@gmail.com>

	Yet another ecoff fuzzed object fix
		* ecoff.c (_bfd_ecoff_slurp_symbol_table): Sanity check fdr_ptr
		csym against remaining space for symbols.  Error on out of bounds
		fdr_ptr fields.

2023-06-05  YunQiang Su  <yunqiang.su@cipunited.com>

	MIPS: sync oprand char usage between mips and micromips
	We should try our best to make mips32 using the same
	oprand char with micromips. So for mips32, we use:

	  ^  is added for 5bit sa oprand for some new DSPr2 instructions:
		APPEND, PREPEND, PRECR_SRA[_R].PH.W
		the LSB bit is 11, like RD.
	  +t is removed for coprocessor 0 destination register.
		'E' does the samething.
	  +t is now used for RX oprand for MFTR/MTTR (MT ASE)
	  ?  is added for sel oprand for MFTR/MTTR (MT ASE)
		For mips32, the position of sel in MFTR/MTTR is same with mfc0 etc,
		while for micromips, they are different.

	We also add an extesion format of cftc2/cttc2/mftc2/mfthc2/mttc2/mtthc2:
		concatenating rs with rx as the index of control or data.

2023-06-05  YunQiang Su  <yunqiang.su@cipunited.com>

	MIPS: add MT ASE support for micromips32
	These instructions are descripted in MD00768.

	MIPS® Architecture for Programmers
	Volume IV-f: The MIPS® MT Module for
	the microMIPS32™ Architecture

	Document Number: MD00768
	Revision 1.12
	July 16, 2013

	https://s3-eu-west-1.amazonaws.com/downloads-mips/documents/MD00768-1C-microMIPS32MT-AFP-01.12.pdf

2023-06-05  YunQiang Su  <yunqiang.su@cipunited.com>

	Revert "MIPS: add MT ASE support for micromips32"
	This reverts commit 783a5f46b0583e9ed3a63acd3361009f46de5c17.

2023-06-05  YunQiang Su  <yunqiang.su@cipunited.com>

	MIPS: add MT ASE support for micromips32
	These instructions are descripted in MD00768.

	MIPS® Architecture for Programmers
	Volume IV-f: The MIPS® MT Module for
	the microMIPS32™ Architecture

	Document Number: MD00768
	Revision 1.12
	July 16, 2013

	https://s3-eu-west-1.amazonaws.com/downloads-mips/documents/MD00768-1C-microMIPS32MT-AFP-01.12.pdf

2023-06-05  YunQiang Su  <yunqiang.su@cipunited.com>

	MIPS: fix some ld testcases with compiler
	1. config/default.exp:
		use -mabi=32 not for -gnuabi64
		xfail_from_runlist: remove an element and mark it xfail.
	2. ld-elf/indirect.exp: xfail
		indirect5a indirect5b indirect6a indirect6b
		indirect5c indirect5d indirect6c indirect6d
	3. ld-elf/pr23658-2: mips output is not common
	4. ld-elf/shared.exp: non-run on mips: Build libpr16496b.so
	5. ld-elfvers/vers.exp:
		xfail vers4, vers4b
		no-run on mips: vers24a, vers24b, vers24c
	6. ld-gc/gc.exp: add -KPIC into asflags for pr13683, pr14265, pr19161
	7. ld-mips-elf/mips-elf.exp:
		use noarch for mips16-local-stubs-1, since it use -mips4
	8. ld-plugin/lto.exp:
		no-run on mips/linux: PR ld/12982
		add -KPIC into asflags for lto-3r, lto-5r, PR ld/19317 (2)
		xfail PR ld/15323 (4), PR ld/19317 (3)
	9. ld-plugin/plugin.exp: xfail
		plugin claimfile lost symbol
		plugin claimfile replace symbol
		plugin claimfile replace symbol
		plugin claimfile lost symbol with source
		plugin claimfile replace symbol with source
		plugin claimfile resolve symbol with source
		plugin 2 with source lib
		load plugin 2 with source
		plugin 3 with source lib
		load plugin 3 with source
	11. ld-selective/selective.exp: add -fno-PIC, which is needed for -mno-abicalls
	12. ld-shared/shared.exp: xfail shared (non PIC), shared (PIC main, non PIC so)

	MIPS: fix -gnuabi64 testsuite
	Test on:
		mips64-linux-gnuabi64
		mips64el-linux-gnuabi64
		mipsisa64-linux-gnuabi64
		mipsisa64el-linux-gnuabi64
		mipsisa64r2-linux-gnuabi64
		mipsisa64r2el-linux-gnuabi64
		mipsisa64r6-linux-gnuabi64
		mipsisa64r6el-linux-gnuabi64

2023-06-05  YunQiang Su  <yunqiang.su@cipunited.com>

	MIPS: fix r6 testsuites
	Introduce
		run_dump_test_o32l
		run_dump_test_n32l
		run_dump_test_n64l
	Which use `-march=from-abi` for pre-R6 testcases,
	like micromips/mips16e etc.

	For cases doesn't use run_dump_test_*, we use
		-mips32r2 for micromips32
		-mips1 for mips16-32
		-march=from-abi for testcases to o32/n32/n64 both/all.

	Replace `addi` with `addiu` for some cases for both r6 and pre-R6.

	Introduce some new testcases for r6 with FPXX/FP64.
	Introduce new testcase: comdat-reloc-r6.

	Skip `default` in mips_arch_list_matching if triple is mipsisa*, due to:
	  1)it will cannot match mipsr6@*.d: since mips32rN/mips64rN
	    will always be used, it won't be a problem.
	  2)some test think -march=mips64rN will alway true for mipsisa64rN,
	    which is not true now.

	This patch fix testsuite for all r6-default gnu triples:
	  mipsisa32r6-linux-gnu
	  mipsisa32r6el-linux-gnu
	  mips-img-linux-gnu
	  mipsel-img-linux-gnu
	  mipsisa64r6-linux-gnu
	  mipsisa64r6el-linux-gnu

2023-06-05  YunQiang Su  <yunqiang.su@cipunited.com>

	MIPS: default r6 if vendor is img
	This behavior is used by downstream toolchain since 2014.
	We also set the default ABI for mips*-img-elf to O32.
	The previous value is NO_ABI, which is not good default ABI.

	We don't support mips64*-img* due to GCC doesn't support it,
	and We believe that the multilib should be used for this case.

2023-06-05  YunQiang Su  <yunqiang.su@cipunited.com>

	MIPS: gas: alter 64 or 32 for mipsisa triples if march is implicit
	When configure with triples mipsisa[32,64]rN[el,], the march value
	is pinned to a fix value if not given explicitly. for example
	   1) mipsisa32r6-linux-gnu -n32 xx.s will complains that:
	      -march=mips32r6 is not compatible with the selected ABI
	   2) mipsisa64r2el-linux-gnu -o32 generates objects with 64bit CPU:
	      ELF 32-bit LSB relocatable, MIPS, MIPS64 rel2 version 1 (SYSV)
	They are not good default behaviors: Let's alter the CPU info

	Since we are using these triples as a regular linux distributions,
	let's alter march according to ABI.

2023-06-05  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-06-04  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-06-03  Tom de Vries  <tdevries@suse.de>

	[gdb] Fix typos
	Fix a few typos:
	- implemention -> implementation
	- convertion(s) -> conversion(s)
	- backlashes -> backslashes
	- signoring -> ignoring
	- (un)ambigious -> (un)ambiguous
	- occured -> occurred
	- hidding -> hiding
	- temporarilly -> temporarily
	- immediatelly -> immediately
	- sillyness -> silliness
	- similiar -> similar
	- porkuser -> pokeuser
	- thats -> that
	- alway -> always
	- supercede -> supersede
	- accomodate -> accommodate
	- aquire -> acquire
	- priveleged -> privileged
	- priviliged -> privileged
	- priviledges -> privileges
	- privilige -> privilege
	- recieve -> receive
	- (p)refered -> (p)referred
	- succesfully -> successfully
	- successfuly -> successfully
	- responsability -> responsibility
	- wether -> whether
	- wich -> which
	- disasbleable -> disableable
	- descriminant -> discriminant
	- construcstor -> constructor
	- underlaying -> underlying
	- underyling -> underlying
	- structureal -> structural
	- appearences -> appearances
	- terciarily -> tertiarily
	- resgisters -> registers
	- reacheable -> reachable
	- likelyhood -> likelihood
	- intepreter -> interpreter
	- disassemly -> disassembly
	- covnersion -> conversion
	- conviently -> conveniently
	- atttribute -> attribute
	- struction -> struct
	- resonable -> reasonable
	- popupated -> populated
	- namespaxe -> namespace
	- intialize -> initialize
	- identifer(s) -> identifier(s)
	- expection -> exception
	- exectuted -> executed
	- dungerous -> dangerous
	- dissapear -> disappear
	- completly -> completely
	- (inter)changable -> (inter)changeable
	- beakpoint -> breakpoint
	- automativ -> automatic
	- alocating -> allocating
	- agressive -> aggressive
	- writting -> writing
	- reguires -> requires
	- registed -> registered
	- recuding -> reducing
	- opeartor -> operator
	- ommitted -> omitted
	- modifing -> modifying
	- intances -> instances
	- imbedded -> embedded
	- gdbaarch -> gdbarch
	- exection -> execution
	- direcive -> directive
	- demanged -> demangled
	- decidely -> decidedly
	- argments -> arguments
	- agrument -> argument
	- amespace -> namespace
	- targtet -> target
	- supress(ed) -> suppress(ed)
	- startum -> stratum
	- squence -> sequence
	- prompty -> prompt
	- overlow -> overflow
	- memember -> member
	- languge -> language
	- geneate -> generate
	- funcion -> function
	- exising -> existing
	- dinking -> syncing
	- destroh -> destroy
	- clenaed -> cleaned
	- changep -> changedp (name of variable)
	- arround -> around
	- aproach -> approach
	- whould -> would
	- symobl -> symbol
	- recuse -> recurse
	- outter -> outer
	- freeds -> frees
	- contex -> context

	Tested on x86_64-linux.

	Reviewed-By: Tom Tromey <tom@tromey.com>

2023-06-03  Tom de Vries  <tdevries@suse.de>

	[gdb/tdep] Fix typo in debug message
	In microblaze_analyze_prologue in gdb/microblaze-tdep.c I came across:
	...
		  microblaze_debug ("got addi r1,r1,%d; contnuing\n", imm);
	...

	Fix this by using "continuing".

	Reviewed-By: Tom Tromey <tom@tromey.com>

2023-06-03  Tom de Vries  <tdevries@suse.de>

	[gdb/python] Fix doc string of valpy_const_value
	In gdb/python/py-value.c, in the value_object_methods array I noticed:
	...
	  { "const_value", valpy_const_value, METH_NOARGS,
	    "Return a 'const' qualied version of the same value." },
	...

	Fix the qualied -> qualified typo.

	Reviewed-By: Tom Tromey <tom@tromey.com>

2023-06-03  Tom de Vries  <tdevries@suse.de>

	[gdb/guile] Fix doc string for value-optimized-out?
	In gdb/guile/scm-value.c, I noticed in the value_functions array initializer:
	...
	  { "value-optimized-out?", 1, 0, 0,
	    as_a_scm_t_subr (gdbscm_value_optimized_out_p),
	    "\
	Return #t if the value has been optimizd out." },
	...
	There's a typo in the doc string.

	Fix this by using "optimized".

	Reviewed-By: Tom Tromey <tom@tromey.com>

2023-06-03  Tom de Vries  <tdevries@suse.de>

	[gdb/tui] Fix help text of show tui tab-width
	I noticed:
	...
	(gdb) help show tui tab-width
	Show the tab witdh, in characters, for the TUI.
	This variable controls how many spaces are used to display a tab character.
	...
	a typo: "witdh".

	Fix this by using "width" instead.

	Reviewed-By: Tom Tromey <tom@tromey.com>

2023-06-03  Tom de Vries  <tdevries@suse.de>

	[gdb/cli] Fix help text of maint info target-sections
	I noticed a typo:
	...
	(gdb) help maint info target-sections
	List GDB's internal section table.

	Print the current targets section list.  This is a sub-set of all
	sections, from all objects currently loaded.  Usually the ALLOC
	sectoins.
	...

	Fix this by using "sections".

	Reviewed-By: Tom Tromey <tom@tromey.com>

2023-06-03  Tom de Vries  <tdevries@suse.de>

	[gdb/cli] Fix help text of maint set ignore-prologue-end-flag
	I noticed here:
	...
	(gdb) help maint set ignore-prologue-end-flag
	Set if the PROLOGUE-END flag is ignored.
	The PROLOGUE-END flag from the line-table entries is used to place \
	  breakpoints past the prologue of functions.  Disabeling its use use forces \
	  the use of prologue scanners.
	...
	a typo in "Disabeling" and accidental word repetition "use use".

	Fix by replacing with "Disabling" and "use".

	Reviewed-By: Tom Tromey <tom@tromey.com>

2023-06-03  Tom de Vries  <tdevries@suse.de>

	[gdb/compile] Fix typo in debug message
	In compile_object_load in gdb/compile/compile-object-load.c I came across:
	...
				"Connectiong ELF symbol \"%s\" to the .toc section (%s)\n",
	...

	Fix this typo by using "Connecting" instead.

	Reviewed-By: Tom Tromey <tom@tromey.com>

2023-06-03  Tom de Vries  <tdevries@suse.de>

	[gdbserver] Fix typo in debug message
	I noticed in emit_ops_insns in gdbserver/linux-aarch64-low.cc:
	...
	  threads_debug_printf ("Adding %d instrucions at %s",
	...

	Fix the typo by using "instructions" instead.

	Reviewed-By: Tom Tromey <tom@tromey.com>

2023-06-03  Tom de Vries  <tdevries@suse.de>

	[gdb/ada] Fix argument name misspelling
	Two functions use the argument name bounds_prefered_p.

	This misspells "preferred".

	Fix this by using bounds_preferred_p instead.

	Tested on x86_64-linux.

	Reviewed-By: Tom Tromey <tom@tromey.com>

2023-06-03  Alan Modra  <amodra@gmail.com>

	Re: loongarch readelf support
	Another segfault.

		* readelf.c (target_specific_reloc_handling): Sanity check
		loongarch reloc r_offset.

2023-06-03  Alan Modra  <amodra@gmail.com>

	Re: More ecoff sanity checks
	Yet another fuzzer fix.

		* ecoff.c (ecoff_slurp_symbolic_header <FIX>): Zero counts when
		associated pointer is zero.
		(_bfd_ecoff_slurp_symbolic_info): Remove now unnecessary check.

2023-06-03  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-06-02  Luis Machado  <luis.machado@arm.com>

	[AArch64] Fix architecture debug version constant thinkos
	Caught this during emulator testing.

	Fix the constants. They should be 0xa and 0xb as opposed to 0x10 and
	0x11.  There was a thinko while defining them.

	Obvious enough.

	Tested on aarch64-linux Ubuntu 20.04/22.04.

2023-06-02  Alan Modra  <amodra@gmail.com>

	Re: bfd_close and target free_cached_memory
	_bfd_delete_bfd can be called early, before the target xvec is set up.

		* opncls.c (_bfd_delete_bfd): Don't segfault on NULL xvec.

2023-06-02  Alan Modra  <amodra@gmail.com>

	Re: More ecoff sanity checks
	Another fix for fuzzed object files, exhibiting as a segfault in
	nm.c filter_symbols when accessing a symbol name.

		* ecoff.c (_bfd_ecoff_slurp_symbol_table): Sanity check
		fdr_ptr->issBase, and tighten sym.iss check.

2023-06-02  Alan Modra  <amodra@gmail.com>

	loongarch readelf support
	This fixes two buffer overflows found by fuzzers.

		* readelf.c (target_specific_reloc_handling): Sanity check
		loongarch reloc symbol index.  Don't apply reloc after errors.
		Reduce translation work of "invalid symbol index" error message.

2023-06-02  Alan Modra  <amodra@gmail.com>

	Minor objcopy optimisation for copy_relocations_in_section
		* objcopy (copy_relocations_in_section): Don't read the relocs
		for STRIP_ALL if keep_specific_htab is empty.

2023-06-02  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-06-01  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: avoid using magic number
	Define a new constant for the maximum number of stack offsets handled in
	libsframe, and use it.  Note that the SFrame format does not define such
	a constant (limit).  This is an implmentation-defined constant in
	libsframe.

	include/
		* sframe-api.h (MAX_NUM_STACK_OFFSETS): New definition.
	libsframe/
		* sframe.c (sframe_fre_sanity_check_p): Use it.

2023-06-01  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: minor fixups in flip_fre related functions
	libsframe/
		* sframe.c (flip_fre_start_address): Remove unnecessary type
		cast.  Use uint16_t instead of unsigned short.
		(flip_fre_stack_offsets): Likewise.

2023-06-01  Jim Wilson  <jimw@sifive.com>

	RISC-V: PR30449, Add lga assembler macro support.
	Originally discussion, https://github.com/riscv/riscv-isa-manual/pull/539

	Added new load address pseudo instruction which is always expanded to GOT
	access, no matter the .option rvc is set or not.

	gas/
		PR 30449
		* config/tc-riscv.c (macro): Add M_LGA support.
		* testsuite/gas/riscv/la-variants.d: New.
		* testsuite/gas/riscv/la-variants.s: New.
	include/
		PR 30449
		* opcode/riscv.h (M_LGA): New.
	opcodes/
		PR 30449
		* riscv-opc.c (riscv_opcodes): Add lga support.

2023-06-01  Nelson Chu  <nelson@rivosinc.com>

	[PR ld/22263][PR ld/24676] RISC-V: Avoid spurious R_RISCV_NONE for TLS GD/IE.
	For TLS GD/IE, add the same condition with the relocate_section in the
	allocate_dynrelocs, to make sure we won't reserve redundant spaces
	for dynamic relocations since the conservative estimatation.

	After applying this patch, ld seems no longer generate the spurious
	R_RISCV_NONE for pr22263-1 test, and the test in pr24676.

	bfd/
		PR ld/22263
		PR ld/24676
		* elfnn-riscv.c (RISCV_TLS_GD_IE_NEED_DYN_RELOC): New defined.
		Set NEED_RELOC to true if TLS GD/IE needs dynamic relocations,
		and INDX will be the dynamic index.
		(allocate_dynrelocs): Don't reserve extra spaces in the rela.got
		if RISCV_TLS_GD_IE_NEED_DYN_RELOC set need_reloc to false.  This
		condition needs to be same as relocate_section.
		(relocate_section): Likewise, use the same condition as
		allocate_dynrelocs.

2023-06-01  Alan Modra  <amodra@gmail.com>

	Harden PowerPC64 OPD handling against fuzzers
	PowerPC64 ELFv1 object files should have at most one .opd section, and
	OPD handling in elf64-ppc.c makes use of this fact by caching some
	.opd section info in the per-object bfd.tdata.  This was done to avoid
	another word in the target specific section data.  Of course, fuzzers
	don't respect the ABI, and even non-malicious users can accidentally
	create multiple .opd sections.  So it is better to avoid possible
	buffer overflows and other confusion when OPD handling for a second
	.opd section references data for the first .opd section, by keeping
	the data per-section.

	The patch also fixes a memory leak, and a corner case where I think we
	could hit an assertion in opd_entry_value or read out of bounds in
	ppc64_elf_branch_reloc doing a final link producing non-ppc64 output.
	(It's a really rare corner case because not only would you need to be
	linking ppc64 objects to non-ppc64 output, you'd also need a branch
	reloc symbol to be defined in a .opd section of a non-ppc64 input.)

		* elf64-ppc.c (is_ppc64_elf): Move earlier in file.
		(ppc64_elf_branch_reloc): Check symbol bfd before accessing
		ppc64 elf specific data structures.
		(struct ppc64_elf_obj_tdata): Move opd union..
		(struct _ppc64_elf_section_data): ..to here.
		(ppc64_elf_before_check_relocs): Allow for opd sec_type
		already set to sec_opd.
		(ppc64_elf_check_relocs): Only set sec_type to sec_toc when
		unset.  Error for unexpected toc relocs.
		(opd_entry_value): Return -1 when non-ppc64 rather than
		asserting.  Check and set sec_type too.  Adjust for changed
		location of contents and relocs.
		(ppc64_elf_relocate_section): Adjust for changed location of
		cached .opd relocs.
		(ppc64_elf_free_cached_info): New function.
		(bfd_elf64_bfd_free_cached_info): Define.

2023-06-01  Alan Modra  <amodra@gmail.com>

	bfd_close and target free_cached_memory
	bfd_free_cached_info is used in just one place in archive.c, which
	means most times we reach bfd_close the function isn't called.  On the
	other hand, if bfd_free_cached_info is called we can't do much on the
	bfd since it loses all its obj_alloc memory.  This restricts what can
	be done in a target _close_and_cleanup.  In particular you can't look
	at sections, which leads to duplication of code in target
	close_and_cleanup and free_cached_info, eg. elfnn-aarch64.c.

		* opncls.c (_bfd_delete_bfd): Call bfd_free_cached_info.
		* elfnn-aarch64.c (elfNN_aarch64_close_and_cleanup): Delete.
		(bfd_elfNN_close_and_cleanup): Don't define.
		* som.c (som_bfd_free_cached_info): Don't call
		_bfd_generic_close_and_cleanup here.
		(som_close_and_cleanup): Define as _bfd_generic_close_and_cleanup.

2023-06-01  Alan Modra  <amodra@gmail.com>

	section_by_target_index memory leak
	The rs6000 backend can call coff_section_from_bfd_index from its
	object_p function via coff_set_alignment_hook.  If the object doesn't
	match, or another target matches too, then the hash table needs to be
	freed via a cleanup.

		* coffgen.c (coff_object_cleanup): New function.
		(coff_real_object_p): Return coff_object_cleanup, and call on
		failure path.  Move declaration to..
		* libcoff-in.h: ..here.
		(coff_object_cleanup): Declare.
		* coff-stgo32.c (go32exe_cleanup): Call coff_object_cleanup.
		(go32exe_check_format): Adjust assertion.
		* libcoff.h: Regenerate.

2023-06-01  Alan Modra  <amodra@gmail.com>

	Remove BFD_FAIL in cpu-sh.c
	The assertions in cpu-sh.c can be triggered by passing bogus values
	in disassemble_info.mach.  This doesn't cause any bfd misbehaviour.

		* cpu-sh.c (sh_get_arch_from_bfd_mach): Remove BFD_FAIL.
		(sh_get_arch_up_from_bfd_mach): Likewise.

2023-06-01  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-05-31  Vladimir Mezentsev  <vladimir.mezentsev@oracle.com>

	gprofng: Fix -Wsign-compare warning
	gprofng/ChangeLog
	2023-05-25  Vladimir Mezentsev  <vladimir.mezentsev@oracle.com>

		PR gprofng/30490
		* src/LoadObject.cc: Fix -Wsign-compare warning.

2023-05-31  Vladimir Mezentsev  <vladimir.mezentsev@oracle.com>

	gprofng: 29470 The test suite should be made more flexible
	I add two new targets (check-extra, check-install) for gprofng testing:
	  `make check` runs sanity testing for gprofng and takes ~30 secunds.
	  `make check-extra` runs all gprofng tests and takes ~20 minutus.
	  `make check-install` runs all gprofng tests and uses gprofng installation.

	On aarch64, there are unwind problems in libgp-collector.so.
	I set ACCT_FILTER to temporarily ignore problematic functions.

	gprofng/ChangeLog
	2023-05-25  Vladimir Mezentsev  <vladimir.mezentsev@oracle.com>

		PR gprofng/29470
		* Makefile.am: Add check-extra, check-install.
		* Makefile.in: Rebuild
		* testsuite/config/default.exp: Set the GPROFNG variable.
		* testsuite/gprofng.display/display.exp: Updated the test list.
		* testsuite/gprofng.display/jsynprog/Intface.java: Correct copyright.
		* testsuite/gprofng.display/jsynprog/Launcher.java: Likewise.
		* testsuite/gprofng.display/jsynprog/Makefile: Likewise.
		* testsuite/gprofng.display/jsynprog/Routine.java: Likewise.
		* testsuite/gprofng.display/jsynprog/Sub_Routine.java: Likewise.
		* testsuite/gprofng.display/jsynprog/cloop.cc: Likewise.
		* testsuite/gprofng.display/jsynprog/jsynprog.h: Likewise.
		* testsuite/gprofng.display/jsynprog/jsynprog.java: Correct copyright.
		Add the -j option to run the selected functions.
		* testsuite/gprofng.display/synprog/check_results.pl:
		Remove unused environment variable.
		* testsuite/gprofng.display/synprog/synprog.c: Updated DEFAULT_COMMAND.
		* testsuite/lib/Makefile.skel: Apply $(ACCT_FILTER).
		* testsuite/lib/acct.pm: Ignore errors when $(ACCT_FILTER) is set.
		* testsuite/lib/display-lib.exp: Add TARGET_FLAGS in make_args.

2023-05-31  Tom Tromey  <tromey@adacore.com>

	Improve MI -dprintf-insert documentation
	I found the documentation for -dprintf-insert a bit unclear.  It
	didn't mention the possibility of multiple arguments, and I also
	noticed that it implied that the format parameter is optional, which
	it is not.

	While looking into this I also noticed a few comments in the
	implementation that could also be improved.

	Then, I noticed a repeated call to strlen in a loop condition, so I
	fixed this up as well.

	Reviewed-By: Eli Zaretskii <eliz@gnu.org>

2023-05-31  Tom Tromey  <tromey@adacore.com>

	Pass correct name to @value in gdb.texinfo
	I noticed a couple instance of this warning when rebuilding the gdb
	info files:

	    warning: undefined flag: GDB

	The problem is that the wrong argument was passed to @value.  This
	patch fixes the problem.

2023-05-31  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Fix gdb.tui/wrap-line.exp with --disable-tui
	When running the test-case gdb.tui/wrap-line.exp with a build configured with
	--disable-tui, we run into:
	...
	(gdb) PASS: gdb.tui/wrap-line.exp: width-hard-coded: set width 50
	tui new-layout command-layout cmd 1^M
	Undefined command: "tui".  Try "help".^M
	(gdb) ERROR: Undefined command "tui new-layout command-layout cmd 1".
	...

	Fix this by guarding the command with allow_tui_tests.

	Tested on x86_64-linux.

2023-05-31  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Fix gdb.tui/pr30056.exp for native-extended-gdbserver
	When running test-case gdb.tui/pr30056.exp with target board
	native-extended-gdbserver, I run into:
	...
	Quit^[[K^M^[[B(gdb) PASS: gdb.tui/pr30056.exp: Control-C
	Remote debugging from host ::1, port 38810^M
	^M(failed reverse-i-search)`xyz': ^M(gdb) target extended-remote \
	  localhost:2346^[[7GWARNING: Timed out waiting for EOF in server after \
	  monitor exit
	...

	This is due to the fact that ^C doesn't abort the reverse-i-search.  This
	appears to be due to a readline problem.  A PR is open about this: PR
	cli/30498.

	Add a KFAIL for the PR, and ensure that the isearch is aborted by using ^G,
	such that we have a responsive prompt to handle the "monitor exit" command
	that native-extended-gdbserver issues.

	Tested on x86_64-linux.

2023-05-31  Tristan Gingold  <tgingold@free.fr>

	pe/coff - add support for base64 encoded long section names
	  PR 30444
	  * coffcode.h (coff_write_object_contents): Handle base64 encoding on PE.  Also check for too large string table.
	  * coffgen.c (extract_long_section_name): New function extracted from ... (make_a_section_from_file): ... here.  Add support for base64 long section names. (decode_base64): New function.

2023-05-31  Nick Clifton  <nickc@redhat.com>

	Fix printf formating issues in elfxx-loongarch64.c

2023-05-31  Felix Willgerodt  <felix.willgerodt@intel.com>

	python, btrace: Fix some small formatting issues.
	Reviewed-By: Tom Tromey <tom@tromey.com>

2023-05-31  Tom de Vries  <tdevries@suse.de>

	[gdb/tui] Fix fingerprint for cmd-only layout
	I added a cmd-only layout:
	...
	(gdb) tui new-layout cmd cmd 1
	...
	and set it:
	...
	(gdb) layout cmd
	...
	which gave me the expect result: only the cmd window in the screen.

	However, after going back to layout src:
	...
	(gdb) layout src
	...
	I got a source window with only one line in it, and the cmd window taking most
	of the screen.

	I traced this back to tui_set_layout, where for both the old and the new
	layout the fingerprint of the cmd window in the layout is taken.  If the
	fingerprint is the same, an effort will be done to preserve the command
	window size.

	The fingerprint is "VC" for both the old (cmd) and new (src) layouts, which
	explains the behaviour.

	I think this is essentially a bug in the finger print calculation, and it
	should be "C" for the cmd layout.

	Fix this by not adding a V or H in the fingerprint if the list size is one.

	Tested on x86_64-linux.

	Reviewed-By: Tom Tromey <tom@tromey.com>

2023-05-31  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-05-30  Andrew Burgess  <aburgess@redhat.com>

	gdb: add support for %V to printf command
	This commit adds a new format for the printf and dprintf commands:
	'%V'.  This new format takes any GDB expression and formats it as a
	string, just as GDB would for a 'print' command, e.g.:

	  (gdb) print a1
	  $a = {2, 4, 6, 8, 10, 12, 14, 16, 18, 20}
	  (gdb) printf "%V\n", a1
	  {2, 4, 6, 8, 10, 12, 14, 16, 18, 20}
	  (gdb)

	It is also possible to pass the same options to %V as you might pass
	to the print command, e.g.:

	  (gdb) print -elements 3 -- a1
	  $4 = {2, 4, 6...}
	  (gdb) printf "%V[-elements 3]\n", a1
	  {2, 4, 6...}
	  (gdb)

	This new feature would effectively replace an existing feature of GDB,
	the $_as_string builtin convenience function.  However, the
	$_as_string function has a few problems which this new feature solves:

	1. $_as_string doesn't currently work when the inferior is not
	running, e.g:

	  (gdb) printf "%s", $_as_string(a1)
	  You can't do that without a process to debug.
	  (gdb)

	The reason for this is that $_as_string returns a value object with
	string type.  When we try to print this we call value_as_address,
	which ends up trying to push the string into the inferior's address
	space.

	Clearly we could solve this problem, the string data exists in GDB, so
	there's no reason why we have to push it into the inferior, but this
	is an existing problem that would need solving.

	2. $_as_string suffers from the fact that C degrades arrays to
	pointers, e.g.:

	  (gdb) printf "%s\n", $_as_string(a1)
	  0x404260 <a1>
	  (gdb)

	The implementation of $_as_string is passed a gdb.Value object that is
	a pointer, it doesn't understand that it's actually an array.  Solving
	this would be harder than issue #1 I think.  The whole array to
	pointer transformation is part of our expression evaluation.  And in
	most cases this is exactly what we want.  It's not clear to me how
	we'd (easily) tell GDB that we didn't want this reduction in _some_
	cases.  But I'm sure this is solvable if we really wanted to.

	3. $_as_string is a gdb.Function sub-class, and as such is passed
	gdb.Value objects.  There's no super convenient way to pass formatting
	options to $_as_string.  By this I mean that the new %V feature
	supports print formatting options.  Ideally, we might want to add this
	feature to $_as_string, we might imagine it working something like:

	  (gdb) printf "%s\n", $_as_string(a1,
	                                   elements = 3,
	                                   array_indexes = True)

	where the first item is the value to print, while the remaining
	options are the print formatting options.  However, this relies on
	Python calling syntax, which isn't something that convenience
	functions handle.  We could possibly rely on strictly positional
	arguments, like:

	  (gdb) printf "%s\n", $_as_string(a1, 3, 1)

	But that's clearly terrible as there's far more print formatting
	options, and if you needed to set the 9th option you'd need to fill in
	all the previous options.

	And right now, the only way to pass these options to a gdb.Function is
	to have GDB first convert them all into gdb.Value objects, which is
	really overkill for what we want.

	The new %V format solves all these problems: the string is computed
	and printed entirely on the GDB side, we are able to print arrays as
	actual arrays rather than pointers, and we can pass named format
	arguments.

	Finally, the $_as_string is sold in the manual as allowing users to
	print the string representation of flag enums, so given:

	  enum flags
	    {
	      FLAG_A = (1 << 0),
	      FLAG_B = (1 << 1),
	      FLAG_C = (1 << 1)
	    };

	  enum flags ff = FLAG_B;

	We can:

	  (gdb) printf "%s\n", $_as_string(ff)
	  FLAG_B

	This works just fine with %V too:

	  (gdb) printf "%V\n", ff
	  FLAG_B

	So all functionality of $_as_string is replaced by %V.  I'm not
	proposing to remove $_as_string, there might be users currently
	depending on it, but I am proposing that we don't push $_as_string in
	the documentation.

	As %V is a feature of printf, GDB's dprintf breakpoints naturally gain
	access to this feature too.  dprintf breakpoints can be operated in
	three different styles 'gdb' (use GDB's printf), 'call' (call a
	function in the inferior), or 'agent' (perform the dprintf on the
	remote).

	The use of '%V' will work just fine when dprintf-style is 'gdb'.

	When dprintf-style is 'call' the format string and arguments are
	passed to an inferior function (printf by default).  In this case GDB
	doesn't prevent use of '%V', but the documentation makes it clear that
	support for '%V' will depend on the inferior function being called.

	I chose this approach because the current implementation doesn't place
	any restrictions on the format string when operating in 'call' style.
	That is, the user might already be calling a function that supports
	custom print format specifiers (maybe including '%V') so, I claim, it
	would be wrong to block use of '%V' in this case.  The documentation
	does make it clear that users shouldn't expect this to "just work"
	though.

	When dprintf-style is 'agent' then GDB does no support the use of
	'%V' (right now).  This is handled at the point when GDB tries to
	process the format string and send the dprintf command to the remote,
	here's an example:

	  Reading symbols from /tmp/hello.x...
	  (gdb) dprintf call_me, "%V", a1
	  Dprintf 1 at 0x401152: file /tmp/hello.c, line 8.
	  (gdb) set sysroot /
	  (gdb) target remote | gdbserver --once - /tmp/hello.x
	  Remote debugging using | gdbserver --once - /tmp/hello.x
	  stdin/stdout redirected
	  Process /tmp/hello.x created; pid = 3088822
	  Remote debugging using stdio
	  Reading symbols from /lib64/ld-linux-x86-64.so.2...
	  (No debugging symbols found in /lib64/ld-linux-x86-64.so.2)
	  0x00007ffff7fd3110 in _start () from /lib64/ld-linux-x86-64.so.2
	  (gdb) set dprintf-style agent
	  (gdb) c
	  Continuing.
	  Unrecognized format specifier 'V' in printf
	  Command aborted.
	  (gdb)

	This is exactly how GDB would handle any other invalid format
	specifier, for example:

	  Reading symbols from /tmp/hello.x...
	  (gdb) dprintf call_me, "%Q", a1
	  Dprintf 1 at 0x401152: file /tmp/hello.c, line 8.
	  (gdb) set sysroot /
	  (gdb) target remote | gdbserver --once - /tmp/hello.x
	  Remote debugging using | gdbserver --once - /tmp/hello.x
	  stdin/stdout redirected
	  Process /tmp/hello.x created; pid = 3089193
	  Remote debugging using stdio
	  Reading symbols from /lib64/ld-linux-x86-64.so.2...
	  (No debugging symbols found in /lib64/ld-linux-x86-64.so.2)
	  0x00007ffff7fd3110 in _start () from /lib64/ld-linux-x86-64.so.2
	  (gdb) set dprintf-style agent
	  (gdb) c
	  Continuing.
	  Unrecognized format specifier 'Q' in printf
	  Command aborted.
	  (gdb)

	The error message isn't the greatest, but improving that can be put
	off for another day I hope.

	Reviewed-By: Eli Zaretskii <eliz@gnu.org>
	Acked-By: Simon Marchi <simon.marchi@efficios.com>

2023-05-30  Simon Marchi  <simon.marchi@efficios.com>

	gdb: add interp::on_memory_changed method
	Same idea as previous patches, but for memory_changed.

	Change-Id: Ic19f20c24d8a6431d4a89c5625e8ef4898f76e82

2023-05-30  Simon Marchi  <simon.marchi@efficios.com>

	gdb: add interp::on_param_changed method
	Same idea as previous patches, but for command_param_changed.

	Change-Id: I7c2196343423360da05f016f8ffa871c064092bb

2023-05-30  Simon Marchi  <simon.marchi@efficios.com>

	gdb: add interp::on_breakpoint_modified method
	Same idea as previous patches, but for breakpoint_modified.

	Change-Id: I4f0a9edea912de431e32451d74224b2022a7c328

2023-05-30  Simon Marchi  <simon.marchi@efficios.com>

	gdb: add interp::on_breakpoint_deleted method
	Same idea as previous patches, but for breakpoint_deleted.

	Change-Id: I59c231ce963491bb1eee1432ee1090138f09e19c

2023-05-30  Simon Marchi  <simon.marchi@efficios.com>

	gdb: add interp::on_breakpoint_created method
	Same idea as previous patches, but for breakpoint_created.

	Change-Id: I614113c924edc243590018b8fb3bf69cb62215ef

2023-05-30  Simon Marchi  <simon.marchi@efficios.com>

	gdb: add interp::on_tsv_modified method
	Same idea as previous patches, but for tsv_modified.

	Change-Id: I55454a2386d5450040b3a353909b26f389a43682

2023-05-30  Simon Marchi  <simon.marchi@efficios.com>

	gdb: add interp::on_tsv_deleted method
	Same idea as previous patches, but for tsv_deleted.

	Change-Id: I71b0502b493da7b6e293bee02aeca98de83d4b75

2023-05-30  Simon Marchi  <simon.marchi@efficios.com>

	gdb: add interp::on_tsv_created method
	Same idea as previous patches, but for tsv_created.

	Change-Id: I9c30ecfdbd78ca015d613f43a0c0aef6c7eb32b5

2023-05-30  Simon Marchi  <simon.marchi@efficios.com>

	gdb: add interp::on_traceframe_changed method
	Same idea as previous patches, but for traceframe_changed.

	Change-Id: Ia473f07d70d57b30aca0094d0e0585d7e0d95637

2023-05-30  Simon Marchi  <simon.marchi@efficios.com>

	gdb: add interp::on_about_to_proceed method
	Same idea as previous patches, but for about_to_proceed.  We only need
	(and want, as far as the mi_interp implementation is concerned) to
	notify the interpreter that caused the proceed.

	Change-Id: Id259bca10dbc3d43d46607ff7b95243a9cbe2f89

2023-05-30  Simon Marchi  <simon.marchi@efficios.com>

	gdb: add interp::on_solib_unloaded method
	Same idea as previous patches, but for solib_unloaded.

	Change-Id: Iad847de93f0b38b5c90679a173d3beeaed7af6c5

2023-05-30  Simon Marchi  <simon.marchi@efficios.com>

	gdb: add interp::on_solib_loaded method
	Same idea as previous patches, but for solib_loaded

	Change-Id: I85edb0a4b377f4b2c39ffccf31cb75f38bae0f55

2023-05-30  Simon Marchi  <simon.marchi@efficios.com>

	gdb: add interp::on_target_resumed method
	Same idea as previous patches, but for target_resumed.

	Change-Id: I66fa28d1d41a1f3c4fb0d6a470137d493eac3c8c

2023-05-30  Simon Marchi  <simon.marchi@efficios.com>

	gdb: add interp::on_record_changed method
	Same idea as previous patches, but for record_changed

	Change-Id: I5eeeacd703af8401c315060514c94e8e6439cc40

2023-05-30  Simon Marchi  <simon.marchi@efficios.com>

	gdb: add interp::on_inferior_removed method
	Same idea as previous patches, but for inferior_removed.

	Change-Id: I7971840bbbdcfabf77e2ded7584830c9dfdd10d0

2023-05-30  Simon Marchi  <simon.marchi@efficios.com>

	gdb: add interp::on_inferior_disappeared method
	Same idea as previous patches, but for inferior_disappeared.

	For symmetry with on_inferior_appeared, I named this one
	on_inferior_disappeared, despite the observer being called
	inferior_exit.  This is called when detaching an inferior, so I think
	that calling it "disappeared" is a bit less misleading (the observer
	should probably be renamed later).

	Change-Id: I372101586bc9454997953c1e540a2a6685f53ef6

2023-05-30  Simon Marchi  <simon.marchi@efficios.com>

	gdb: add interp::on_inferior_appeared method
	Same idea as previous patches, but for inferior_appeared.

	Change-Id: Ibe4feba34274549a886b1dfb5b3f8d59ae79e1b5

2023-05-30  Simon Marchi  <simon.marchi@efficios.com>

	gdb: add interp::on_inferior_added method
	Same idea as previous patches, but for inferior_added.

	mi_interp::init avoided using mi_inferior_added, since, as the comment
	used to say, it would notify all MI interpreters.  Now, it's easy to
	only notify the new interpreter, so it's possible to just call the
	on_inferior_added method in mi_interp::init.

	Change-Id: I0eddbd5367217d1c982516982089913019ef309f

2023-05-30  Simon Marchi  <simon.marchi@efficios.com>

	gdb: add interp::on_thread_exited method
	Same idea as previous patches, but for thread_exited.

	Change-Id: I4be974cbe58cf635453fef503c2d77c82522cbd9

2023-05-30  Simon Marchi  <simon.marchi@efficios.com>

	gdb: add interp::on_new_thread method
	Same idea as previous patches, but for new_thread.

	Change-Id: Ib70ae3421b736fd69d86c4e7c708bec349aa256c

2023-05-30  Simon Marchi  <simon.marchi@efficios.com>

	gdb: add interp::on_user_selected_context_changed method
	Same as previous patches, but for user_selected_context_changed.

	Change-Id: I40de15be897671227d4bcf3e747f0fd595f0d5be

2023-05-30  Simon Marchi  <simon.marchi@efficios.com>

	gdb: add interp::on_command_error method
	Same idea as the previous patches, but for command_error.

	Change-Id: If6098225dd72fad8be13b3023b35bc8bc48efb9d

2023-05-30  Simon Marchi  <simon.marchi@efficios.com>

	gdb: add interp::on_sync_execution_done method
	Same as previous patches, but for sync_execution_done.  Except that
	here, we only want to notify the interpreter that is executing the
	command, not all interpreters.

	Change-Id: I729c719447b5c5f29af65dbf6fed9132e2cd308b

2023-05-30  Simon Marchi  <simon.marchi@efficios.com>

	gdb: add interp::on_no_history method
	Same as previous patches, but for no_history.

	Change-Id: I06930fe7cb4082138c6c5496c5118fe4951c10da

2023-05-30  Simon Marchi  <simon.marchi@efficios.com>

	gdb: add interp::on_exited method
	Same as previous patch, but for exited.  Remove the exited observable,
	since nothing uses it anymore, and we don't have anything coming that
	will use it.

	Change-Id: I358cbea0159af56752dfee7510d6a86191e722bb

2023-05-30  Simon Marchi  <simon.marchi@efficios.com>

	gdb: add interp::on_signal_exited method
	Same as previous patch, but for signal_exited.  Remove the signal_exited
	observable, since nothing uses it anymore, and we don't have anything
	coming that will use it.

	Change-Id: I0dca1eab76338bf27be755786e3dad3241698b10

2023-05-30  Simon Marchi  <simon.marchi@efficios.com>

	gdb: add interp::on_normal_stop method
	Same idea as the previous patch, but for the normal_stop event.

	Change-Id: I4fc8ca8a51c63829dea390a2b6ce30b77f9fb863

2023-05-30  Simon Marchi  <simon.marchi@efficios.com>

	gdb: add interp::on_signal_received method
	Instead of having the interpreter code registering observers for the
	signal_received observable, add a "signal_received" virtual method to
	struct interp.  Add a interps_notify_signal_received function that loops
	over all UIs and calls the signal_received method on the interpreter.
	Finally, add a notify_signal_received function that calls
	interps_notify_signal_received and then notifies the observers.  Replace
	all existing notifications to the signal_received observers with calls
	to notify_signal_received.

	Before this patch, the CLI and MI code both register a signal_received
	observer.  These observer go over all UIs, and, for those that have a
	interpreter of the right kind, print the stop notifiation.

	After this patch, we have just one "loop over all UIs", inside
	interps_notify_signal_received.  Since the interp::on_signal_received
	method gets called once for each interpreter, the implementations only
	need to deal with the current interpreter (the "this" pointer).

	The motivation for this patch comes from a future patch, that makes the
	amdgpu code register an observer to print a warning after the CLI's
	signal stop message.  Since the amdgpu and the CLI code both use
	observers, the order of the two messages is not stable, unless we define
	the priority using the observer dependency system.  However, the
	approach of using virtual methods on the interpreters seems like a good
	change anyway, I think it's more straightforward and simple to
	understand than the current solution that uses observers.  We are sure
	that the amdgpu message gets printed after the CLI message, since
	observers are notified after interpreters.

	Keep the signal_received, even if nothing uses if, because we will be
	using it in the upcoming amdgpu patch implementing the warning described
	above.

	Change-Id: I4d8614bb8f6e0717f4bfc2a59abded3702f23ac4

2023-05-30  Tom de Vries  <tdevries@suse.de>

	[gdb] Mention --with/without-system-readline for --configuration
	Simon reported that the new test-case gdb.tui/pr30056.exp fails with system
	readline.

	This is because the test-case requires a fix in readline that's present in our
	in-repo copy of readline, but most likely not in any system readline yet.

	Fix this by:
	- mentioning --with-system-readline or --without-system-readline in the
	  configuration string.
	- adding a new proc with_system_readline that makes this information available
	  in the testsuite.
	- using this in test-case gdb.tui/pr30056.exp to declare it unsupported for
	  --with-system-readline.

	Tested on x86_64-linux.

	Reported-By: Simon Marchi <simon.marchi@efficios.com>
	Approved-By: Simon Marchi <simon.marchi@efficios.com>

2023-05-30  Nick Clifton  <nickc@redhat.com>

	Slight wording improvement for the -Ur documentation

	Improve header information displayed with objdump -P for PE binaries.
	  * od-pe.c (targ_info): New array.
	  (get_target_specific_info): New function.
	  (decode_machine_number): Retire.  Use get_target_specific_info instead.
	  (is_pe_object_magic): Likewise.
	  (dump_pe_file_header): Display more information.
	  Rework layout to be similar to that from 'objdump -p'.
	  Add code to handle larger than normnal AOUT headers.

2023-05-30  mengqinggang  <mengqinggang@loongson.cn>

	LoongArch: ld: Add support for linker relaxation.
	Add ld relax support and testsuits.

	ld/ChangeLog:

		* emultempl/loongarchelf.em: Regenerated.
		* testsuite/ld-elf/compressed1d.d: Xfail loongarch*-*.
		* testsuite/ld-elf/pr26936.d: Likewise.
		* testsuite/ld-loongarch-elf/disas-jirl.d: Regenerated.
		* testsuite/ld-loongarch-elf/disas-jirl-32.d: Regenerated.
		* testsuite/ld-loongarch-elf/jmp_op.d: Likewise.
		* testsuite/ld-loongarch-elf/macro_op.d: Likewise.
		* testsuite/ld-loongarch-elf/macro_op_32.d: Likewise.
		* testsuite/ld-loongarch-elf/relax-align.dd: New test.
		* testsuite/ld-loongarch-elf/relax-align.s: New test.
		* testsuite/ld-loongarch-elf/relax.exp: New test.
		* testsuite/ld-loongarch-elf/relax.s: New test.
		* testsuite/ld-loongarch-elf/uleb128.dd: New test.
		* testsuite/ld-loongarch-elf/uleb128.s: New test.

2023-05-30  mengqinggang  <mengqinggang@loongson.cn>

	LoongArch: gas: Add support for linker relaxation.
	Add gas -mrelax and -mno-relax option.
	Add R_LARCH_RELAX reloc for instrction if it can be relaxed.
	ADD R_LARCH_ALIGN reloc for align pseudo instruction because relax.
	Add ADD/SUB reloc pair for debug and exception data to calculate symbol
	substraction because relax.

	gas/ChangeLog:

		* config/tc-loongarch.c:
		(struct loongarch_cl_insn): New macro_id member.
		(enum options): New OPTION_RELAX and OPTION_NO_RELAX.
		(struct option): New mrelax and mno-relax.
		(md_parse_option): Likewise.
		(get_internal_label):
		(loongarch_args_parser_can_match_arg_helper): Generate relax reloc.
		(move_insn): Set fx_frag and fx_where if exist.
		(append_fixp_and_insn): Call frag_wane and frag_new for linker relax
		relocs.
		(loongarch_assemble_INSNs): New loongarch_cl_insn pointer parameter.
		(md_assemble): Fix function call.
		(fix_reloc_insn): Likewise.
		(md_apply_fix): Generate ADD/SUB reloc pair for debug and exception
		data.
		(loongarch_fix_adjustable): Delete.
		(md_convert_frag): Generate new fix.
		(loongarch_pre_output_hook): New function.
		(loongarch_make_nops): Likewise.
		(loongarch_frag_align_code): Likewise.
		(loongarch_insert_uleb128_fixes): Likewise.
		(loongarch_md_finish): Likewise.
		* config/tc-loongarch.h
		(md_allow_local_subtract): New macro define.
		(loongarch_frag_align_code): New declare.
		(md_do_align): Likewise.
		(loongarch_fix_adjustable): Delete.
		(tc_fix_adjustable): New macro define.
		(TC_FORCE_RELOCATION_SUB_SAME): Likewise.
		(TC_LINKRELAX_FIXUP): Likewise.
		(TC_FORCE_RELOCATION_LOCAL): Likewise.
		(DWARF2_USE_FIXED_ADVANCE_PC): Likewise.
		(MD_APPLY_SYM_VALUE): Likewise.
		(tc_symbol_new_hook): New extern.
		(NOP_OPCODE): Delete.
		(loongarch_pre_output_hook): New macro define.
		(md_pre_output_hook): Likewise.
		(md_finish): Likewise.
		(loongarch_md_finish): New extern.
		* testsuite/gas/all/align.d: Mark as unsupported on LoongArch.
		* testsuite/gas/all/gas.exp: Xfail loongarch*-*.
		* testsuite/gas/all/relax.d: Likewise.
		* testsuite/gas/elf/dwarf-5-irp.d: Likewise.
		* testsuite/gas/elf/dwarf-5-loc0.d: Likewise.
		* testsuite/gas/elf/dwarf-5-macro-include.d: Likewise.
		* testsuite/gas/elf/dwarf-5-macro.d: Likewise.
		* testsuite/gas/elf/dwarf2-11.d: Likewise.
		* testsuite/gas/elf/dwarf2-15.d: Likewise.
		* testsuite/gas/elf/dwarf2-16.d: Likewise.
		* testsuite/gas/elf/dwarf2-17.d: Likewise.
		* testsuite/gas/elf/dwarf2-18.d: Likewise.
		* testsuite/gas/elf/dwarf2-19.d: Likewise.
		* testsuite/gas/elf/dwarf2-5.d: Likewise.
		* testsuite/gas/elf/ehopt0.d: Likewise.
		* testsuite/gas/elf/elf.exp: Likewise.
		* testsuite/gas/elf/section11.d: Likewise.
		* testsuite/gas/lns/lns.exp: Likewise.
		* testsuite/gas/loongarch/jmp_op.d: Regenerated.
		* testsuite/gas/loongarch/li.d: Likewise.
		* testsuite/gas/loongarch/macro_op.d: Likewise.
		* testsuite/gas/loongarch/macro_op_32.d: Likewise.
		* testsuite/gas/loongarch/macro_op_large_abs.d: Likewise.
		* testsuite/gas/loongarch/macro_op_large_pc.d: Likewise.
		* testsuite/gas/loongarch/relax_align.d: New test.
		* testsuite/gas/loongarch/relax_align.s: New test.
		* testsuite/gas/loongarch/uleb128.d: New test.
		* testsuite/gas/loongarch/uleb128.s: New test.

2023-05-30  mengqinggang  <mengqinggang@loongson.cn>

	LoongArch: binutils: Add support for linker relaxation.
	Add support for relocs related to relax to readelf.

	binutils/ChangeLog:

		* readelf.c (target_specific_reloc_handling): Handle ULEB128 reloc.
		(is_32bit_inplace_add_reloc): Handle new reloc.
		(is_32bit_inplace_sub_reloc): Likewise.
		(is_64bit_inplace_add_reloc): Likewise.
		(is_64bit_inplace_sub_reloc): Likewise.
		(is_16bit_inplace_add_reloc): Likewise.
		(is_16bit_inplace_sub_reloc): Likewise.
		(is_8bit_inplace_add_reloc): Likewise.
		(is_8bit_inplace_sub_reloc): Likewise.
		(is_6bit_inplace_sub_reloc): Likewise.
		(is_6bit_inplace_add_reloc): New function.
		(apply_relocations): Handle new reloc.
		* testsuite/binutils-all/readelf.exp: Add -mno-relax option
		for LoongArch.

2023-05-30  mengqinggang  <mengqinggang@loongson.cn>

	LoongArch: opcodes: Add support for linker relaxation.
	Set gas default to enable relax.

	opcodes/ChangeLog:

		* loongarch-opc.c (struct loongarch_ASEs_option): New member relax
		with the default value 1.

2023-05-30  mengqinggang  <mengqinggang@loongson.cn>

	LoongArch: bfd: Add support for linker relaxation.
	Add relax support and related relocs in bfd.

	bfd/ChangeLog:

		* bfd-in2.h: Add relocs related to relax.
		* elfnn-loongarch.c (struct loongarch_elf_link_hash_table): New integer
		pointer (data_segment_phase) to monitor the data segment phase.
		(loongarch_elf_check_relocs): Swap B21/B26 reloc sequence.
		(loongarch_elf_adjust_dynamic_symbol): Fix code format.
		(loongarch_reloc_rewrite_imm_insn): Fix function call.
		(perform_relocation): Handle new relocs related to relax.
		(RELOCATE_CALC_PC32_HI20): Fix code format.
		(RELOCATE_CALC_PC64_HI32): Likewise.
		(loongarch_elf_relocate_section): Handle new relocs related to relax.
		(loongarch_relax_delete_bytes): New function.
		(loongarch_relax_pcala_addi): Likewise.
		(loongarch_relax_pcala_ld): Likewise.
		(bfd_elfNN_loongarch_set_data_segment_info): Likewise.
		(loongarch_relax_align): Likewise.
		(loongarch_elf_relax_section): Likewise.
		(bfd_elfNN_bfd_relax_section): New macro define.
		* elfxx-loongarch.c (reloc_bits): New bfd point parameter.
		(reloc_bits_b16): Likewise.
		(reloc_bits_b21): Likewise.
		(reloc_bits_b26): Likewise.
		(loongarch_adjust_reloc_bitsfield): Likewise.
		(reloc_bits_pcrel20_s2): New function.
		(loongarch_elf_add_sub_reloc): Likewise.
		(loongarch_elf_add_sub_reloc_uleb128): Likewise.
		(loongarch_write_unsigned_leb128): New function.
		* elfxx-loongarch.h (loongarch_adjust_reloc_bitsfield): New bfd point
		parameter.
		(bfd_elf32_loongarch_set_data_segment_info): New declare.
		(bfd_elf64_loongarch_set_data_segment_info): Likewise.
		(loongarch_write_unsigned_leb128): Likewise.
		* libbfd.h: Add relocs related to relax.
		* reloc.c: Add relocs related to relax.

2023-05-30  mengqinggang  <mengqinggang@loongson.cn>

	LoongArch: include: Add support for linker relaxation.
	Add relocs and gas LARCH_opts.relax option.

	include/ChangeLog:

		* elf/loongarch.h: Add relocs.
		* opcode/loongarch.h: Add LARCH_opts.relax and macro LARCH_NOP.

2023-05-30  Nick Clifton  <nickc@redhat.com>

	Add support for an ARMMAGIC value of 0xa00 to the PE dumper.

2023-05-30  Alan Modra  <amodra@gmail.com>

	arm-pe objdump -P
	arm-pe looks to be a very old PE implementation, incompatible with
	current arm-wince-pe.  arm-pe has different relocations and uses
	ARMMAGIC which has this comment: "I just made this up".  Well, OK, I
	don't know the history but it was probably before Microsoft "just made
	up" their constants for ARM windows CE.

	This patch supports objdump -P for arm-pe, and another magic constant
	that may appear in object files.  (I don't think binutils generates
	files using ARMV7PEMAGIC aka IMAGE_FILE_MACHINE_ARMNT.)

		* od-pe.c (is_pe_object_magic): Handle IMAGE_FILE_MACHINE_ARMNT
		and ARMMAGIC.

2023-05-30  Alan Modra  <amodra@gmail.com>

	Define IMAGE_FILE_MACHINE_ARMNT
	Same value as ARMV7PEMAGIC.
	https://learn.microsoft.com/en-us/windows/win32/sysinfo/image-file-machine-constants

		* coff/pe.h (IMAGE_FILE_MACHINE_ARMNT): Define.

2023-05-30  Alan Modra  <amodra@gmail.com>

	Don't define COFF_MAGIC
	This macro was unused apart from aout/encap.h, which has been deleted.

		* config/tc-arm.h (COFF_MAGIC): Don't define.
		* config/tc-sh.h (COFF_MAGIC): Don't define.
		* config/tc-z80.h (COFF_MAGIC): Don't define.
		* config/tc-z8k.h (COFF_MAGIC): Don't define.

2023-05-30  Alan Modra  <amodra@gmail.com>

	Delete include/aout/encap.h
	This file is unused and as the header comment says, obsolete.

	Regen binutils POTFILES.in
	for od-pe.c

2023-05-30  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-05-29  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Fix linefeed scrolling in tuiterm
	I came across a bug in the implementation of line feed in tuiterm, and added a
	unit test that exposes it.

	Before sending the line feed we have:
	...
	Screen Dump (size 8 columns x 4 rows, cursor at column 0, row 3):
	    0 abcdefgh
	    1 ijklmnop
	    2 qrstuvwx
	    3 yz01234
	...
	and after it we have:
	...
	Screen Dump (size 8 columns x 4 rows, cursor at column 0, row 1):
	    0 ijklmnop
	    1 qrstuvwx
	    2 yz01234
	    3 yz01234
	...

	Note how the cursor started at row 3 and after the line feed ended up at
	row 1, while it should have stayed in row 3.

	Fix this by moving "incr _cur_row -1" one level up in the loop nest in
	proc _ctl_0x0a.

	Tested on x86_64-linux.

2023-05-29  Simon Marchi  <simon.marchi@efficios.com>

	gdb/mi: fix ^running record with multiple MI interpreters
	I stumbled on the mi_proceeded and running_result_record_printed
	globals, which are shared by all MI interpreter instances (it's unlikely
	that people use multiple MI interpreter instances, but it's possible).
	After poking at it, I found this bug:

	1. Start GDB in MI mode
	2. Add a second MI interpreter with the new-ui command
	3. Use -exec-run on the second interpreter

	This is the output I get on the first interpreter:

	    =thread-group-added,id="i1"
	    ~"Reading symbols from a.out...\n"
	    ~"New UI allocated\n"
	    (gdb)
	    =thread-group-started,id="i1",pid="94718"
	    =thread-created,id="1",group-id="i1"
	    ^running
	    *running,thread-id="all"

	And this is the output I get on the second intepreter:

	    =thread-group-added,id="i1"
	    (gdb)
	    -exec-run
	    =thread-group-started,id="i1",pid="94718"
	    =thread-created,id="1",group-id="i1"
	    *running,thread-id="all"

	The problem here is that the `^running` reply to the -exec-run command
	is printed on the wrong UI.  It is printed on the first one, it should
	be printed on the second (the one on which we sent the -exec-run).

	What happens under the hood is that captured_mi_execute_command, while
	executing a command for the second intepreter, clears the
	running_result_record_printed and mi_proceeded globals.
	mi_about_to_proceed then sets mi_proceeded.  Then, mi_on_resume_1 gets
	called for the first intepreter first.  Since the

	    !running_result_record_printed && mi_proceeded

	condition is true, it prints a ^running, and sets
	running_result_record_printed.  When mi_on_resume_1 gets called for the
	second interpreter, running_result_record_printed is already set, so
	^running is not printed there.

	It took me a while to understand the relationship between these two
	variables.  I think that in the end, this is what we want to track:

	 1. When executing an MI command, take note if that command causes a
	    "proceed".  This is done in mi_about_to_proceed.
	 2. In mi_on_resume_1, if the command indeed caused a "proceed", we want
	    to output a ^running record.  And we want to remember that we did,
	    because...
	 3. Back in captured_mi_execute_command, if we did not output a
	    ^running, we want to output a ^done.

	Moving those two variables to the mi_interp struture appears to fix it.
	Only for the interpreter doing the -exec-run command does the
	running_result_record_printed flag get cleared, and therefore only or
	that one does the ^running record get printed.

	Add a new test for this, that does pretty much what the reproducer above
	shows.  Without the fix, the test fails because
	mi_send_resuming_command_raw never sees the ^running record.

	Change-Id: I63ea30e6cb61a8e1dd5ef03377e6003381a9209b
	Tested-By: Alexandra Petlanova Hajkova <ahajkova@redhat.com>

2023-05-29  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-05-28  Tom de Vries  <tdevries@suse.de>

	[readline] Fix double free in _rl_scxt_dispose
	Consider the following scenario.  We start gdb in TUI mode:
	...
	$ gdb -q -tui
	...
	and type ^R which gives us the reverse-isearch prompt in the cmd window:
	...
	(reverse-i-search)`':
	...
	and then type "foo", right-arrow-key, and ^C.

	In TUI mode, gdb uses a custom rl_getc_function tui_getc.

	When pressing the right-arrow-key, tui_getc:
	- attempts to scroll the TUI src window, without any effect, and
	- returns 0.

	The intention of returning 0 is mentioned here in tui_dispatch_ctrl_char:
	...
	  /* We intercepted the control character, so return 0 (which readline
	     will interpret as a no-op).  */
	  return 0;
	...

	However, after this 0 is returned by the rl_read_key () call in
	_rl_search_getchar, _rl_read_mbstring is called, which incorrectly interprets
	0 as the first part of an utf-8 multibyte char, and tries to read the next
	char.

	In this state, the ^C takes effect and we run into a double free because
	_rl_isearch_cleanup is called twice.

	Both these issues need fixing independently, though after fixing the first we
	no longer trigger the second.

	The first issue is caused by the subtle difference between:
	- a char array containing 0 chars, which is zero-terminated, and
	- a char array containing 1 char, which is zero.

	In mbrtowc terms, this is the difference between:
	...
	  mbrtowc (&wc, "", 0, &ps);
	...
	which returns -2, and:
	...
	  mbrtowc (&wc, "", 1, &ps);
	...
	which returns 0.

	Note that _rl_read_mbstring calls _rl_get_char_len without passing it an
	explicit length parameter, and consequently it cannot distinguish between the
	two, and defaults to the "0 chars" choice.

	Note that the same problem doesn't exist in _rl_read_mbchar.

	Fix this by defaulting to the "1 char" choice in _rl_get_char_len:
	...
	-  if (_rl_utf8locale && l > 0 && UTF8_SINGLEBYTE(*src))
	+  if (_rl_utf8locale && l >= 0 && UTF8_SINGLEBYTE(*src))
	...

	The second problem happens when the call to _rl_search_getchar in
	_rl_isearch_callback returns.  At that point _rl_isearch_cleanup has already
	been called from the signal handler, but we proceed regardless, using a cxt
	pointer that has been freed.

	Fix this by checking for "RL_ISSTATE (RL_STATE_ISEARCH)" after the call to
	_rl_search_getchar:
	...
	   c = _rl_search_getchar (cxt);
	+  if (!RL_ISSTATE (RL_STATE_ISEARCH))
	+    return 1;
	...

	Tested on x86_64-linux.

	Approved-By: Chet Ramey <chet.ramey@case.edu>

	PR tui/30056
	Bug: https://sourceware.org/bugzilla/show_bug.cgi?id=30056

2023-05-28  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-05-27  Nelson Chu  <nelson@nelson.ba.rivosinc.com>

	[PR ld/22263][PR ld/25694] RISC-V: Avoid dynamic TLS relocs in PIE.
	Lots of targets already fixed the TEXTREL problem for TLS in PIE.

	* For PR ld/25694,
	In the check_reloc, refer to spare and loongarch, they don't need to reserve
	any local dynamic reloc for TLS LE in pie/pde, and similar to other targets.
	So it seems like riscv was too conservative to estimate the TLS LE before.
	Just break and don't goto static_reloc for TLS LE in pie/pde can fix the
	TEXTREL problem.

	* For PR ld/22263,
	The risc-v code for TLS GD/IE in the relocate_section seems same as MIPS port.
	So similar to MIPS, pr22570, commits 9143e72c6d4d and 1cb83cac9a89, it seems
	also the right way to do the same thing for risc-v.

	On risc-v, fixes
	FAIL: Build pr22263-1

	RISC-V haven't supported the TLS transitions, so will need the same fix (use
	bfd_link_dll) in the future.

	bfd/
		PR ld/22263
		PR ld/25694
		* elfnn-riscv.c (riscv_elf_check_relocs): Replace bfd_link_pic with
		bfd_link_dll for TLS IE.  Don't need to reserve the local dynamic
		relocation for TLS LE in pie/pde, and report error in pic just like
		before.
		(riscv_elf_relocate_section): For TLS GD/IE, use bfd_link_dll rather
		than !bfd_link_pic in determining the dynamic symbol index.  Avoid
		the index of -1.

2023-05-27  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-05-26  Nick Clifton  <nickc@redhat.com>

	Enhance objdump's --private option so that it can display the contents of PE format files.
	  * od-pe.c: New file: Dumps fields in PE format headers.
	  * configure.ac (od_vectors): Add objdump_private_desc_pe for PE format targets. (od_files): Add od-pe for PE format targets.
	  * configure: Regenerate.
	  * Makefile.am (CFILES): Add od-pe.c (EXTRA_objdump_SOURCE): Likewise.
	  * Makefile.in: Generate.
	  * NEWS: Mention the new feature.
	  * doc/binutils.texi: Document the new support.
	  * objdump.c (wide_output): Change from local to global.
	  * objdump.h (wide_output): Prototype. (objdump_private_desc_pe): Prototype.
	  * testsuite/binutils-all/objdump.exp: Add a test of the new feature.

2023-05-26  Andreas Schwab  <schwab@linux-m68k.org>

	Remove duplicate definition
		* coff/pe.h (IMAGE_FILE_MACHINE_AMD64): Remove duplicate
		definition.  Alphabetize.

2023-05-26  Jan Beulich  <jbeulich@suse.com>

	x86: fix disassembler build after 1a3b4f90bc5f
	In commit 1a3b4f90bc5f ("x86: convert two pointers to (indexing)
	integers") I neglected the fact that compilers may warn about comparing
	ptrdiff_t (signed long) with size_t (unsigned long) values. Since just
	before we've checked that the value is positive, simply add a cast
	(despite my dislike for casts).

2023-05-26  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Add test-case gdb.tui/color-prompt.exp
	Add a test-case that sets a prompt with color in TUI.

	The line containing the prompt is shown by get_line_with_attrs as follows:
	...
	<fg:31>(gdb) <fg:default>
	...

	The 31 means red, but only for foreground colors, for background colors 41
	means red.

	Make this more readable by using color names for both foreground and
	background, such that we have instead:
	....
	<fg:red>(gdb) <fg:default>
	...

	Tested on x86_64-linux.

2023-05-26  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Add invisible and blinking attributes in tuiterm
	I noticed curses using the invisible and blinking attributes.

	Add these in tuiterm.

	Tested on x86_64-linux.

2023-05-26  Tom de Vries  <tdevries@suse.de>

	[gdb/testsuite] Fix reverse attribute in tuiterm
	I noticed in proc Term::_csi_m arguments that while parameters 7 and 27 are
	supposed to set the reverse attribute to 1 and 0, in fact it's set to 1 in
	both cases:
	...
	 		    7 {
				set _attrs(reverse) 1
			    }
	  ...
			    27 {
				set _attrs(reverse) 1
	 		    }
	...

	Fix this and add a regression test in gdb.tui/tuiterm.exp.

	Tested on x86_64-linux.

2023-05-26  Jan Beulich  <jbeulich@suse.com>

	iamcu: suppress tests which can't possibly work
	With neither --32 nor --64 passed to gas, advanced features like AVX
	aren't available without explicitly enabling them.

	x86-64: improve gas diagnostic when no 32-bit target is configured
	Make this similar to --64 and --x32: Check whether a suitable target
	exists.

	x86-64: conditionalize tests using --32
	Using this option doesn't really work when no support for any 32-bit
	target was configured in (as is the case for at least cloudabi and
	rdos).

	x86: split gas testsuite .exp file
	The set of 32-bit-only and 64-bit-only tests has grown quite large. In
	particular when one's after only the results for the 64-bit set, having
	them live in a separate .exp file is easier / faster.

	x86: convert two pointers to (indexing) integers
	This in particular reduces the number of pointers to non-const that we
	have (and that could potentially be used for undue modification of
	state). As a result, fetch_code()'s 2nd parameter can then also become
	pointer-to-const.

2023-05-26  Jan Beulich  <jbeulich@suse.com>

	x86: disassembling over-long insns
	The present way of dealing with them - misusing MAX_MNEM_SIZE, which has
	nothing to do with insn length - leads to inconsistent results. Since we
	allow for up to MAX_CODE_LENGTH - 1 prefix bytes (which then could be
	followed by another MAX_CODE_LENGTH "normal" insn bytes until we're done
	decoding), size the_buffer[] accordingly.

	Move struct dis_private down to be able to use MAX_CODE_LENGTH without
	moving its #define. While doing this also alter the order to have the
	potentially large array last.

2023-05-26  Jan Beulich  <jbeulich@suse.com>

	x86: use fixed-width type for codep and friends
	This first of all removes a dependency on bfd_byte and unsigned char
	being the same types. It further eliminates the need to mask by 0xff
	when fetching values (which wasn't done fully consistently anyway),
	improving code legibility.

	While there, where possible add const.

2023-05-26  Jan Beulich  <jbeulich@suse.com>

	x86: figure braces aren't really part of mnemonics
	Instead they're separators for pseudo-prefixes. Don't insert them in
	mnemonic_chars[], handling them explicitly in parse_insn() instead. Note
	that this eliminates the need for another separator after a pseudo-
	prefix. While maybe not overly interesting for a following real
	mnemonic, I view this as quite desirable between multiple successive
	pseudo-prefixes (bringing things in line with the other use of figure
	braces in AVX512's zeroing-masking).

	Drop the unused is_mnemonic_char() at this occasion.

2023-05-26  Jan Beulich  <jbeulich@suse.com>

	x86: de-duplicate operand_special_chars[] wrt extra_symbol_chars[]
	Having to add characters to both arrays can easily lead to oversights.
	Consuming extra_symbol_chars[] when populating operand_chars[] also
	allows to drop two special cases in md_begin().

	Constify operand_special_chars[] at this occasion.

2023-05-26  Indu Bhagat  <indu.bhagat@oracle.com>

	sframe/doc: minor improvements for readability
	libsframe/
		* sframe-spec.texi: Cosmetic fixes.

2023-05-26  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: revisit sframe_find_fre API
	Inspite of implementing a rather simple functionality, this function was
	relatively difficult to follow, and maintain.  Some changes are done now
	to address that - refactor the function and use better names to make it
	more readable.

	The changes to the implementation do not cause any change in the
	contract of the API.

	libsframe/
	        * sframe.c (sframe_fre_get_end_ip_offset): to here...
	        (sframe_find_fre): Refactor some bits from...

2023-05-26  Indu Bhagat  <indu.bhagat@oracle.com>

	libsframe: use const char * consistently for immutable FRE buffers
	libsframe/
	        * sframe.c (sframe_decode_fre): Use const char * datatype when
		handling buffer containing the FREs.
		(sframe_fre_get_end_ip_offset): Likewise.
		(sframe_find_fre): Likewise.
		(sframe_decoder_get_fre): Likewise.

	libsframe: use uint8_t data type for FRE info related stubs
	libsframe/
		* sframe.c: Use uint8_t for FRE offset count and FRE offset
		size.  Use uint8_t for FRE info word as well.

2023-05-26  Alan Modra  <amodra@gmail.com>

	PR22263 ld test
	A number of targets that I test regularly fail the "Build pr22263-1"
	test for various reasons.

	arm-linux-gnueabi: "undefined reference to `__aeabi_read_tp'"
	ia64-linux-gnu: "Explicit stops are ignored in auto mode"
	m68k-linux-gnu: "undefined reference to `__m68k_read_tp'"
	microblaze-linux-gnu: "undefined reference to `__tls_get_addr'"
	nios2-linux-gnu, s390-linux-gnu and sh4-linux-gnu have a tprel reloc in .got
	riscv64-linux-gnu has a dynamic relocation in text

	So only riscv really fails the pr.  The rest fail due to test issues
	or lack of a linker optimisation.  Lack of an optimisation isn't
	really a fail, but it's worth keeping the test to ensure those
	optimisations don't regress.  The xfail targets may not be an
	exhaustive list.  This just tidies test results for those for which I
	have cross compilers installed.

		PR 22263
		* testsuite/ld-elf/tls.exp: Split pr22263 test into two parts,
		one to check for -z text errors, the other to check tprel
		linker optimisation.  Supply needed symbols and assembler flags.
		xfail the linker optimisation on targets known to fail.

2023-05-26  Tom Tromey  <tom@tromey.com>

	Make MI commands const-correct
	I've had this patch for a while now and figured I'd update it and send
	it.  It changes MI commands to use a "const char * const" for their
	argv parameter.

	Regression tested on x86-64 Fedora 36.

	Acked-By: Simon Marchi <simon.marchi@efficios.com>

2023-05-26  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-05-25  Ciaran Woodward  <ciaranwoodward@xmos.com>

	Fix scoped_value_mark not working with empty value chain
	The scoped_value_mark helper class was setting its internal
	mark value to NULL to indicate that the value chain had already
	been freed to mark.

	However, value_mark() also returns NULL if the value chain is
	empty at the time of call.

	This lead to the situation that if the value chain was empty
	at the time the scoped_value_mark was created, the class
	would not correctly clean up the state when it was destroyed,
	because it believed it had already been freed.

	I noticed this because I was setting a watchpoint very early
	in my debug session, and it was becoming a software watchpoint
	rather than hardware. Running any command that called evaluate()
	beforehand (such as 'x 0') would mean that a hardware watchpoint
	was correctly used. After some careful examination of the
	differences in execution, I noticed that values were being freed
	later in the 'bad case', which lead me to notice the issue with
	scoped_value_mark.

2023-05-25  Simon Marchi  <simon.marchi@efficios.com>

	gdb: remove breakpoint_pointer_iterator
	Remove the breakpoint_pointer_iterator layer.  Adjust all users of
	all_breakpoints and all_tracepoints to use references instead of
	pointers.

	Change-Id: I376826f812117cee1e6b199c384a10376973af5d
	Reviewed-By: Andrew Burgess <aburgess@redhat.com>

2023-05-25  Simon Marchi  <simon.marchi@efficios.com>

	gdbsupport: make filtered_iterator::operator* return the same thing as underlying iterator
	This is the same idea as the previous patch, but for filtered_iterator.
	Without this patch, I would see this when applying the patch that
	removes reference_to_pointer_iterator from breakpoint_range:

	      CXX    breakpoint.o
	    /home/smarchi/src/binutils-gdb/gdb/breakpoint.c: In function ‘void download_tracepoint_locations()’:
	    /home/smarchi/src/binutils-gdb/gdb/breakpoint.c:11007:41: error: cannot allocate an object of abstract type ‘breakpoint’
	    11007 |   for (breakpoint &b : all_tracepoints ())
	          |                                         ^
	    In file included from /home/smarchi/src/binutils-gdb/gdb/gdbthread.h:26,
	                     from /home/smarchi/src/binutils-gdb/gdb/infrun.h:21,
	                     from /home/smarchi/src/binutils-gdb/gdb/gdbarch.h:28,
	                     from /home/smarchi/src/binutils-gdb/gdb/arch-utils.h:23,
	                     from /home/smarchi/src/binutils-gdb/gdb/breakpoint.c:21:
	    /home/smarchi/src/binutils-gdb/gdb/breakpoint.h:619:8: note:   because the following virtual functions are pure within ‘breakpoint’:
	      619 | struct breakpoint : public intrusive_list_node<breakpoint>
	          |        ^~~~~~~~~~
	    /home/smarchi/src/binutils-gdb/gdb/breakpoint.c:250:1: note:     ‘virtual breakpoint::~breakpoint()’
	      250 | breakpoint::~breakpoint ()
	          | ^~~~~~~~~~

	Change-Id: I05285ff27d21cb0ab80cba392ec4e959167e3cd7
	Reviewed-By: Andrew Burgess <aburgess@redhat.com>

2023-05-25  Simon Marchi  <simon.marchi@efficios.com>

	gdbsupport: make basic_safe_iterator::operator* return the same thing as underlying iterator
	Using the following patch that removes the reference_to_pointer_iterator
	from breakpoint_range, I would get:

	      CXX    breakpoint.o
	    /home/smarchi/src/binutils-gdb/gdb/breakpoint.c: In function ‘void breakpoint_program_space_exit(program_space*)’:
	    /home/smarchi/src/binutils-gdb/gdb/breakpoint.c:3030:46: error: cannot allocate an object of abstract type ‘breakpoint’
	     3030 |   for (breakpoint &b : all_breakpoints_safe ())
	          |                                              ^
	    In file included from /home/smarchi/src/binutils-gdb/gdb/gdbthread.h:26,
	                     from /home/smarchi/src/binutils-gdb/gdb/infrun.h:21,
	                     from /home/smarchi/src/binutils-gdb/gdb/gdbarch.h:28,
	                     from /home/smarchi/src/binutils-gdb/gdb/arch-utils.h:23,
	                     from /home/smarchi/src/binutils-gdb/gdb/breakpoint.c:21:
	    /home/smarchi/src/binutils-gdb/gdb/breakpoint.h:619:8: note:   because the following virtual functions are pure within ‘breakpoint’:
	      619 | struct breakpoint : public intrusive_list_node<breakpoint>
	          |        ^~~~~~~~~~
	    /home/smarchi/src/binutils-gdb/gdb/breakpoint.c:250:1: note:     ‘virtual breakpoint::~breakpoint()’
	      250 | breakpoint::~breakpoint ()
	          | ^~~~~~~~~~

	This is because the operator* method of the basic_safe_iterator iterator
	wrapper returns a value_type.  So, even if the method of the underlying
	iterator (breakpoint_iterator, an intrusive_list iterator) returns a
	`breakpoint &`, the method of the wrapper returns a `breakpoint`.

	I think it would make sense for iterator wrappers such as
	basic_safe_iterator to return the exact same thing as the iterator they
	wrap.  At least, it fixes my problem.

	Change-Id: Ibbcd390ac03d2fb6ae4854923750c8d7c3c04e8a
	Reviewed-By: Andrew Burgess <aburgess@redhat.com>

2023-05-25  Simon Marchi  <simon.marchi@efficios.com>

	gdb: link breakpoints with intrusive_list
	Change-Id: I043d8d6f3dd864d80d5088f6ffc2c098337249ea
	Reviewed-By: Andrew Burgess <aburgess@redhat.com>

2023-05-25  Simon Marchi  <simon.marchi@efficios.com>

	gdb: remove bp_location_pointer_iterator
	Remove the bp_location_pointer_iterator layer.  Adjust all users of
	breakpoint::locations to use references instead of pointers.

	Change-Id: Iceed34f5e0f5790a9cf44736aa658be6d1ba1afa
	Reviewed-By: Andrew Burgess <aburgess@redhat.com>

2023-05-25  Simon Marchi  <simon.marchi@efficios.com>

	gdb: use intrusive_list for breakpoint locations
	Replace the hand-maintained linked lists of breakpoint locations with
	and intrusive list.

	 - Remove breakpoint::loc, add breakpoint::m_locations.

	 - Add methods for the various manipulations that need to be done on the
	   location list, while maintaining reasonably good encapsulation.

	 - bp_location currently has a default constructor because of one use
	   in hoist_existing_locations.  hoist_existing_locations now returns a
	   bp_location_list, and doesn't need the default-constructor
	   bp_location anymore, so remove the bp_location default constructor.

	 - I needed to add a call to clear_locations in delete_breakpoint to
	   avoid a use-after-free.

	 - Add a breakpoint::last_loc method, for use in
	   set_breakpoint_condition.

	bp_location_range uses reference_to_pointer_iterator, so that all
	existing callers of breakpoint::locations don't need to change right
	now.  It will be removed in the next patch.

	The rest of the changes are to adapt the call sites to use the new
	methods, of breakpoint::locations, rather than breakpoint::loc directly.

	Change-Id: I25f7ee3d66a4e914a0540589ac414b3b820b6e70
	Reviewed-By: Andrew Burgess <aburgess@redhat.com>

2023-05-25  Simon Marchi  <simon.marchi@efficios.com>

	gdbsupport: add missing increment/decrement operators to reference_to_pointer_iterator
	Using the following patch, I would get this build failure:

	      CXX    breakpoint.o
	    In file included from /usr/include/c++/13.1.1/bits/stl_algobase.h:66,
	                     from /usr/include/c++/13.1.1/bits/hashtable_policy.h:36,
	                     from /usr/include/c++/13.1.1/bits/hashtable.h:35,
	                     from /usr/include/c++/13.1.1/bits/unordered_map.h:33,
	                     from /usr/include/c++/13.1.1/unordered_map:41,
	                     from /usr/include/c++/13.1.1/functional:63,
	                     from /home/smarchi/src/binutils-gdb/gdb/../gdbsupport/ptid.h:35,
	                     from /home/smarchi/src/binutils-gdb/gdb/../gdbsupport/common-defs.h:206,
	                     from /home/smarchi/src/binutils-gdb/gdb/defs.h:26,
	                     from /home/smarchi/src/binutils-gdb/gdb/breakpoint.c:20:
	    /usr/include/c++/13.1.1/bits/stl_iterator_base_funcs.h: In instantiation of ‘constexpr void std::__advance(_BidirectionalIterator&, _Distance, bidirectional_iterator_tag) [with _BidirectionalIterator = reference_to_pointer_iterator<intrusive_list_iterator<bp_location, intrusive_base_node<bp_location> > >; _Distance = long int]’:
	    /usr/include/c++/13.1.1/bits/stl_iterator_base_funcs.h:224:21:   required from ‘constexpr void std::advance(_InputIterator&, _Distance) [with _InputIterator = reference_to_pointer_iterator<intrusive_list_iterator<bp_location, intrusive_base_node<bp_location> > >; _Distance = long int]’
	    /usr/include/c++/13.1.1/bits/stl_iterator_base_funcs.h:237:19:   required from ‘constexpr _InputIterator std::next(_InputIterator, typename iterator_traits<_Iter>::difference_type) [with _InputIterator = reference_to_pointer_iterator<intrusive_list_iterator<bp_location, intrusive_base_node<bp_location> > >; typename iterator_traits<_Iter>::difference_type = long int]’
	    /home/smarchi/src/binutils-gdb/gdb/breakpoint.c:1073:19:   required from here
	    /usr/include/c++/13.1.1/bits/stl_iterator_base_funcs.h:179:11: error: no match for ‘operator--’ (operand type is ‘reference_to_pointer_iterator<intrusive_list_iterator<bp_location, intrusive_base_node<bp_location> > >’)
	      179 |           --__i;
	          |           ^~~~~

	This points out that while intrusive_list_iterator has an operator--,
	the reference_to_pointer_iterator wrapper does not.  I'm not to sure why
	the compiler chooses the overload of __advance that accepts a
	_BidirectionalIterator, given that reference_to_pointer_iterator can't
	be decremented, but adding those operators seems like the right thing to
	do in any case, for completeness.

	Change-Id: I8e2044b6734fadf0f21093047cf35bb7080dbdc3
	Reviewed-By: Andrew Burgess <aburgess@redhat.com>

2023-05-25  Simon Marchi  <simon.marchi@efficios.com>

	gdb: add breakpoint::first_loc methods
	Add convenience first_loc methods to struct breakpoint (const and
	non-const overloads).  A subsequent patch changes the list of locations
	to be an intrusive_list and makes the actual list private, so these
	spots would need to change from:

	    b->loc

	to something ugly like:

	    *b->locations ().begin ()

	That would make the code much heavier and not readable.  There is a
	surprisingly big number of places that access the first location of
	breakpoints.  Whether this is correct, or these spots fail to consider
	the possibility of multi-location breakpoints, I don't know.  But
	anyhow, I think that using this instead:

	 b->first_loc ()

	conveys the intention better than the other two forms.

	Change-Id: Ibbefe3e4ca6cdfe570351fe7e2725f2ce11d1e95
	Reviewed-By: Andrew Burgess <aburgess@redhat.com>

2023-05-25  Simon Marchi  <simon.marchi@efficios.com>

	gdb: add breakpoint "has locations" methods
	Add three convenience methods to struct breakpoint:

	 - has_locations: returns true if the breakpoint has at least one
	   location
	 - has_single_location: returns true if the breakpoint has exactly one
	   location
	 - has_multiple_locations: returns true if the breakpoint has more than
	   one location

	A subsequent patch changes the list of breakpoints to be an
	intrusive_list, so all these spots would need to change.  But in any
	case, I think that this:

	  if (b->has_multiple_locations ())

	conveys the intention better than:

	  if (b->loc != nullptr && b->loc->next != nullptr)

	Change-Id: Ib18c3605fd35d425ef9df82cb7aacff1606c6747
	Reviewed-By: Andrew Burgess <aburgess@redhat.com>

2023-05-25  Simon Marchi  <simon.marchi@efficios.com>

	gdb: constify breakpoint::print_it parameter
	The print_it method itself is const.  In a subsequent patch, the
	locations that come out of a const breakpoint will be const as well.  It
	will therefore be needed to make the last_loc output parameter const as
	well.  Make that change now to reduce the size of the following patches.

	Change-Id: I7ed962950bc9582646e31e2e42beca2a1c9c5105
	Reviewed-By: Andrew Burgess <aburgess@redhat.com>

2023-05-25  Simon Marchi  <simon.marchi@efficios.com>

	gdb: make some breakpoint methods use `this`
	Some implementations of breakpoint::check_status and
	breakpoint::print_it do this:

	    struct breakpoint *b = bs->breakpoint_at;

	bs->breakpoint_at is always the same as `this` (we can get convinced by
	looking at the call sites of check_status and print_it), so it would
	just be clearer to access fields through `this` instead.

	Change-Id: Ic542a64fcd88e31ae2aad6feff1da278c7086891
	Reviewed-By: Alexandra Petlanova Hajkova <ahajkova@redhat.com>
	Reviewed-By: Andrew Burgess <aburgess@redhat.com>

2023-05-25  Simon Marchi  <simon.marchi@efficios.com>

	gdb: get gdbarch from syscall_catchpoint instead of location
	I noticed some methods of syscall_catchpoint doing this:

	  struct gdbarch *gdbarch = loc->owner->gdbarch;

	`loc` is the list of locations of this catchpoint.  Logically, the owner
	the locations are this catchpoint.  So this just ends up getting
	this->gdbarch.  Remove the unnecessary indirection through the loc.

	syscall_catchpoint::print_recreate does something slightly different,
	getting its arch from the loc:

	  struct gdbarch *gdbarch = loc->gdbarch;

	I suppose it's always going to be the same arch, so get it from the
	catchpoint there too.

	Change-Id: I6f6a6f8e0cd7cfb754cecfb6249e71ec12ba4855
	Reviewed-By: Alexandra Petlanova Hajkova <ahajkova@redhat.com>
	Reviewed-By: Andrew Burgess <aburgess@redhat.com>

2023-05-25  Alan Modra  <amodra@gmail.com>

	PR29189, dlltool delaylibs corrupt float/double arguments
		PR 29189
		* dlltool.c (i386_x64_trampoline): Save and restore xmm0-5.  Make
		use of parameter save area for integer arg regs.  Comment.

2023-05-25  GDB Administrator  <gdbadmin@sourceware.org>

	Automatic date update in version.in

2023-05-24  Simon Marchi  <simon.marchi@efficios.com>

	gdbsupport: add support for references to checked_static_cast
	Add a checked_static_cast overload that works with references.  A bad
	dynamic cast with references throws std::bad_cast, it would be possible
	to implement the new overload based on that, but it seemed simpler to
	just piggy back off the existing function.

	I found some potential uses of this new overload in amd-dbgapi-target.c,
	update them to illustrate the use of the new overload.  To build
	amd-dbgapi-target.c, on needs the amd-dbgapi library, which I don't
	expect many people to have.  But I have it, and it builds fine here.  I
	did test the new overload by making a purposely bad cast and it did
	catch it.

	Change-Id: Id6b6a7db09fe3b4aa43cddb60575ff5f46761e96
